checkRequire("Lua_HeChengEquipSelectedItem");
Lua_AmuletNecklacePanel = class("Lua_AmuletNecklacePanel", Lua_DisplayObject);
function Lua_AmuletNecklacePanel:ctor(p)
	self:superCall("ctor", p, "AmuletNecklacePanel_skin");
end

function Lua_AmuletNecklacePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rateLbl.text = ""

	self.desLbl:setEnable(false);
	self.desLbl1:setEnable(false);

	self.desLblArr = Array();
	self.desLblArr:add(self.desLbl2);
	self.desLblArr:add(self.desLbl3);
	self.desLblArr:add(self.desLbl4);
	self.desLblArr:add(self.desLbl5);
	self.desLblArr:add(self.desLbl6);
	for i = 1, self.desLblArr:getSize() do
		self.desLblArr[i]:addClickFuntion(self, self.onPutMainEquip)
	end

	self.duanzaoBgArr = Array();
	self.duanzaoBgArr:add(self.duanzao2);
	self.duanzaoBgArr:add(self.duanzao3);
	self.duanzaoBgArr:add(self.duanzao4);
	self.duanzaoBgArr:add(self.duanzao5);
	self.duanzaoBgArr:add(self.duanzao6);

	self.equip_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 768, 410));
	self.equip_DragList:setListCell(Lua_HeChengEquipSelectedItem, 118, 256, 3);
	self.equip_DragList:setLocation(112, -63, 0);
	self.equip_DragList:setEnable(false);

	self.composeList = Lua_AmuletNecklaceUtil:getComposeList()
	self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, 0, 268, 525),
		Vector3(268, 65, 0), Vector3(244, 46, 0), Vector2(0, 0), Vector3(0, 16));
	self.btnList:setDepth(5);
	self.btnList:setMainBtnStyle("common_atlas_1", "ui_common_btn_p2", "ui_common_btn_p1", "D5DADE", "FFFFFF", 28);
	self.btnList:setSubBtnStyle("common_atlas_1", "ui_common_btn_p4", "ui_common_btn_p3", "92A0DA", "FFFCB7", 26);
	self.btnList:setLocation(-460, -70, 0);
	self.btnList:setData(self.composeList, self, self.onSubClick, 0, 230); -- (525 - 65) / 2
	self.btnList:setMainSlected(1);

	self.tipsIcon:addClickFuntion(self, self.onHelpClick);
	self.ronglianBtn:addClickFuntion(self, self.onHeChengClick);
	self.yijianBtn:addClickFuntion(self, self.onOncePutClick);

	self:addLuaEvent("onEquipItemClick", self, self.onEquipSelecteCellClick);
	self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent);
	self:addLuaEvent("PUT_INTO_EQUIP", self, self.onPutIntoEquip);
	self:addLuaEvent("REMOVE_EQUIP", self, self.onRemoveEquip);
	self:addLuaEvent("FORGING_PLAY_FAILED", self, self.onFailedEvent);

	self:setRedDot();
	self:infoShowState(true);
end

function Lua_AmuletNecklacePanel:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(120594));
end

function Lua_AmuletNecklacePanel:infoShowState(state)
	self.equip_DragList:setEnable(state)
	self.dragListObj:SetActive(state);
	self.heChengObj:SetActive(not state);
end

function Lua_AmuletNecklacePanel:onEquipSelecteCellClick(data)
	self:infoShowState(false)
	self:onEquipChange(data)
end

function Lua_AmuletNecklacePanel:updataState(state)
	self.suo5:setEnable(state);
	self.suo6:setEnable(state);
	self.desLbl2:setEnable(state);
	self.desLbl3:setEnable(state);
	self.desLbl4:setEnable(state);
	self.suo2:setEnable(not state);
	self.suo3:setEnable(not state);
	self.suo4:setEnable(not state);
	self.desLbl5:setEnable(not state);
	self.desLbl6:setEnable(not state);
end

function Lua_AmuletNecklacePanel:setRedDot()
	self.numDic = DataCenter.equData.neckNumDic;
	self.subDic = DataCenter.equData.neckSubDic;
	self.btnList:setRedDot(1, self.numDic);
	self:updateSubRedDot();
end

function Lua_AmuletNecklacePanel:updateSubRedDot()
	if self.selectedData == nil then
		return;
	end

	if self.subDic ~= nil and self.subDic[self.selectedData.mainIndex] ~= nil then
		local openDic = self.subDic[self.selectedData.mainIndex];
		self.btnList:setRedDot(2, openDic);
	else
		self.btnList:setRedDot(2, {});
	end
end

function Lua_AmuletNecklacePanel:onEquipChange(value)
	self:updataState(true);

	self.curEquipData = value;

	if value == nil then
		return;
	end

	if self.equipImg ~= nil then
		self.equipImg:dispose();
		self.equipImg = nil
	end

	if self.equipImg == nil then
		self.equipImg = Lua_ToolImage.new(self.infoBg.mainContent);
		self.equipImg:setDepth(15);
		self.equipImg:setLocation(0, 0, 0);
	end

	local equipImgVo = Lua_ToolVo.new(value.output, 0, 0);
	equipImgVo.star = value.star;
	self.equipImg.data = equipImgVo;

	if self.stateArr ~= nil then
		self.stateArr:clear();
	else
		self.stateArr = Array();
	end

	if self.imgArr ~= nil then
		self.imgArr:dispose();
		self.imgArr:clear();
	else
		self.imgArr = Array();
	end

	if self.pkg_indexArr ~= nil then
		self.pkg_indexArr:clear();
	else
		self.pkg_indexArr = Array();
	end

	self.equArr = Array();
	for i = 1, #self.curEquipData.materialsArr.equip do
		self.stateArr:add(0);
		self.equArr:add(self.curEquipData.materialsArr.equip[i]);
	end

	if self.equArr:getSize() == 4 then
		self.suo5:setEnable(false);
		self.desLbl5:setEnable(true);
	elseif self.equArr:getSize() == 5 then
		self.suo5:setEnable(false);
		self.desLbl5:setEnable(true);
		self.suo6:setEnable(false);
		self.desLbl6:setEnable(true);
	end
	self.need_amount = self.equArr:getSize();
	self:updateRate();
end

function Lua_AmuletNecklacePanel:onPutMainEquip(go)
	local equipList = DataCenter.equData:getComposeEquArr(self.curEquipData.materialsArr.equip[1]);
	local costEquType = tonumber(string.sub(go.name, -1, -1)) - 1;

	local mainEqu = Array();
	mainEqu:add(equipList);
	mainEqu:add(costEquType);
	Lua_WindowUtil.openWin("Lua_ComposeTiHuanEquipWindow", WinParam.ACTION_AUTO, mainEqu);
end

function Lua_AmuletNecklacePanel:onPutIntoEquip(data)
	if data == nil then
		return;
	end

	self.desLblArr[data.costEquType]:setEnable(false);
	self.stateArr[data.costEquType] = 1;

	self.mtImg = Lua_ToolImage.new(self.duanzaoBgArr[data.costEquType].mainContent);
	self.mtImg:setDepth(15);
	self.mtImg:setLocation(0, 0, 0);
	self.mtImg:showNum(0, true);
	self.mtImg:showCloseSp(true, true, "REMOVE_EQUIP", "Lua_ForgingWindow", Vector3(30, 30));
	self.mtImg.data = data;
	self.imgArr:add(self.mtImg);

	self.pkg_indexArr:add({index = self.mtImg.data.index, bind = self.mtImg.data.bind, costEquType = data.costEquType});

	local mater = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsBySubType( { Lua_PackTypeDefine.EQUIP });
	if mater ~= nil and mater:getSize() ~= 0 then
		for i = 1, mater:getSize() do
			if mater[i].index == self.mtImg.data.index then
				mater[i].isPut = true;
				break;
			end
		end
	end
	self:updateRate();
end

function Lua_AmuletNecklacePanel:onRemoveEquip(data)
	self.desLblArr[data.costEquType]:setEnable(true);
	self.stateArr[data.costEquType] = 0;

	local mater = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsBySubType({Lua_PackTypeDefine.EQUIP});
	if mater ~= nil and mater:getSize() ~= 0 then
		for i = 1, mater:getSize() do
			if mater[i].index == data.index then
				mater[i].isPut = false;
				break;
			end
		end
	end

	for i = 1, self.imgArr:getSize() do
		if self.imgArr[i].data.index == data.index then
			self.imgArr[i]:dispose();
			self.imgArr:remove(i);
			break;
		end
	end

	for i = 1, self.pkg_indexArr:getSize() do
		if self.pkg_indexArr[i].index == data.index then
			self.pkg_indexArr:remove(i);
			break;
		end
	end
	self:updateRate();
end


function Lua_AmuletNecklacePanel:updateRate()
	local cur_amount = self.pkg_indexArr:getSize();
	if cur_amount < 3 then
		self.rateLbl.text = LanUtil.getValue(120549);
	elseif cur_amount == self.need_amount then
		self.rateLbl.text = LanUtil.formateStr(LanUtil.getValue(110582), tostring(self.curEquipData.rateArr[1]));
	elseif self.need_amount == 5 and cur_amount == 3 then
		self.rateLbl.text = LanUtil.formateStr(LanUtil.getValue(110582), tostring(self.curEquipData.rateArr[3]));
	else
		self.rateLbl.text = LanUtil.formateStr(LanUtil.getValue(110582), tostring(self.curEquipData.rateArr[2]));
	end
end

function Lua_AmuletNecklacePanel:onHeChengClick()
	local cur_amount = self.pkg_indexArr:getSize();
	local isHas_bindItem = false;
	for i = 1, self.pkg_indexArr:getSize() do
		if self.pkg_indexArr[i].bind == 1 then
			isHas_bindItem = true;
			break;
		end
	end

	if cur_amount >= 3 then
		if isHas_bindItem == true then
			self:showTipsWin();
		else
			self:sendMessage();
		end
	else
		OperateAlert.show(LanUtil.getValue(120549));
	end
end

function Lua_AmuletNecklacePanel:sendMessage()
	self.pkg_indexArr:sort("costEquType", false);
	local cmd = ProtoPublic_pb.Proto11400630();
	for i = 1, self.pkg_indexArr:getSize() do
		cmd.pkg_index:append(self.pkg_indexArr[i].index);
	end
	cmd.rule_id = self.curEquipData.idx;
	sendMsg(11400630, cmd);
end

function Lua_AmuletNecklacePanel:showTipsWin()
	local tipData = {};
	tipData.owner = self;
	tipData.des = LanUtil.formateStr(LanUtil.getValue(120586));
	tipData.cancelName = LanUtil.getValue(120545);
	tipData.subName = LanUtil.getValue(110739);
	tipData.titleName = LanUtil.getValue(120585);
	tipData.type = 1;
	tipData.subFun = self.sendMessage;
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_AmuletNecklacePanel:onOncePutClick()
	if self.equArr == nil then
		return;
	end

	local len = self.equArr:getSize();
	local equipList = DataCenter.equData:getComposeEquArr(self.curEquipData.materialsArr.equip[1]);
	local index = 1;
	for i = 1, len do
		if self.stateArr[i] == 0 then
			if equipList[index] ~= nil then
				equipList[index].costEquType = i;
				self:onPutIntoEquip(equipList[index]);
				index = index + 1;
			end
		end
	end
end

function Lua_AmuletNecklacePanel:updataPackEquip()
	if self.pkg_indexArr ~= nil then
		local mater = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsBySubType({Lua_PackTypeDefine.EQUIP});
		if mater ~= nil and mater:getSize() ~= 0 then
			for i = 1, self.pkg_indexArr:getSize() do
				for j = 1, mater:getSize() do
					if mater[j].index == self.pkg_indexArr[i].index then
						mater[j].isPut = false;
						break;
					end
				end
			end
		end
	end
end

function Lua_AmuletNecklacePanel:onSubClick(sub)
	self.selectedData = sub;
	self:updateSubRedDot();

	if sub.data == nil then
		return;
	end

	self:updataPackEquip();

	if self.pkg_indexArr ~= nil then
		self.pkg_indexArr:clear();
	else
		self.pkg_indexArr = Array();
	end

	self.idList = sub.data;
	self.Arr = Array();
	local len = #Lua_AmuletNecklaceUtil.selected_equipArr();
	for i = 1, len do
		local infList = Lua_AmuletNecklaceUtil.getInfList(tonumber(self.idList[i]));
		local list = {};
		list.index = i;
		list.idx = self.idList[i];
		list.rateArr = infList.attr;
		list.materialsArr = infList.materials;
		list.output = infList.out_put;
		list.star = infList.star;
		list.part = i + 6;
		list.equipCount = 0;
		for i = 1, #list.materialsArr.equip do
			list.materialsArr.equip[i][4] = list.part;
			list.materialsArr.equip[i][5] = 4;
		end
		list.equipCount = DataCenter.equData:getComposeEquCount(list.materialsArr.equip[1]);
		list.partRedDot = DataCenter.equData:canCompose(list.materialsArr);
		list.materialsCount = list.equipCount;
		self.Arr:add(list);
	end
	self.equip_DragList:setLuaArrayData(self.Arr, false);
	self:infoShowState(true);
end

function Lua_AmuletNecklacePanel:onSuccessEvent()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_qianghua", "gui_qianghua", 136, -21);
	else
		self.effect:setEnable(false);
		self.effect:setEnable(true);
	end
	self.effect:SetRenderQueue(self.ylLbl, 10, 2, false);

	if self.effectZiTi == nil then
		self.effectZiTi = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hechengchenggong", "gui_hechengchenggong", 89, -116);
	else
		self.effectZiTi:setEnable(false);
		self.effectZiTi:setEnable(true);
	end
	self.effectZiTi:SetRenderQueue(self.ylLbl, 10, 2, false);
	self:onEquipChange(self.curEquipData);
	self:setRedDot();
end

function Lua_AmuletNecklacePanel:onFailedEvent()
	if self.failedEffect == nil then
		self.failedEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_qianghua", "gui_qianghua", 136, -21);
		self.failedEffect:SetRenderQueue(self.ylLbl, 10, 2, false);
	else
		self.failedEffect:setEnable(false);
		self.failedEffect:setEnable(true);
	end

	if self.failedEffectZiTi == nil then
		self.failedEffectZiTi = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hechengshibai", "gui_hechengshibai", 89, -116);
		self.failedEffectZiTi:SetRenderQueue(self.ylLbl, 10, 2, false);
	else
		self.failedEffectZiTi:setEnable(false);
		self.failedEffectZiTi:setEnable(true);
	end
	self:onEquipChange(self.curEquipData);
	self:setRedDot();
end

function Lua_AmuletNecklacePanel:dispose()
	if self.equip_DragList ~= nil then
		self.equip_DragList:dispose();
		self.equip_DragList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	self:updataPackEquip();

	self:superCall("dispose");
end