Lua_AttrTxtInfoPanel = class("Lua_AttrTxtInfoPanel", Lua_DragContainerItem);
function Lua_AttrTxtInfoPanel:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub);

	dragContainer:addSubContainer(self, true);
	self.dragContainer = dragContainer;
end

function Lua_AttrTxtInfoPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.ObjList = Array()
end

function Lua_AttrTxtInfoPanel:setTextData(data, state)
	self.data = data
	self.state = state

	local len = data:getSize()
	for i = 1, len do
		if self.ObjList[i] == nil then
			local label = UICreate.createLabel(self.content, "", 0, 0, 100, 30, 22);
			label.overflowMethod = UILabel.Overflow.ResizeFreely;
			label.pivot = UIWidget.Pivot.Left;
			label:setDepth(6);
			label.text = "[85A8BE]" .. data[i].attrName .. "：[-]" .. data[i].value
			label:setLocation(-132, 70 -(i - 1) * 30, 0);

			local offsetX = label.mainContent.transform.localPosition.x + label.width + 24;
			local arrow = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xjt_02", 0, 0, 0, 0);
			arrow:setLocation(offsetX, 70 -(i - 1) * 30, 0);
			arrow:setDepth(6);
			arrow:setEnable(true);

			offsetX = arrow.mainContent.transform.localPosition.x + 15
			local label2 = UICreate.createLabel(self.content, "", 0, 0, 100, 30, 22);
			label2.pivot = UIWidget.Pivot.Left;
			label2.overflowMethod = UILabel.Overflow.ResizeFreely;
			label2:setDepth(5);
			label2.text = "[00E125]" .. data[i].addValue
			label2:setLocation(offsetX, 70 -(i - 1) * 30, 0);

			self.ObjList:add({label = label, arrow = arrow, label2 = label2})
		else
			self.ObjList[i].label.text = "[85A8BE]" .. data[i].attrName .. "：[-]" .. data[i].value
			
			local offsetX = self.ObjList[i].label.mainContent.transform.localPosition.x + self.ObjList[i].label.width + 24
			self.ObjList[i].arrow:setEnable(true)
			self.ObjList[i].arrow:setLocation(offsetX, 70 -(i - 1) * 30, 0);
			
			offsetX = self.ObjList[i].arrow.mainContent.transform.localPosition.x + 15
			self.ObjList[i].label2.text = "[00E125]" .. data[i].addValue
			self.ObjList[i].label2:setLocation(offsetX, 70 -(i - 1) * 30, 0);
		end
	end

	local objLen = self.ObjList:getSize();
	if self.state == true then
		for i = 1, objLen do
			self.ObjList[i].arrow:setEnable(false)
			self.ObjList[i].label2.text = ""
		end
	end

	if objLen > len then
		for i = len + 1, objLen do
			self.ObjList[i].label.text = ""
			self.ObjList[i].arrow:setEnable(false)
			self.ObjList[i].label2.text = ""
		end
	end

	self.dragContainer:updateChildPos();
	self.dragContainer.canDrag = self.ObjList:getSize() * 30 > 166
end 

function Lua_AttrTxtInfoPanel:getHeight()
	return self.ObjList:getSize() * 30;
end