Lua_ComposeTiHuanEquipWindow = class("Lua_ComposeTiHuanEquipWindow", Lua_Window);
function Lua_ComposeTiHuanEquipWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ComposeTiHuanEquipWindow";
	self.skinName = "TiHuan_skin";
end

function Lua_ComposeTiHuanEquipWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.titleNameLab.text = LanUtil.getValue(120535);

	self.tihuanBtn:setEnable(false);
	self.xiexiaBtn:setEnable(false);

	self.tihuan_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 380, 432));
	self.tihuan_DragList:setListCell(Lua_TiHuanEquItem, 126, 380, 1);
	self.tihuan_DragList:setLocation(0, -35, 0);

	self:addLuaEvent("onTiHuanCellClick", self, self.onTiHuanCellClick);
	self:addLuaEvent("CREAT_EQU", self, self.setData);
end

function Lua_ComposeTiHuanEquipWindow:showWin(param)
	self.Arr = param[1];
	self.costEquType = param[2];
	Lua_MsgUtil.callFunc("CREAT_EQU");
end

function Lua_ComposeTiHuanEquipWindow:setData()
	if self.Arr ~= nil and self.Arr:getSize() ~= 0 then
		self.tihuan_DragList:setLuaArrayData(self.Arr, false);
	end
end

function Lua_ComposeTiHuanEquipWindow:onTiHuanCellClick(data)
	self.data = data
	if self.data == nil then
		return;
	end

	self.data.costEquType = self.costEquType
	Lua_MsgUtil.callFunc("PUT_INTO_EQUIP", self.data);
	self:hide();
end

function Lua_ComposeTiHuanEquipWindow:dispose()
	if self.tihuan_DragList ~= nil then
		self.tihuan_DragList:dispose();
		self.tihuan_DragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_TiHuanEquItem = class("Lua_TiHuanEquItem", Lua_ListCell);
function Lua_TiHuanEquItem:ctor(p)
	self:superCall("ctor", p, "TiHuanEquipItem_skin");
end

function Lua_TiHuanEquItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setCanClick(true);
	self.itemImg:setLocation(-132, 2, 0);
end

function Lua_TiHuanEquItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data;
	self.itemNameTxt.text = self.itemImg.data.colorName;
end

function Lua_TiHuanEquItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onTiHuanCellClick", self._data);
end

function Lua_TiHuanEquItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end