Lua_CuiLianPanel = class("Lua_CuiLianPanel", Lua_DisplayObject);
function Lua_CuiLianPanel:ctor(p)
	self:superCall("ctor", p, "CuiLianPanel_skin");
end

function Lua_CuiLianPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.xianRedDot:setEnable(false);
	self.shenRedDot:setEnable(false);
	self.cuiLianRedDot:setEnable(false);

	self.xianBtn:addClickFuntion(self, self.onXianClick);
	self.shenBtn:addClickFuntion(self, self.onShenClick);
	self.cuiLianBtn:addClickFuntion(self, self.onCuiLianClick);
	self.tipsIcon:addClickFuntion(self, self.onHelp)

	self:addLuaEvent("onCuiLianCellClick", self, self.onCuiLianCellClick);
	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView);
	self:addLuaEvent("UPDATE_COUNT", self, self.onChangeLabel)
	self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent)

	self.tipsLab.text = LanUtil.getValue(110557);
	self.desLblArr = Array();
	self.lblArr = Array();

	self.duanzaoBgArr = Array();
	self.duanzaoBgArr:add(self.forging_duanzaoL);
	self.duanzaoBgArr:add(self.forging_duanzaoM);
	self.duanzaoBgArr:add(self.forging_duanzaoR);

	self.cuiLianLbl2:setEnable(false);
	self.isClick = false;
	self.refineIdx = 0;
	self.idx = 1;

	self.isEnough1 = true;
	self.isEnough2 = true;
	self.isEnough3 = true;

	self.cuilian_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 500));
	self.cuilian_DragList:setListCell(Lua_CuiLianItem, 116, 286, 1);
	self.cuilian_DragList:setLocation(-460, -26, 0);

	self:onChangeDes();
end

function Lua_CuiLianPanel:onSuccessEvent()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.cuiLianBg.mainContent, "/effects/scsEffects/gui_qianghua", "gui_qianghua", 0, 0);
	else
		self.effect:setEnable(false);
		self.effect:setEnable(true);
	end
	self.effect:SetRenderQueue(self.ylLbl, 5, 2, false);

	if self.effectZiTi == nil then
		self.effectZiTi = UICreate.createUIEffect(self.cuiLianBg.mainContent, "/effects/scsEffects/gui_cuilianziti", "gui_cuilianziti", 0, -160);
	else
		self.effectZiTi:setEnable(false);
		self.effectZiTi:setEnable(true);
	end
	self.effectZiTi:SetRenderQueue(self.ylLbl, 5, 2, false);
end

function Lua_CuiLianPanel:onXianClick()
	self.isClick = false;
	self.isFirst = false;
	self:onChangeDes()
end

function Lua_CuiLianPanel:onShenClick()
	self.isClick = true;
	self.isFirst = false;
	self:onChangeDes()
end

function Lua_CuiLianPanel:onChangeDes()
	if self.isClick then
		-- 传说列表
		self.titleLab.text = LanUtil.getValue(110564);
		self.idx = 2;

		self.xianBtn:setStyle(32);
		self.shenBtn:setStyle(31);
	else
		-- 史诗列表
		self.titleLab.text = LanUtil.getValue(110566);
		self.idx = 1;

		self.xianBtn:setStyle(31);
		self.shenBtn:setStyle(32);
	end

	self.Arr1 = Array();
	self.equipArr = DataCenter.equData.parts;
	if #self.equipArr ~= 0 then
		for i = 1, 12 do
			local _eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil then
				_eq.bolIdx = self.idx;
				_eq.cuilianHongDian = false;
				if _eq.order >= 5 and _eq.color >= 4 and _eq.star >= 1 and Lua_CuiLianUtil.getJewelry_part(_eq.equPart) ~= -1 and _eq.refine == 0 then
					self.Arr1:add(_eq);
				end

				if _eq.order >= 5 and _eq.color >= 4 and _eq.star >= 1 and Lua_CuiLianUtil.getJewelry_part(_eq.equPart) ~= -1 and _eq.refine > 0 then
					self.Arr1:add(_eq);
				end
			end
		end
	end
	self.Arr1:sort("equPart", false);
	self.cuilian_DragList:setLuaArrayData(self.Arr1, false);

	
	self.length = self.cuilian_DragList.showList:getSize();
	if self.length ~= 0 then
		if self.isFirst == nil then
			self.isFirst = true;
			self.cuilian_DragList.showList[1]:onPlayerSoundClick();
			self.cuilian_DragList:setSelected(1);
		elseif self.isFirst == false then
			self.isFirst = true;

			local idx = self.cuilian_DragList.curSelectedIdx;
			local arr = self.cuilian_DragList.showList;
			for i = 1, arr:getSize() do
				if arr[i].cellSeqIndex == idx then
					self.cuilian_DragList.showList[i]:onPlayerSoundClick();
					self.cuilian_DragList:setSelected(idx);
					break;
				end
			end
		end
	end
end

function Lua_CuiLianPanel:onHelp()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(110596));
end

function Lua_CuiLianPanel:getSuitName()
	if self.data == nil then
		return
	end
	if self.data.career == 0 then
		local _strName = Lua_CuiLianUtil.getRefine_name(4, self.data.order);
		return _strName;
	else
		local _strName = Lua_CuiLianUtil.getRefine_name(DataCenter.roleData.career, self.data.order);
		return _strName;
	end
	-- return string.sub(self.equipImg.data.name, 0, 6);
end

function Lua_CuiLianPanel:onCalCount2()
	if self.data == nil then
		return
	end

	local _count = 0;
	local _count2 = 0
	if self.data.career ~= 0 then
		for i = 1, 12 do
			local _eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil and _eq.refine ~= 0 and _eq.refine == self.idx and Lua_CuiLianUtil.getJewelry_part(_eq.equPart) ~= -1 and self.data.career == _eq.career and self.data.order <= _eq.order then
				_count = _count + 1;
			end

			if _eq ~= nil and _eq.refine ~= 0 and _eq.refine == 1 and Lua_CuiLianUtil.getJewelry_part(_eq.equPart) ~= -1 and self.data.career == _eq.career and self.data.order <= _eq.order then
				_count2 = _count2 + 1
				-- 只计算仙品数量用于判断淬炼神品的二级框
			end
		end
	else
		-- 饰品
		for i = 1, 12 do
			local _eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil and _eq.refine ~= 0 and _eq.refine == self.idx and Lua_CuiLianUtil.getJewelry_part(_eq.equPart) ~= -1 and self.data.career == _eq.career then
				_count = _count + 1;
			end

			if _eq ~= nil and _eq.refine ~= 0 and _eq.refine == 1 and Lua_CuiLianUtil.getJewelry_part(_eq.equPart) ~= -1 and self.data.career == _eq.career then
				_count2 = _count2 + 1
				-- 只计算仙品数量用于判断淬炼神品的二级框
			end
		end
	end
	self.xianPinCount = _count2
	self:onChangeLabel(_count)
end

function Lua_CuiLianPanel:onCalShenPinCount()
	if self.data == nil then
		return
	end

	local _eq;
	local _count = 0;
	if self.data.career ~= 0 then
		for i = 1, 12 do
			_eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil and _eq.refine ~= 0 and _eq.refine == 2 and Lua_CuiLianUtil.getJewelry_part(_eq.equPart) ~= -1 and self.data.career == _eq.career and self.data.order <= _eq.order then
				_count = _count + 1;
			end
		end
	else
		-- 饰品
		for i = 1, 12 do
			_eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil and _eq.refine ~= 0 and _eq.refine == 2 and Lua_CuiLianUtil.getJewelry_part(_eq.equPart) ~= -1 and self.data.career == _eq.career then
				_count = _count + 1;
			end
		end
	end
	return _count;
end

function Lua_CuiLianPanel:onChangeLabel(count)
	local shenPinCount = self:onCalShenPinCount();
	local str = Lua_CuiLianUtil.getTips_count(self.idx);
	local str2 = self:getSuitName();

	local count2 = Lua_CuiLianUtil.getCount(self.idx, 1);
	local count4 = Lua_CuiLianUtil.getCount(self.idx, 2);
	local count6 = Lua_CuiLianUtil.getCount(self.idx, 3);

	self.colorList = {[1] = "[85A8BE]", [2] = "[FFDF05]"};

	if self.data.career ~= 0 then
		self.titleLbl2.text = "[00E125]" .. string.format(str, str2, count, 6);
		count2 = Lua_CuiLianUtil.getCount(self.idx, 1);
		count4 = Lua_CuiLianUtil.getCount(self.idx, 2);
		count6 = Lua_CuiLianUtil.getCount(self.idx, 3);

		self.sixDesLbl:setEnable(true);
		self.sixLbl:setEnable(true);
	else
		-- 饰品
		self.titleLbl2.text = "[00E125]" .. string.format(str, str2, count, 4);

		count2 = Lua_CuiLianUtil.getJewelryCount(self.idx, 1);
		count4 = Lua_CuiLianUtil.getJewelryCount(self.idx, 2);
		count6 = Lua_CuiLianUtil.getJewelryCount(self.idx, 3);
		self.sixDesLbl:setEnable(false);
		self.sixLbl:setEnable(false);
	end

	self.strArr = Array();
	for i = 1, Lua_CuiLianUtil.getAttrLen(self.idx) do
		local len = Lua_CuiLianUtil.getPropertyLen(self.idx, i);
		if self.data.career ~= 0 then
			len = Lua_CuiLianUtil.getPropertyLen(self.idx, i)
		else
			len = Lua_CuiLianUtil.getJewelryPropertyLen(self.idx, i)
		end

		local str = "";
		for c = 1, len do
			local isMark_Str = "\n";
			if self.data.career ~= 0 then
				if Lua_CuiLianUtil.getTips2_mark(self.idx, i, c) == -1 then
					isMark_Str = "%\n";
				end
			else
				if Lua_CuiLianUtil.getJewelryTips2_mark(self.idx, i, c) == -1 then
					isMark_Str = "%\n";
				end
			end

			if self.data.career ~= 0 then
				str = str .. Lua_CuiLianUtil.getTips2(self.idx, i, c) .. Lua_CuiLianUtil.getProperty(self.idx, i, c, self.data.order) .. isMark_Str;
			else
				str = str .. Lua_CuiLianUtil.getJewelryTips2(self.idx, i, c) .. Lua_CuiLianUtil.getJewelryProperty(self.idx, i, c) .. isMark_Str;
			end
		end
		self.strArr:add(str);
	end

	local color2, color4, color6;
	if self.data.career ~= 0 then
		local suitList = DataCenter.equData:getSuitNumList(self.idx, true);
		color2 = suitList[count2] == self.data.order and self.colorList[2] or self.colorList[1];
		color4 = suitList[count4] == self.data.order and self.colorList[2] or self.colorList[1];
		color6 = suitList[count6] == self.data.order and self.colorList[2] or self.colorList[1];
	else
		color2 = count >= count2 and self.colorList[2] or self.colorList[1];
		color4 = count >= count4 and self.colorList[2] or self.colorList[1];
		color6 = count >= count6 and self.colorList[2] or self.colorList[1];
	end
	self.twoDesLbl.text = color2 .. self.strArr[1];
	self.twoLbl.text = color2 .. Lua_CuiLianUtil.getCountShow(self.idx, count2 / 2)

	self.fourDesLbl.text = color4 .. self.strArr[2];
	self.fourLbl.text = color4 .. Lua_CuiLianUtil.getCountShow(self.idx, count4 / 2)

	self.sixDesLbl.text = color6 .. self.strArr[3];
	self.sixLbl.text = color6 .. Lua_CuiLianUtil.getCountShow(self.idx, count6 / 2)
end

function Lua_CuiLianPanel:onCuiLianClick()
	if self.data == nil then
		return
	end

	if self.isEnough1 == false or self.isEnough1 == false or self.isEnough3 == false then
		local arr = Array();
		for i = 1, self.costNum do
			arr:add(Lua_ToolVo.new(self.cost_Arr[i][1], 1, 0));
		end
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	else
		if (self.xianPinCount == 2 or self.xianPinCount == 4 or self.xianPinCount == 6) and self.idx ~= 1 then
			local tipData = {};
			tipData.des = LanUtil.formateStr(LanUtil.getValue(120552), tostring(self.xianPinCount));
			tipData.owner = self;
			tipData.type = 1;
			tipData.txtPivot = UIWidget.Pivot.Left;
			tipData.txtFontSize = 26;
			tipData.txtSpacingY = 10;
			tipData.subName = LanUtil.getValue(120551);
			tipData.cancelName = LanUtil.getValue(120553);
			tipData.subFun = self.onSubCallback;
			-- 确认
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		else
			self:onSubCallback()
		end
	end
end

function Lua_CuiLianPanel:onSubCallback()
	local cmd = ProtoPublic_pb.Proto11400618();
	cmd.part = self.data.equPart;
	sendMsg(11400618, cmd);
end

function Lua_CuiLianPanel:onCuiLianCellClick(data)
	self.data = data;
	if self.data == nil then
		return;
	end
	self:onShowInfo()
end

function Lua_CuiLianPanel:checkBtnRedDot(refine)
	for i = 1, self.Arr1:getSize() do
		local cost_Arr = Lua_CuiLianUtil.getCost(self.Arr1[i].refine, "a" .. self.Arr1[i].career .. string.format("%02d", self.Arr1[i].equPart))[self.Arr1[i].order];
		local costNum = #cost_Arr;
		local isRed = true;
		if refine == 1 then
			if self.Arr1[i].refine == 0 then
				for c = 1, costNum do
					if cost_Arr[c] ~= nil then
						local had_Count = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(cost_Arr[c][1]);
						if had_Count < cost_Arr[c][2] then
							isRed = false
						end
					end
				end

				if isRed == true then
					return isRed;
				end
			end
		else
			if self.Arr1[i].refine == 1 and self.Arr1[i].star >= 2 then
				for c = 1, costNum do
					if cost_Arr[c] ~= nil then
						local had_Count = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(cost_Arr[c][1]);
						if had_Count < cost_Arr[c][2] then
							isRed = false
						end
					end
				end

				if isRed == true then
					return isRed;
				end
			end
		end
	end
	return false;
end

function Lua_CuiLianPanel:onShowInfo()
	self:onCalCount2();

	self.xianRedDot:setEnable(self:checkBtnRedDot(1));
	self.shenRedDot:setEnable(self:checkBtnRedDot(2));
	self.cost_Arr = Lua_CuiLianUtil.getCost(self.data.refine, "a" .. self.data.career .. string.format("%02d", self.data.equPart))[self.data.order];
	self.costNum = #self.cost_Arr;
	if self.goArr == nil then
		self.goArr = Array();
	else
		self.isEnough1 = true;
		self.isEnough2 = true;
		self.isEnough3 = true;
		for i = 1, self.goArr:getSize() do
			self.goArr[i]:dispose();
		end
	end

	if self.equipImg == nil then
		self.equipImg = Lua_ToolImage.new(self.content);
		self.equipImg:setDepth(6);
		self.equipImg:setLocation(42, 29, 0);
	end
	self.equipImg:setEnable(true);
	self.equipImg.data = self.data;

	if self.data.bolIdx == 1 then
		-- 史诗
		if self.data.refine == 0 then
			self.equipNameBg:setEnable(true);
			self.equipName.text = LanUtil.getValue(110568) .. self.equipImg.data.name;
			self:setGameObjectSate(true, false, self.data.cuilianHongDian);
		else
			self.equipNameBg:setEnable(false);
			self.equipName.text = "";
			self.equipImg:setEnable(false);
			self:setGameObjectSate(false, true, self.data.cuilianHongDian);
			return
		end
	else
		if self.data.refine == 1 then
			self.equipNameBg:setEnable(true);
			self.equipName.text = LanUtil.getValue(110569) .. self.equipImg.data.name;
			self:setGameObjectSate(true, false, self.data.cuilianHongDian);
		elseif self.data.refine == 0 then
			self.equipNameBg:setEnable(false);
			self.equipName.text = "";
			self.equipImg:setEnable(false);
			self:setGameObjectSate(false, false, self.data.cuilianHongDian);
			return
		else
			self.equipNameBg:setEnable(false);
			self.equipName.text = "";
			self.equipImg:setEnable(false);
			self:setGameObjectSate(false, true, self.data.cuilianHongDian);
			return
		end
	end

	if self.data.refine == 2 or self.data.refine == 1 and self.data.refine_up == false then
		self.equipNameBg:setEnable(false);
		self.equipName.text = "";
		self:setGameObjectSate(false, true, self.data.cuilianHongDian);
		return
	else
		self:setGameObjectSate(true, false, self.data.cuilianHongDian);
	end

	for i = 1, self.costNum do
		if self.cost_Arr[i][2] ~= 0 and self.costNum == 1 then
			self.equipImg1 = Lua_ToolImage.new(self.duanzaoBgArr[2].mainContent);
			self.equipImg1:setDepth(6);
			self.equipImg1:setLocation(0, 0, 0);
			self.equipImg1.data = Lua_ToolVo.new(self.cost_Arr[i][1], 0, 0);
			self.had_Count = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.cost_Arr[i][1]);
			self.equipImg1:showNumLimit(self.had_Count, self.cost_Arr[i][2], 2)
			-- M锁隐藏 LR锁开启
			self.goArr:add(self.equipImg1);
		elseif self.cost_Arr[i][2] ~= 0 and self.costNum == 2 then
			-- R锁开启 M锁隐藏
			self.equipImg2 = Lua_ToolImage.new(self.duanzaoBgArr[i].mainContent);
			self.equipImg2:setDepth(6);
			self.equipImg2:setLocation(0, 0, 0);
			self.equipImg2.data = Lua_ToolVo.new(self.cost_Arr[i][1], 0, 0);
			self.had_Count = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.cost_Arr[i][1]);
			self.equipImg2:showNumLimit(self.had_Count, self.cost_Arr[i][2], 2)
			self.goArr:add(self.equipImg2);
		elseif self.cost_Arr[i][2] ~= 0 and self.costNum == 3 then
			-- rlm都隐藏
			self.equipImg3 = Lua_ToolImage.new(self.duanzaoBgArr[i].mainContent);
			self.equipImg3:setDepth(6);
			self.equipImg3:setLocation(0, 0, 0);
			self.equipImg3.data = Lua_ToolVo.new(self.cost_Arr[i][1], 0, 0);
			self.had_Count = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.cost_Arr[i][1]);
			self.equipImg3:showNumLimit(self.had_Count, self.cost_Arr[i][2], 2)
			self.goArr:add(self.equipImg3);
		end
	end
end

function Lua_CuiLianPanel:setGameObjectSate(args1, args2, args3)
	self.cuiLianBtn:setEnable(args1);
	self.cuiLianLbl2:setEnable(args2);
	self.cuiLianRedDot:setEnable(args3);
end

function Lua_CuiLianPanel:onUpdateView()
	self:onChangeDes();

	self.Arr1 = Array();
	self.equipArr = DataCenter.equData.parts;
	if #self.equipArr ~= 0 then
		for i = 1, 12 do
			local _eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil then
				_eq.bolIdx = self.idx;
				if _eq.order >= 5 and _eq.color >= 4 and _eq.star >= 1 and Lua_CuiLianUtil.getJewelry_part(_eq.equPart) ~= -1 and _eq.refine == 0 then
					self.Arr1:add(_eq);
				end

				if _eq.order >= 5 and _eq.color >= 4 and _eq.star >= 1 and Lua_CuiLianUtil.getJewelry_part(_eq.equPart) ~= -1 and _eq.refine > 0 then
					self.Arr1:add(_eq);
				end
			end
		end
	end
	self.Arr1:sort("equPart", false);

	for i = 1, self.Arr1:getSize() do
		if self.data.equPart == self.Arr1[i].equPart then
			self.data = self.Arr1[i];
			self.Arr1[i].selected = true;
		else
			self.Arr1[i].selected = false;
		end
	end
	self.cuilian_DragList:setLuaArrayData(self.Arr1, false);
	self:onShowInfo();
end

function Lua_CuiLianPanel:dispose()
	if self.cuilian_DragList ~= nil then
		self.cuilian_DragList:dispose();
		self.cuilian_DragList = nil;
	end
	DataCenter.equData.ForgingWindowData = nil;
	self:superCall("dispose");
end





--------------------------------------------------





Lua_CuiLianItem = class("Lua_CuiLianItem", Lua_ListCell);
function Lua_CuiLianItem:ctor(p)
	self:superCall("ctor", p, "CuiLianItem_skin");
end

function Lua_CuiLianItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-94.5, 2, 0);
end

function Lua_CuiLianItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemTxt.text = "";
	self.itemTxtM.text = "";
	self.itemTipsTxt.text = "";
	self.itemBg:setAltas("iconantlas1", "tab3_souchong_normal");
	self.itemImg.data = self._data;
	self.equipCount = 0;

	if self._data.career == 0 then
		self.equipCount = 4;
	else
		self.equipCount = 6;
	end

	if self._data.bolIdx == 1 then
		if self._data.refine == 0 then
			self.itemTxt.text = self.itemImg.data.colorName
			if self._data.refine_up == true then
				self.itemTipsTxt.text = LanUtil.getValue(110570);
			end
		elseif self._data.refine == 1 then
			self.itemTxt.text = "[" .. self.itemImg.data.colorStr .. "]" .. LanUtil.getValue(110568) .. self.itemImg.data.colorName
			local strArr = self:getSuitName();
			local _count = self:onCalCount();
			self.itemTxtM.text = LanUtil.formateStr(LanUtil.getValue(110571), tostring(strArr), tostring(_count), tostring(self.equipCount));
			if self._data.refine_up == true and self._data.star > Lua_CuiLianUtil.getStar_limit(self._data.bolIdx) then
				self.itemTipsTxt.text = LanUtil.getValue(110572)
			end
		elseif self._data.refine == 2 then
			self.itemTxt.text = "[" .. self.itemImg.data.colorStr .. "]" .. LanUtil.getValue(110569) .. self.itemImg.data.colorName
			local strArr = self:getSuitName();
			local _count = self:onCalCount();
			self.itemTxtM.text = LanUtil.formateStr(LanUtil.getValue(110571), tostring(strArr), tostring(_count), tostring(self.equipCount));
		end
	else
		if self._data.refine == 1 then
			self.itemTxt.text = "[" .. self.itemImg.data.colorStr .. "]" .. LanUtil.getValue(110568) .. self.itemImg.data.colorName
			local strArr = self:getSuitName();
			local _count = self:onCalCount();
			self.itemTxtM.text = LanUtil.formateStr(LanUtil.getValue(110571), tostring(strArr), tostring(_count), tostring(self.equipCount));
			if self._data.refine_up == true then
				self.itemTipsTxt.text = LanUtil.getValue(110572);
			end
		elseif self._data.refine == 0 then
			self.itemTxt.text = self.itemImg.data.colorName
			if self._data.refine_up == true then
				self.itemTipsTxt.text = LanUtil.getValue(110594);
			end
		elseif self._data.refine == 2 then
			self.itemTxt.text = "[" .. self.itemImg.data.colorStr .. "]" .. LanUtil.getValue(110569) .. self.itemImg.data.colorName
			local strArr = self:getSuitName();
			local _count = self:onCalCount();
			self.itemTxtM.text = LanUtil.formateStr(LanUtil.getValue(110571), tostring(strArr), tostring(_count), tostring(self.equipCount));
		end
			if self._data.star < Lua_CuiLianUtil.getStar_limit(self._data.bolIdx) and self._data.refine ~= 0 then
				if self._data.refine == 1 then
					self.itemTxt.text = "[" .. self.itemImg.data.colorStr .. "]" .. LanUtil.getValue(110568) .. self.itemImg.data.colorName
				else
					self.itemTxt.text = "[" .. self.itemImg.data.colorStr .. "]" .. LanUtil.getValue(110569) .. self.itemImg.data.colorName
				end
			self.itemTipsTxt.text = LanUtil.getValue(110595);
		end
	end

	self._data.cuilianHongDian = self:checkRedDot()
	self.redDot:setEnable(self._data.cuilianHongDian);
	self.itemBg:setAltas("iconantlas1", data.selected and "tab3_souchong_select" or "tab3_souchong_normal");
end

function Lua_CuiLianItem:onCalCount()
	local _eq;
	local count = 0;
	if self._data.career ~= 0 then
		for i = 1, 12 do
			_eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil and _eq.refine == self._data.bolIdx and self._data.career == _eq.career and self._data.order <= _eq.order then
				count = count + 1;
			end
		end
	else
	-- 饰品
		for i = 1, 12 do
			_eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil and _eq.refine == self._data.bolIdx and self._data.career == _eq.career then
				count = count + 1;
			end
		end
	end
	return count;
end

function Lua_CuiLianItem:getSuitName()
	if self._data.career == 0 then
		local _strName = Lua_CuiLianUtil.getRefine_name(4, self._data.order);
		return _strName;
	else
		local _strName = Lua_CuiLianUtil.getRefine_name(DataCenter.roleData.career, self._data.order);
		return _strName;
	end
end

function Lua_CuiLianItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onCuiLianCellClick", self._data);
end

function Lua_CuiLianItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_CuiLianItem:checkRedDot()
	local cost_Arr = Lua_CuiLianUtil.getCost(self._data.refine, "a" .. self._data.career .. string.format("%02d", self._data.equPart))[self._data.order];
	local costNum = #cost_Arr;
	if self._data.bolIdx == self._data.refine or self._data.bolIdx - self._data.refine ~= 1 then
		return false
	else
		if self._data.refine_up == false then
			return false;
		else
			if self._data.star < Lua_CuiLianUtil.getStar_limit(self._data.bolIdx) and self._data.bolIdx == 2 then
				return false;
			end
			
			for i = 1, costNum do
				local had_Count = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(cost_Arr[i][1]);
				if had_Count < cost_Arr[i][2] then
					return false;
				end
			end
			return true;
		end
	end
end