Lua_EquipFuLingItem = class("Lua_EquipFuLingItem", Lua_ListCell);
function Lua_EquipFuLingItem:ctor(p)
	self:superCall("ctor", p, "EquipJueXingItem_skin");
end

function Lua_EquipFuLingItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-93.5, 2.5, 0);
end

function Lua_EquipFuLingItem:setData(data)
	self._data = data
	if data == nil then
		return;
	end
	self.itemImg.data = data

	if data.intensifyLevel == 0 then
		self.itemTxt.text = self.itemImg.data.colorName
	elseif data.intensifyLevel == data.maxLvl then
		self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.intensifyLevel;
	else
		self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.intensifyLevel;
	end

	if data.isCanFuLing == false then
		self.itemTipsTxt.text = "[FF1616]" .. data.fuLingTxtShow
	else
		if data.spirit_level ~= data.maxFuLingLvl or data.spirit_level == data.theMaxFuLingLvl then
			self.itemTipsTxt.text = "[85A8BE]" .. LanUtil.getValue(128910) .. data.spirit_level
		else
			self.itemTipsTxt.text = "[FF1616]" .. data.max_fuling_show
		end
	end
	self.redDot:setEnable(self:checkRedot() and data.isCanFuLing == true and data.spirit_level < data.maxFuLingLvl);
end

function Lua_EquipFuLingItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onEquipFulingCellClick", self._data);
end

function Lua_EquipFuLingItem:checkRedot()
	local costItemArr = self._data.fuLingCostItem
	local isEnough = true
	for i = 1, costItemArr:getSize() do
		local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemArr[i].id)
		if hadCount < costItemArr[i].count then
			return false
		end
	end
	return isEnough
end
function Lua_EquipFuLingItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_EquipFuLingItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end