Lua_EquipJueXingItem = class("Lua_EquipJueXingItem", Lua_ListCell);
function Lua_EquipJueXingItem:ctor(p)
	self:superCall("ctor", p, "EquipJueXingItem_skin");
end

function Lua_EquipJueXingItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-93.5, 2.5, 0);
end

function Lua_EquipJueXingItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end
	self.itemImg.data = self._data

	if data.intensifyLevel == 0 then
		self.itemTxt.text = self.itemImg.data.colorName
	elseif data.intensifyLevel == self._data.maxLvl then
		self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.intensifyLevel;
	else
		self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.intensifyLevel;
	end

	if self._data.isCanJueXing == false then
		self.itemTipsTxt.text = "[FF1616]" .. self._data.jueXingTxtShow
	else
		if self._data.awake_level ~= self._data.maxJueXingLvl or self._data.awake_level == self._data.theMaxJueXingLvl then
			self.itemTipsTxt.text = "[85A8BE]" .. LanUtil.getValue(128903) .. self._data.awake_level
		else
			self.itemTipsTxt.text = "[FF1616]" .. self._data.max_lvl_show
		end
	end
	self.redDot:setEnable(self:checkRedot() and self._data.isCanJueXing == true and self._data.awake_level < self._data.maxJueXingLvl)
end

function Lua_EquipJueXingItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onEquipJueXingCellClick", self._data);
end

function Lua_EquipJueXingItem:checkRedot()
	local costItemArr = self._data.jueXingCostItem;
	local isEnough = true;
	for i = 1, costItemArr:getSize() do
		local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemArr[i].id)
		if hadCount < costItemArr[i].count then
			return false;
		end
	end
	return isEnough;
end

function Lua_EquipJueXingItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_EquipJueXingItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end