checkRequire("Lua_QiangHuaPanel"); -- 強化
checkRequire("Lua_ZhuLingPanel"); -- 注靈
checkRequire("Lua_XiLianPanel"); -- 洗練
checkRequire("Lua_JinJiePanel"); -- 進階
checkRequire("Lua_JingCuiPanel"); -- 精淬
Lua_ForgingPanel = class("Lua_ForgingPanel", Lua_DisplayObject);
function Lua_ForgingPanel:ctor(p)
	self:superCall("ctor", p, "ForgingPanel_skin");
end

function Lua_ForgingPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.initIndex = 1;
	self.isFirstClick = true;

	self.btnNames = Array();
	self.btnNames:add({name = LanUtil.getValue(110550), panel = Lua_QiangHuaPanel, eventIds = {10801}, openId = 10006});
	self.btnNames:add({name = LanUtil.getValue(120570), panel = Lua_ZhuLingPanel, eventIds = {10807, 10808}, openId = 10158});
	self.btnNames:add({name = LanUtil.getValue(110553), panel = Lua_XiLianPanel, openId = 10071});
	self.btnNames:add({name = LanUtil.getValue(120556), panel = Lua_JinJiePanel, eventIds = {10806}, openId = 10154});
	self.btnNames:add({name = LanUtil.getValue(140200), panel = Lua_JingCuiPanel, eventIds = {10813, 10814}, openId = 10188});

	self.forgingList = Lua_ButtonList.new(self.content, self.btnNames, 154, self, self.onButtonListClick,
		"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 148, 66), Vector4(0, 0, 148, 66),
		Lua_ColorDefine.transColor("D2D8DC"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(28, 28, 120, 30), 2, "common_atlas_1");
	self.forgingList:setDepth(5);
	self.forgingList:setRedDotPos(63, 23);
	self.forgingList:setLocation(-540, 250, 0);

	local initIndex = 1;
	local len = self.btnNames:getSize();
	local ForgingWindowData = DataCenter.equData.ForgingWindowData;
	if ForgingWindowData ~= nil and type(ForgingWindowData) == "number" then
		initIndex = ForgingWindowData;
	elseif ForgingWindowData ~= nil and ForgingWindowData.nameIndex ~= nil then
		for i = 1, len do
			if self.btnNames[i].name == LanUtil.getValue(ForgingWindowData.nameIndex) then
				initIndex = i;
				break;
			end
		end
	end
	self.forgingList:setSelected(initIndex, true);

	local isShowIcon;
	for i = 1, len do
		isShowIcon = true;
		if self.btnNames[i].openId == nil or DataCenter.funcOpenData:isOpened(self.btnNames[i].openId) == true then
			self.forgingList:setBtnGray(false, i, isShowIcon);
		else
			local cfg = getConfig({"func_open", self.btnNames[i].openId});
			if cfg ~= nil and cfg.advance_function ~= nil then
				isShowIcon = cfg.advance_function == 1;
			end
			self.forgingList:setBtnGray(true, i, isShowIcon);
		end
	end

	self:onUpdateXiLianIcon();
	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateXiLianIcon);
	self:addLuaEvent("PACK_UPDATE", self, self.onUpdateXiLianIcon);
end

function Lua_ForgingPanel:onUpdateXiLianIcon()
	if DataCenter.funcOpenData:isOpened(10071) == true then
		local item_amount = Lua_CuiLianUtil.getLock_cost(1)[2];
		local item_id = Lua_CuiLianUtil.getLock_cost(1)[1];
		local curNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(item_id);
		if DataCenter.equData.free_polish_times > 0 or curNum >= item_amount then
			self.forgingList:setRedDotStateByIndex(3, true);
		else
			self.forgingList:setRedDotStateByIndex(3, false);
		end
	end
end

function Lua_ForgingPanel:onButtonListClick(val)
	if self.initIndex == val and self.isFirstClick == false then
		return;
	end

	if self.btnNames[val].openId ~= nil and DataCenter.funcOpenData:isOpened(self.btnNames[val].openId) == false then
		local cfg = getConfig({"func_open", self.btnNames[val].openId});
		if cfg ~= nil and cfg.advance_message ~= nil then
			OperateAlert.show(cfg.advance_message);
		end
		return;
	end

	if self.isFirstClick == true then
		self.isFirstClick = false
	end

	self.initIndex = val;
	if self.panel ~= nil then
		self.panel:dispose();
		self.panel = nil;
	end

	if self.btnNames[self.initIndex].panel == nil then
		return;
	end
	self.panel = self.btnNames[self.initIndex].panel.new(self.content)
end

function Lua_ForgingPanel:dispose()
	if self.btnNames ~= nil then
		self.btnNames:dispose();
		self.btnNames:clear();
		self.btnNames = nil;
	end
	if self.forgingList ~= nil then
		self.forgingList:dispose()
		self.forgingList = nil
	end
	DataCenter.equData.ForgingWindowData = nil;

	self:superCall("dispose");
end