checkRequire("Lua_EquipFuLingItem");
Lua_FuLingPanel = class("Lua_FuLingPanel", Lua_DisplayObject);
function Lua_FuLingPanel:ctor(p)
	self:superCall("ctor", p, "FuLingPanel_skin");
end

function Lua_FuLingPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsLbl.text = LanUtil.getValue(128908);
	self:addLuaEvent("onEquipFulingCellClick", self, self.onEquipFulingCellClick);

	self.attrArr = Array();
	self.attrArr_qianghua = Array();
	self.costArr = Array();
	self.parentArr = Array();
	self.parentArr:add(self.duanzaoLeft.mainContent);
	self.parentArr:add(self.duanzaoRight.mainContent);

	self.redDot:setEnable(false);

	self.equip_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 500));
	self.equip_DragList:setListCell(Lua_EquipFuLingItem, 116, 286, 1);
	self.equip_DragList:setLocation(-460, -85, 0);

	self:setListData();
	if self.Arr:getSize() > 0 then
		self.equip_DragList.showList[1]:onPlayerSoundClick();
		self.equip_DragList:setSelected(1);
	end

	self.helpIcon:addClickFuntion(self, self.onHelpClick);
	self.fuLingBtn:addClickFuntion(self, self.onFuLingClick);

	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView);
	self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent);
end

function Lua_FuLingPanel:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(128907));
end

function Lua_FuLingPanel:onFuLingClick()
	if self.data == nil then
		return;
	end

	if self.itemOutPutId == 0 then
		local cmd = getProtoMsg("Proto11400632");
		cmd.part = self.data.equPart;
		sendMsg(11400632, cmd);
	else
		local arr = Array();
		arr:add(Lua_ToolVo.new(self.itemOutPutId, 1, 1));
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end

function Lua_FuLingPanel:setListData()
	self.Arr = Array();
	for i = 12, 1, -1 do
		local _eq = DataCenter.equData:getEquByPart(i);
		if _eq ~= nil then
			self.Arr:add(_eq);
		end
	end
	self.equip_DragList:setLuaArrayData(self.Arr, false);
end

function Lua_FuLingPanel:onEquipFulingCellClick(data)
	self.data = data;
	self:createEquipItem();
end

function Lua_FuLingPanel:onSuccessEvent()
	if self.effectZiTi == nil then
		self.effectZiTi = UICreate.createUIEffect(self.infoBg.mainContent, "/effects/scsEffects/gui_fulingchenggong", "gui_fulingchenggong", 0, -110);
		self.effectZiTi:SetRenderQueue(self.xjylLbl, 10, 2, false);
	else
		self.effectZiTi:setEnable(false);
		self.effectZiTi:setEnable(true);
	end
end

function Lua_FuLingPanel:onUpdateView()
	self:setListData();
	for i = 1, self.Arr:getSize() do
		if self.data.equPart == self.Arr[i].equPart then
			self.data = self.Arr[i];
			break;
		end
	end
	self:createEquipItem();
end

function Lua_FuLingPanel:createEquipItem()
	if self.data == nil then
		return;	
	end

	if self.leftEquipItem == nil then
		self.leftEquipItem = Lua_ToolImage.new(self.infoBg.mainContent);
		self.leftEquipItem:setDepth(4);
		self.leftEquipItem:setLocation(0, 0, 0);
	end
	self.leftEquipItem.data = self.data;
	self:onCreateCostItem();
	self:onInfoPanelChange();
end

function Lua_FuLingPanel:onCreateCostItem()
	local costItemArr = self.data.fuLingCostItem;
	local len = costItemArr:getSize();
	self.itemOutPutId = 0;
	for i = 1, len do
		local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemArr[i].id);
		if self.costArr[i] == nil then
			local item = Lua_ToolImage.new(self.parentArr[i]);
			item.data = costItemArr[i];
			item:setDepth(6);
			item:showNumLimit(hadCount, costItemArr[i].count, 2);
			self.costArr:add(item);
		else
			self.costArr[i].data = costItemArr[i];
			self.costArr[i]:showNumLimit(hadCount, costItemArr[i].count, 2);
		end

		if hadCount < costItemArr[i].count then
			self.itemOutPutId = costItemArr[i].id;
		end
	end

	local objLen = self.costArr:getSize();
	if objLen > len or len == 0 then
		for i = len + 1, objLen do
			self.costArr[i].data = nil;
			self.costArr[i]:setEnable(false);
		end
	end
end

function Lua_FuLingPanel:onInfoPanelChange()
	if self.skillSp == nil then
		self.skillSp = UICreate.createUIAtlasImage(self.skillIconBg.mainContent, "", "", 0, 0, 0, 0);
		self.skillSp:setDepth(7);
	end

	if self.skillSp2 == nil then
		self.skillSp2 = UICreate.createUIAtlasImage(self.skillIconBg2.mainContent, "", "", 0, 0, 0, 0);
		self.skillSp2:setDepth(7);
	end
		self.skillSp:setAltas(self.data.fuLingConfigData.skillAltas, self.data.fuLingConfigData.skillIcon);
		self.skillSp2:setAltas(self.data.fuLingConfigData.skillAltas, self.data.fuLingConfigData.skillIcon);

	if self.data.spirit_level == 0 then
		self.skilldes.text = "";
		self.titleObj3.gameObject:SetActive(true);
		self.skillLvl.text = LanUtil.formateStr(LanUtil.getValue(128909), "0", tostring(self.data.fuLingConfigData.skill_max_lvl));
		self.skillName.text = "[00E125]" .. self.data.fuLingConfigData.skill_name .. " Lv.0";
		self.skilldes2.text = "[85A8BE]" .. self.data.fuLingConfigData.skill_str .. "[00E125]" .. self.data.fuLingConfigData.skill_value * 100 .. "%";
	else
		local configData = self.data:getConfigDataByPartAndLvl(self.data.equPart, self.data.spirit_level, 2);
		self.skilldes.text = "[85A8BE]" .. configData.skill_str .. configData.skill_value * 100 .. "%";
		self.skillLvl.text = LanUtil.formateStr(LanUtil.getValue(128909), tostring(configData.skill_lvl_show), tostring(configData.skill_max_lvl));
		self.skillName.text = "[00E125]" .. configData.skill_name .. " Lv." .. configData.skill_lvl_show;
		local configData2 = self.data:getConfigDataByPartAndLvl(self.data.equPart, self.data.spirit_level + 1, 2);
		if configData2 ~= nil and self.data.spirit_level ~= self.data.theMaxFuLingLvl then
			self.titleObj3.gameObject:SetActive(true)
			self.skilldes2.text = "[85A8BE]" .. self.data.fuLingConfigData.skill_str .. "[00E125]" .. configData2.skill_value * 100 .. "%";
		else
			self.titleObj3.gameObject:SetActive(false);
			self.skilldes2.text = "";
		end
	end

	if self.data.isCanFuLing == false then
		self.fuLingBtn:setBtnEnable(false);
		self.xjylLbl.text = self.data.fuLingTxtShow;
		self.redDot:setEnable(false);
	else
		if self.itemOutPutId == 0 and self.data.maxFuLingLvl > self.data.spirit_level then
			self.redDot:setEnable(true);
		else
			self.redDot:setEnable(false);
		end

		if self.data.spirit_level == self.data.theMaxFuLingLvl then
			self.fuLingBtn.label = LanUtil.getValue(128912);
			self.fuLingBtn:setBtnEnable(false);
			self.xjylLbl.text = LanUtil.getValue(128910) .. self.data.spirit_level;
		else
			self.fuLingBtn.label = LanUtil.getValue(128913);
			self.fuLingBtn:setBtnEnable(true);
			if self.data.maxFuLingLvl ~= self.data.spirit_level then
				self.xjylLbl.text = LanUtil.getValue(128910) .. self.data.spirit_level;
			else
				self.xjylLbl.text = self.data.max_fuling_show;
			end
		end
	end
end

function Lua_FuLingPanel:dispose()
	if self.equip_DragList ~= nil then
		self.equip_DragList:dispose();
		self.equip_DragList = nil;
	end
	self:superCall("dispose");
end