Lua_HeChengEquipSelectedItem = class("Lua_HeChengEquipSelectedItem", Lua_ListCell);
function Lua_HeChengEquipSelectedItem:ctor(p)
	self:superCall("ctor", p, "HeChengEquipSelectedItem_skin");
end

function Lua_HeChengEquipSelectedItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-73, 3, 0);
end

function Lua_HeChengEquipSelectedItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local equipVo = Lua_ToolVo.new(data.output, 1);
	equipVo.star = data.star;
	self.itemImg.data = equipVo;

	self.itemImg:showBetterTip(0);
	if equipVo.useLvl <= DataCenter.roleData.level and equipVo.profession <= DataCenter.roleData.profession
		and (equipVo.career == 0 or equipVo.career == DataCenter.roleData.career) then
		local myEqu = DataCenter.equData:getEquByPart(equipVo.part);
		if myEqu == nil then
			self.itemImg:showBetterTip(2);
		else
			if equipVo.score > myEqu.score then
				self.itemImg:showBetterTip(2);
			end
		end
	end
	
	self.equipName.text = equipVo.colorName;
	self.mtCount.text = LanUtil.formateStr(LanUtil.getValue(120569), tostring(data.materialsCount));

	self:checkRedDot();
end

function Lua_HeChengEquipSelectedItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onEquipItemClick", self._data);
end

function Lua_HeChengEquipSelectedItem:checkRedDot(go)
	self.redDot:setEnable(self._data.partRedDot);
end

function Lua_HeChengEquipSelectedItem:dispose(go)
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;
	
	self:superCall("dispose");
end