Lua_JinJieItem = class("Lua_JinJieItem", Lua_ListCell);
function Lua_JinJieItem:ctor(p)
	self:superCall("ctor", p, "JinJieItem_skin");
end

function Lua_JinJieItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-93.5, 2.5, 0);
end

function Lua_JinJieItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if  self._data.id == 0  then
		self:itemIsLock();
	elseif self._data.order>=Lua_JinJieUtil.getMax_class() then
		self:itemIsLock();
	else
		self.itemImg.data = data;
		self.lockIcon.mainContent:SetActive(false)
		self._data.isLock = false   
		self.maxLvl = self._data.maxLvl;
		if self.itemImg.data.order >= Lua_JinJieUtil.getClass_limit() and self.itemImg.data.color >= Lua_JinJieUtil.getColor_limit() and self.itemImg.data.star>=Lua_JinJieUtil.getStar_limit()  then      
			self._data.isLock=false
			if data.intensifyLevel == 0 then
				self.itemTxt.text = self.itemImg.data.colorName
			elseif data.intensifyLevel == self.maxLvl then
				self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.intensifyLevel .. "(MAX)";
			else
				self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.intensifyLevel;
			end
			self.redDot:setEnable(self:checkRedDot())
		else
			self:itemIsLock()
		end
	end

	self.itemBg:setAltas("common_atlas_1", data.selected and "ui_common_widget_x1" or "ui_common_widget_x2")
end

function Lua_JinJieItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onJinJieCellClick", self._data);
end

function Lua_JinJieItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_JinJieItem:itemIsLock()
	self.lockIcon.mainContent:SetActive(true);
	self._data.isLock = true
	self.itemImg.data = nil;
	self.itemTxt.text = LanUtil.formateStr(LanUtil.getValue(120557), tostring(Lua_JinJieUtil.getEquip_part(self._data.equPart)))
	self.itemTipsTxt.text = LanUtil.formateStr(LanUtil.getValue(120559),tostring(Lua_JinJieUtil.getClass_limit()),tostring(Lua_JinJieUtil.getColor(Lua_JinJieUtil.getColor_limit())),tostring(Lua_JinJieUtil.getStar_limit()), tostring(Lua_JinJieUtil.getEquip_part(self._data.equPart)))
	self.redDot:setEnable(false)
end

function Lua_JinJieItem:checkRedDot()
	if self._data==nil  then
		return false
	else
		local costId = Lua_JinJieUtil.getCostid(self._data.equPart, self._data.order)
		local costAmount= Lua_JinJieUtil.getCostcount(self._data.equPart, self._data.order)
		local curNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costId)
		if curNum >= costAmount then
			return true
		else 
			return false
		end
	end
end

function Lua_JinJieItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end
