Lua_JingCuiItem = class("Lua_JingCuiItem", Lua_ListCell);
function Lua_JingCuiItem:ctor(p)
	self:superCall("ctor", p, "EquipJueXingItem_skin");
end

function Lua_JingCuiItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-93.5, 2.5, 0);
end

function Lua_JingCuiItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data;
	self.itemTxt.text = data.colorName;

	if data.polish_open == false or data.polish_open_siz <= 0 then
		self.itemTipsTxt.text = "[FF1616]" .. LanUtil.getValue(140208);
	else
		self.itemTipsTxt.text = "[85A8BE]" .. LanUtil.getValue(140202) .. data.jingcui_level;
	end
	self.redDot:setEnable(self:checkRedot() and data.jingcui_level ~= data.theMaxJingCuiLvl);
end

function Lua_JingCuiItem:checkRedot()
	local packData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local costItemArr = self._data.jingCuiCostItem;
	for i = 1, costItemArr:getSize() do
		if packData:getItemNum(costItemArr[i].id) < costItemArr[i].count then
			return false;
		end
	end
	return true;
end

function Lua_JingCuiItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onEquipJingCuiCellClick", self._data);
end

function Lua_JingCuiItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_JingCuiItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end