checkRequire("Lua_JingCuiItem")
Lua_JingCuiPanel = class("Lua_JingCuiPanel", Lua_DisplayObject);
function Lua_JingCuiPanel:ctor(p)
	self:superCall("ctor", p, "JingCuiPanel_skin");
end

function Lua_JingCuiPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsLab.text = LanUtil.getValue(140201);
	self.costTXt.text = LanUtil.getValue(140203);

	self.attrName = getConfig({"attr_common"});
	self.itemOutPutId = 0;
	self.costArr = Array();
	self.redDot:setEnable(false);

	self.desLabArr = Array();
	self.desLabArr:add(self.desLab1);
	self.desLabArr:add(self.desLab2);
	self.desLabArr:add(self.desLab3);
	self.desLabArr:add(self.desLab4);
	self.desLabArr:add(self.desLab5);

	self.upObjArr = Array();
	self.upObjArr:add(self.upObj1);
	self.upObjArr:add(self.upObj2);
	self.upObjArr:add(self.upObj3);
	self.upObjArr:add(self.upObj4);
	self.upObjArr:add(self.upObj5);

	self.leftEquipItem = Lua_ToolImage.new(self.duanzao.mainContent);
	self.leftEquipItem:setDepth(4);

	self.jingcuiList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 500));
	self.jingcuiList:setListCell(Lua_JingCuiItem, 116, 286, 1);
	self.jingcuiList:setLocation(-460, -85, 0);
	self:updateShowJingCuiList();

	self:addLuaEvent("onEquipJingCuiCellClick", self, self.onJingCuiCellClick);
	if self.equipVoArr:getSize() > 0 then
		self.jingcuiList.showList[1]:onPlayerSoundClick();
		self.jingcuiList:setSelected(1);
	end

	self.ruleIcon:addClickFuntion(self, self.onRuleClick);
	self.jingcuiBtn:addClickFuntion(self, self.onJingCuiClick);

	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView); -- 装备信息（返回）
	self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent); -- 精粹返回
end

function Lua_JingCuiPanel:updateShowJingCuiList()
	local equipVo;
	self.equipVoArr = Array();
	for i = 12, 1, -1 do
		equipVo = DataCenter.equData:getEquByPart(i);
		if equipVo ~= nil then
			self.equipVoArr:add(equipVo);
		end
	end
	self.jingcuiList:setLuaArrayData(self.equipVoArr, false);
end

function Lua_JingCuiPanel:onJingCuiCellClick(data)
	self.equipVo = data;
	self:createEquipItem();
end

function Lua_JingCuiPanel:createEquipItem()
	self.leftEquipItem.data = self.equipVo;
	self.lvlTxt.text = "[85A8BE]" .. LanUtil.getValue(140202) .. self.equipVo.jingcui_level;

	self:onCreateCostItem();
	self:onShowAttr();
	self:onChangeBtn();
end

function Lua_JingCuiPanel:onCreateCostItem()
	local costItemArr = self.equipVo.jingCuiCostItem;
	local len = costItemArr:getSize();
	local packData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local hadCount;
	local item;
	self.itemOutPutId = 0;
	for i = 1, len do
		hadCount = packData:getItemNum(costItemArr[i].id);
		item = self.costArr[i];
		if item == nil then
			item = Lua_ToolImage.new(self.content);
			item:setDepth(6);
			item:setLocation(-50 + (i - 1) * 90, -270, 0);
			self.costArr:add(item);
		end
		item.data = costItemArr[i];
		item:showNumLimit(hadCount, costItemArr[i].count, 2);
		item:setEnable(true);

		if hadCount < costItemArr[i].count then
			self.itemOutPutId = costItemArr[i].id
		end
	end

	local objLen = self.costArr:getSize();
	if objLen > len or len == 0 then
		for i = len + 1, objLen do
			self.costArr[i]:setEnable(false)
		end
	end
end

function Lua_JingCuiPanel:onShowAttr()
	self.next_jingCuiConfig = self.equipVo:getConfigDataByPartAndLvl(self.equipVo.equPart, self.equipVo.jingcui_level + 1, 3)
	self.cur_jingCuiConfig = self.equipVo:getConfigDataByPartAndLvl(self.equipVo.equPart, self.equipVo.jingcui_level, 3)
	local attrList = {}
	local _arr = self.equipVo.wash_attrs;
	for i = 1, #_arr do
		if _arr[i].open == true then
			if _arr[i].attr.attr_id ~= 0 then
				local configData = self.attrName[_arr[i].attr.attr_id];
				local percent_valueStr = "";
				if configData.show_percent ~= nil and configData.show_percent == 1 then
					percent_valueStr = "%";
				end

				local value = 0;
				if self.cur_jingCuiConfig ~= nil then
					value = self.cur_jingCuiConfig[configData.attr_english];
				end

				if self.next_jingCuiConfig ~= nil then
					self.upObjArr[i]:SetActive(true);
					self["upTxt"..i].text = "[00E125]" .. (self.next_jingCuiConfig[configData.attr_english] - value) .. "%";
				else
					self.upObjArr[i]:SetActive(false);
				end

				local offsetValue = math.floor(_arr[i].attr.value * value / 100);
				if configData.show_percent == 1 then
					offsetValue = string.format("%.3f", _arr[i].attr.value * value / 100);
				end
				attrList[configData.attr_english] = tonumber(offsetValue);

				self.desLabArr[i].text = "[" .. Lua_ColorDefine.getItemColorStr(_arr[i].attr.color) .. "]"
					.. configData.common .. "+" .. _arr[i].attr.value .. percent_valueStr
					.. "[85A8BE] [+" .. offsetValue .. percent_valueStr .. "]";

				if i == 3 then
					self.jingcuiBg3:removeClickFuntion(self, self.onxlcClick);
				elseif i == 4 then
					self.jingcuiBg4:removeClickFuntion(self, self.onxlcClick);
				elseif i == 5 then
					self.jingcuiBg5:removeClickFuntion(self, self.onxlcClick);
				end
			else
				self.desLabArr[i].text = LanUtil.getValue(110573)
			end
		else
			self.upObjArr[i]:SetActive(false);
			if self.equipVo.polish_open_siz <= 0 then
				self.desLabArr[i].text = "[FF1616]" .. LanUtil.getValue(140208);
				if i == 3 then
					self.jingcuiBg3:removeClickFuntion(self, self.onxlcClick);
				elseif i == 4 then
					self.jingcuiBg4:removeClickFuntion(self, self.onxlcClick);
				elseif i == 5 then
					self.jingcuiBg5:removeClickFuntion(self, self.onxlcClick);
				end
			else
				self.desLabArr[i].text = LanUtil.getValue(110573);
				if i == 3 then
					self.jingcuiBg3:addClickFuntion(self, self.onxlcClick);
				elseif i == 4 then
					self.jingcuiBg4:addClickFuntion(self, self.onxlcClick);
				elseif i == 5 then
					self.jingcuiBg5:addClickFuntion(self, self.onxlcClick);
				end
			end
		end
	end
	self.gradeLab.text = Lua_FightUtil.caculateConfigForce(attrList);
	self.attrObj5:SetActive(self.equipVo.star == 4)
end

function Lua_JingCuiPanel:onChangeBtn()
	if self.equipVo.jingcui_level == self.equipVo.theMaxJingCuiLvl then
		self.jingcuiBtn.label = LanUtil.getValue(140204);
		self.jingcuiBtn:setEnable(false);
		self.redDot:setEnable(false);
		self.maxTipsLab:setEnable(true);
	else
		if self.cur_jingCuiConfig == nil or self.cur_jingCuiConfig.is_surpass == 0 then
			self.jingcuiBtn.label = LanUtil.getValue(140204);
		else
			self.jingcuiBtn.label = LanUtil.getValue(140205);
		end
		self.jingcuiBtn:setEnable(true);
		self.redDot:setEnable(self.itemOutPutId == 0);
		self.maxTipsLab:setEnable(false);
	end
end

function Lua_JingCuiPanel:onUpdateView()
	self:updateShowJingCuiList();
	for i = 1, self.equipVoArr:getSize() do
		if self.equipVo.equPart == self.equipVoArr[i].equPart then
			self.equipVo = self.equipVoArr[i];
			break;
		end
	end
	self:createEquipItem();
end

function Lua_JingCuiPanel:onSuccessEvent()
	if self.cur_jingCuiConfig == nil or self.cur_jingCuiConfig.is_surpass == 0 then
		self:onPlayEffect("/effects/scsEffects/gui_jingcuichenggong", "gui_jingcuichenggong")
	elseif self.cur_jingCuiConfig.is_surpass == 1 then
		self:onPlayEffect("/effects/scsEffects/gui_tupochenggong", "gui_tupochenggong")
	end
end

function Lua_JingCuiPanel:onPlayEffect(path, name)
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.attitudeBg.mainContent, path, name, 0, -175);
		self.effect:SetRenderQueue(self.lvlTxt, 5, 2, false);
	end
	self.effect:setUrl(path, name)
	self.effect:setEnable(false);
	self.effect:setEnable(true);
end

function Lua_JingCuiPanel:onxlcClick(go)
	if self.equipVo.id == 0 then
		return;
	end

	-- string.sub -1是最后一个字符串
	self.polish_index = tonumber(string.sub(go.name, -1, -1)) - 1;
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
		owner = self,
		des = LanUtil.formateStr(LanUtil.getValue(110598), tostring(100)),
		type = 1,
		subFun = self.onSubCallback
	});
end

function Lua_JingCuiPanel:onSubCallback(go)
	local cmd = ProtoPublic_pb.Proto11400620();
	cmd.part = self.equipVo.part;
	cmd.polish_index = self.polish_index;
	sendMsg(11400620, cmd);
end

function Lua_JingCuiPanel:onRuleClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(140206));
end

function Lua_JingCuiPanel:onJingCuiClick()
	if self.equipVo == nil then
		return;
	end

	if self.equipVo.polish_open_siz <= 0 then
		OperateAlert.show(LanUtil.getValue(140207));
		return;
	end

	if self.itemOutPutId == 0 then
		local cmd = getProtoMsg("Proto11400633");
		cmd.part = self.equipVo.equPart;
		sendMsg(11400633, cmd)
	else
		local arr = Array();
		arr:add(Lua_ToolVo.new(self.itemOutPutId, 1, 1));
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end

function Lua_JingCuiPanel:dispose()
	if self.leftEquipItem ~= nil then
		self.leftEquipItem:dispose();
		self.leftEquipItem = nil;
	end
	if self.jingcuiList ~= nil then
		self.jingcuiList:dispose();
		self.jingcuiList = nil;
	end
	self:superCall("dispose");
end