Lua_JingLianItem = class("Lua_JingLianItem", Lua_ListCell);
function Lua_JingLianItem:ctor(p)
	self:superCall("ctor", p, "XiangQianItem_skin");
end

function Lua_JingLianItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-93.5, 2.5, 0);

	self.kongdiArr = Array();
	self.kongdiArr:add(self.kongdi1);
	self.kongdiArr:add(self.kongdi2);
	self.kongdiArr:add(self.kongdi3);
	self.kongdiArr:add(self.kongdi4);
	self.kongdiArr:add(self.kongdi5);
	self.kongdiArr:add(self.kongdi6);

	self.hongbaoshiArr = Array();
	self.hongbaoshiArr:add(self.hongdi1);
	self.hongbaoshiArr:add(self.hongdi2);
	self.hongbaoshiArr:add(self.hongdi3);
	self.hongbaoshiArr:add(self.hongdi4);
	self.hongbaoshiArr:add(self.hongdi5);
	self.hongbaoshiArr:add(self.hongdi6);

	self.lanbaoshiArr = Array();
	self.lanbaoshiArr:add(self.landi1);
	self.lanbaoshiArr:add(self.landi2);
	self.lanbaoshiArr:add(self.landi3);
	self.lanbaoshiArr:add(self.landi4);
	self.lanbaoshiArr:add(self.landi5);
	self.lanbaoshiArr:add(self.landi6);
end

function Lua_JingLianItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = self._data;
	self.maxLvl = self._data.maxLvl;

	if self._data.jewl_Level == 0 then
		self.itemTxt.text = self.itemImg.data.colorName
	else
		self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.jewl_Level;
	end

	self.count = DataCenter.equData:getJewf_countHoleByPart(self._data.equPart);
	self.count2 = DataCenter.equData:getJewf_countByPart(self._data.equPart);
	self.jewlCount = 0;
	for i = 1, self.count do
		if i <= self.count2 then
			self.kongdiArr[i].mainContent:SetActive(true);
		else
			self.kongdiArr[i].mainContent:SetActive(false);
		end

		if self._data.jewel[i].id > 0 then
			self.jewlCount = self.jewlCount + 1
		end
		self.hongbaoshiArr[i].mainContent:SetActive(false);
		self.lanbaoshiArr[i].mainContent:SetActive(false);
    end

	self.isRed = false;
	for i = 1, self.count do
		if self._data.jewel[i].id > 0 then
			if Lua_ToolVo.new(self._data.jewel[i].id, 0, 0).subType == 101 then
				self.isRed = true;
				break;
			end
		end
	end

	for i = 1, self.jewlCount do
		if self.isRed == true then
			self.hongbaoshiArr[i].mainContent:SetActive(true);
			self.lanbaoshiArr[i].mainContent:SetActive(false);
		else
			self.hongbaoshiArr[i].mainContent:SetActive(false);
			self.lanbaoshiArr[i].mainContent:SetActive(true);
		end
	end

	-- self.itemBg:setAltas("common_atlas_1", data.selected and "ui_common_widget_x1" or "ui_common_widget_x2");
	self:showRedDot();
end

function Lua_JingLianItem:showRedDot()
	self._data.jewlRedDot = self:checkRedDot();
	self.redDot:setEnable(self._data.jewlRedDot);
end

function Lua_JingLianItem:checkRedDot()
	if self._data.maxJewlState == true then
		return false;
	end

	local costType = self._data.jwelType
	local costItemList = DataCenter.equData.jwelCostConig[costType]["cost_level"];
	local len = #costItemList
	for i = 1, len do
		local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemList[i][1]);
		if hadCount > 0 then
			return true
		end
	end
	return false
end

function Lua_JingLianItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onJingLianCellClick", self._data);
end

function Lua_JingLianItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_JingLianItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;
	
    self:superCall("dispose");
end