checkRequire("Lua_JingLianItem")
checkRequire("Lua_AttrTxtInfoPanel")
Lua_JingLianPanel = class("Lua_JingLianPanel", Lua_DisplayObject);
function Lua_JingLianPanel:ctor(p)
	self:superCall("ctor", p, "JingLianPanel_skin");
end

function Lua_JingLianPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.ItemList = Array();
	self.isClick = false;
	self.itemOutPutId = 0;

	self.autoClickBtn:addClickFuntion(self, self.onAutoClickBtn);
	self.jingLianClickBtn:addClickFuntion(self, self.onJingLianClickBtn);

	self.tipsLbl.text = LanUtil.getValue(120583);
	self.maxTxt:setEnable(false);

	self:addLuaEvent("onJingLianCellClick", self, self.onJingLianCellClick);
	self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent);

	self.suo_Arr = Array()
	self.suo_Arr:add(self.suo1);
	self.suo_Arr:add(self.suo2);
	self.suo_Arr:add(self.suo3);
	self.suo_Arr:add(self.suo4);
	self.suo_Arr:add(self.suo6);
	self.suo_Arr:add(self.suo5);
	self.suo_Arr[1].mainContent:SetActive(false);
	self.suo_Arr[2].mainContent:SetActive(false);

	self.duanzaoBG_Arr = Array();
	self.duanzaoBG_Arr:add(self.forging_duanzao1);
	self.duanzaoBG_Arr:add(self.forging_duanzao2);
	self.duanzaoBG_Arr:add(self.forging_duanzao3);
	self.duanzaoBG_Arr:add(self.forging_duanzao4);
	self.duanzaoBG_Arr:add(self.forging_duanzao6);
	self.duanzaoBG_Arr:add(self.forging_duanzao5);

	self.redDot:setEnable(false);

	self:createDragList();
	self:setListData();
	if self.Arr:getSize() > 0 then
		self.jingLian_DragList.showList[1]:onPlayerSoundClick();
		self.jingLian_DragList:setSelected(1);
	end
	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView);
end

function Lua_JingLianPanel:createDragList()
	self.jingLian_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 542));
	self.jingLian_DragList:setListCell(Lua_JingLianItem, 116, 286, 1);
	self.jingLian_DragList:setLocation(-460, -70, 0);

	self.txt_dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 264, 166));
	self.txt_dragContainer:setLocation(370, 56, 0);
	self.attrInfoPanel = Lua_AttrTxtInfoPanel.new(self.txt_dragContainer);
end

function Lua_JingLianPanel:onJingLianClickBtn()
	if self.data == nil then
		return
	end
	self.curPart = self.data.equPart;
	self:onSendMsg()
end

function Lua_JingLianPanel:onAutoClickBtn()
	if self.data == nil then
		return
	end

	self.curPart = self.data.equPart;
	if self.ItemList[self.selectedIndex].hadCount ~= 0 then
		self.isClick = not self.isClick;
		if self.isClick == true then
			self.autoClickBtn.label = LanUtil.getValue(120580);
			Lua_CommonUtil.addTimer("onSendMsgKey", 0.3, self, self.onSendMsg, nil);
		else
			self.autoClickBtn.label = LanUtil.getValue(120579);
			Lua_CommonUtil.removeTimer(self, self.onSendMsg);
		end
	else
		local arr = Array();
		arr:add(self.ItemList[self.selectedIndex].item.data);
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end

function Lua_JingLianPanel:onSendMsg()
	if self.ItemList[self.selectedIndex].hadCount ~= 0 then
		local cmd = getProtoMsg("Proto11400629");
		cmd.part = self.data.equPart;
		cmd.auto_refine = false
		-- 选择的消耗品等级0未选择1初级2中级3高级
		cmd.cost_level = self.selectedIndex
		sendMsg(11400629, cmd)
	else
		self.autoClickBtn.label = LanUtil.getValue(120579);
		Lua_CommonUtil.removeTimer(self, self.onSendMsg);
		local arr = Array();
		arr:add(self.ItemList[self.selectedIndex].item.data);
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end

function Lua_JingLianPanel:onSuccessEvent(msg)
	if msg ~= nil and msg.is_upgrade == true then
		self:onJingLianEffect()
	end
end

function Lua_JingLianPanel:onJingLianEffect()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.infoBg.mainContent, "/effects/scsEffects/gui_jinglianchenggong", "gui_jinglianchenggong", 0, 0);
	else
		self.effect.mainContent:SetActive(false);
		self.effect.mainContent:SetActive(true);
	end
	self.effect:SetRenderQueue(self.lvlText, 15, 2, false);
end

function Lua_JingLianPanel:onJingLianCellClick(data)
	self.data = data
	if self.curPart == self.data.equPart then
		return
	end
	self:createEquipItem()
end

function Lua_JingLianPanel:onUpdateView()
	self:setListData()
	local len = self.Arr:getSize()
	for i = 1, len do
		if self.data.equPart == self.Arr[i].equPart then
			self.data = self.Arr[i]
			break
		end
	end
	self:createEquipItem()
end

function Lua_JingLianPanel:setListData()
	self.Arr = Array();
	for i = 12, 1, -1 do
		local _eq = DataCenter.equData:getEquByPart(i);
		if _eq ~= nil and _eq.hasJewl == true then
			self.Arr:add(_eq);
		end
	end
	self.jingLian_DragList:setLuaArrayData(self.Arr, false);
end

function Lua_JingLianPanel:createEquipItem()
	if self.data == nil then
		return
	end

	self:onCellDispose()
	if self.rightEquipItem == nil then
		self.rightEquipItem = Lua_ToolImage.new(self.infoBg.mainContent);
		self.rightEquipItem:setDepth(4);
		self.rightEquipItem:setLocation(0, 0, 0);
	end
	self.rightEquipItem.data = self.data

	self.lvlText.text = LanUtil.formateStr(LanUtil.getValue(120581), tostring(self.data.jewl_Level))

	if self.goArr == nil then
		self.goArr = Array();
	else
		for i = 1, self.goArr:getSize() do
			self.goArr[i]:dispose();
		end
	end

	self.count = DataCenter.equData:getJewf_countHoleByPart(self.data.equPart);
	for i = 1, self.count do
		local index = i;
		if i == 5 then
			index = i + 1
		elseif i == 6 then
			index = i - 1
		end

		if self.data.jewel[i].id > 0 then
			self.jewfImg = Lua_ToolImage.new(self.duanzaoBG_Arr[index].mainContent);
			self.jewfImg:setDepth(6);
			self.jewfImg:setLocation(0, 0, 0);
			self.jewfImg.content.name = i;
			self.jewfImg:setCanClick(true);
			self.jewfImg.data = Lua_ToolVo.new(self.data.jewel[i].id, 0, 0);
			self.goArr:add(self.jewfImg);
			-- 去掉锁 加号
			self.suo_Arr[index].mainContent:SetActive(false);
		elseif self.data.jewel[i].id == 0 then
			self.suo_Arr[index].mainContent:SetActive(false);
		elseif self.data.jewel[i].id == -1 then
			self.suo_Arr[index].mainContent:SetActive(true);
		end
	end
	self:showProgress()
	self:showCostItem()
	self:showMaxState()
	self:showAttr()
end

function Lua_JingLianPanel:showProgress()
	self.shuLianDuBar:setText(self.data.jewl_Progress .. "/" .. self.data.jwelProgress)
	self.shuLianDuBar:setMaxValue(self.data.jwelProgress)
	self.shuLianDuBar:setValue(self.data.jewl_Progress)
end

function Lua_JingLianPanel:showCostItem()
	local costType = self.data.jwelType
	local costItemList = DataCenter.equData.jwelCostConig[costType]["cost_level"];
	local len = #costItemList
	for i = 1, len do
		if self.ItemList[i] == nil then
			local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemList[i][1]);

			local item = Lua_ToolImage.new(self.itemContainer.gameObject);
			item:setDepth(7);
			item:setLocation(280 +(i - 1) * 90, -165, 0);
			item.data = Lua_ToolVo.new(costItemList[i][1])
			item.content.name = i
			item:showNumLimit(hadCount, 1, 2)
			item:removeFun(false)
			item.item_bg:addClickFuntion(self, self.onIconClick);

			local selected_mask = UICreate.createUIAtlasImage(item.item_bg.mainContent, "common_atlas_1", "ui_common_xzk", 0, 0, 100, 100);
			selected_mask:setDepth(8);
			selected_mask:setEnable(false);

			self.ItemList:add({item = item, index = i, hadCount = hadCount, selected_mask = selected_mask})
		else
			self.ItemList[i].item.data = Lua_ToolVo.new(costItemList[i][1])
			local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemList[i][1]);
			self.ItemList[i].item:showNumLimit(hadCount, 1, 2)
			self.ItemList[i].index = i
			self.ItemList[i].hadCount = hadCount
		end
	end

	local objLen = self.ItemList:getSize();
	if objLen > len then
		for i = len + 1, objLen do
			self.ItemList[i].item:dispose()
			self.ItemList[i] = nil
		end
	end
	self:onFirstSelected()
end

function Lua_JingLianPanel:showMaxState()
	if self.data.maxJewlState then
		self.maxTxt:setEnable(true)
		self.itemContainer.gameObject:SetActive(false)
	else
		self.maxTxt:setEnable(false)
		self.itemContainer.gameObject:SetActive(true)
	end
	self.redDot:setEnable(self.data.jewlRedDot);
end

function Lua_JingLianPanel:onCellDispose()
	if self.data == nil then
		return
	end

	if self.curPart ~= self.data.equPart then
		self.isClick = false
		self.autoClickBtn.label = LanUtil.getValue(120579);
		Lua_CommonUtil.removeTimer(self, self.onSendMsg);
	end
end

function Lua_JingLianPanel:onFirstSelected()
	if self.curPart ~= self.data.part then
		local len = self.ItemList:getSize()
		self.selectedIndex = 1
		for i = 1, len do
			if self.ItemList[i].hadCount ~= 0 then
				self.selectedIndex = i
				self.hasRedDot = true
				break
			end
		end
		self:onSelectedByIndex(self.selectedIndex)
	end
	self.curPart = self.data.equPart
end

function Lua_JingLianPanel:onIconClick(go)
	local index = tonumber(go.transform.parent.name)
	if self.selectedIndex ~= index then
		self:onSelectedByIndex(index)
	else
		Lua_PackUtil.showItemInfo(self.ItemList[index].item.data, false);
	end
end

function Lua_JingLianPanel:onSelectedByIndex(value)
	local index = value
	local len = self.ItemList:getSize()
	for i = 1, len do
		if i == index then
			-- self.ItemList[i].tickImg:setEnable(true);
			self.ItemList[i].selected_mask:setEnable(true);
			self.selectedIndex = self.ItemList[i].index
		else
			-- self.ItemList[i].tickImg:setEnable(false);
			self.ItemList[i].selected_mask:setEnable(false);
		end
	end
end

function Lua_JingLianPanel:showAttr()
	local baoshi_Arr = Array()
	local attrList = {}
	for i = 1, self.count do
		if self.data.jewel[i].id > 0 then
			local jewel_AttrList = Lua_ToolVo.new(self.data.jewel[i].id).attribute
			for k, v in ipairs(Lua_ThingDefine.params) do
				for key, value in pairs(jewel_AttrList) do
					if v == key then
						if attrList[key] == nil then
							attrList[key] = value
						else
							attrList[key] = attrList[key] + value
						end
					end
				end
			end
		end
	end

	local attrListLen = #attrList
	local arr = Array();
	local level = self.data.jewl_Level + 1
	if self.data.jewl_Level == 0 then
		level = 1
	elseif self.data.maxJewlState == true then
		level = self.data.jewl_Level
	end

	local Attribute_percent1 = 0
	local Attribute_percent2 = 0
	if self.data.maxJewlState == true then
		Attribute_percent2 = DataCenter.equData.jwelCostConig[self.data.jwelType]["Attribute_percent"][self.data.jewl_Level]
	else
		Attribute_percent2 = DataCenter.equData.jwelCostConig[self.data.jwelType]["Attribute_percent"][level]
	end

	if self.data.jewl_Level == 0 then
		Attribute_percent1 = 0;--DataCenter.equData.jwelCostConig[self.data.jwelType]["Attribute_percent"][1]
	else
		Attribute_percent1 = DataCenter.equData.jwelCostConig[self.data.jwelType]["Attribute_percent"][self.data.jewl_Level]
	end

	for key, value in pairs(attrList) do
		local list = {}
		list.attrName = Lua_ThingDefine.getParamName(key)
		list.value = math.floor(value *(1 + Attribute_percent1 / 100))
		list.addValue = math.floor(value *(Attribute_percent2 - Attribute_percent1) / 100)
		list.rank = Lua_ThingDefine.getParaRankByParams(key)
		arr:add(list)
	end

	arr:add({attrName = LanUtil.getValue(120582), value = Attribute_percent1.."%", addValue =(Attribute_percent2 - Attribute_percent1).."%", rank = 99});
	arr:sort("rank", false)
	self.attrInfoPanel:setTextData(arr, self.data.maxJewlState)
end

function Lua_JingLianPanel:dispose()
	if self.jingLian_DragList ~= nil then
		self.jingLian_DragList:dispose();
		self.jingLian_DragList = nil;
	end
	if self.right_DragList ~= nil then
		self.right_DragList:dispose();
		self.right_DragList = nil;
	end
	for i = 1, self.ItemList:getSize() do
		self.ItemList[i].item:dispose();
		self.ItemList[i].selected_mask:dispose();
	end
	self.ItemList:clear();
	Lua_CommonUtil.removeTimer(self, self.onSendMsg);

	self:superCall("dispose");
end