checkRequire("Lua_EquipJueXingItem")
checkRequire("Lua_JueXingTaoZhuangInfo")
Lua_JueXingPanel = class("Lua_JueXingPanel", Lua_DisplayObject);
function Lua_JueXingPanel:ctor(p)
	self:superCall("ctor", p, "JueXingPanel_skin");
end

function Lua_JueXingPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsLbl.text = LanUtil.getValue(128901)
	self:addLuaEvent("onEquipJueXingCellClick", self, self.onEquipJueXingCellClick)

	self.attrArr = Array()
	self.attrArr_qianghua = Array()
	self.costArr = Array()
	self.parentArr = Array()
	self.parentArr:add(self.duanzaoLeft.mainContent)
	self.parentArr:add(self.duanzaoRight.mainContent)
	
	self.redDot:setEnable(false);

	self.equip_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 500));
	self.equip_DragList:setListCell(Lua_EquipJueXingItem, 116, 286, 1);
	self.equip_DragList:setLocation(-460, -85, 0);

	-- 暂时屏蔽套装
	self.titleObj3:SetActive(false)
	-- self.txt_dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 292, 136));
	-- self.txt_dragContainer:setLocation(360, -175, 0);
	-- self.taoZhuangInfoPanel = Lua_JueXingTaoZhuangInfo.new(self.txt_dragContainer);

	self:setListData()
	if self.Arr:getSize() > 0 then
		self.equip_DragList.showList[1]:onPlayerSoundClick();
		self.equip_DragList:setSelected(1);
	end

	self.helpIcon:addClickFuntion(self, self.onHelpClick);
	self.juexingBtn:addClickFuntion(self, self.onJueXingClick);

	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView);
	self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent);
end

function Lua_JueXingPanel:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(128902));
end

function Lua_JueXingPanel:onJueXingClick()
	if self.data == nil then
		return;
	end

	if self.itemOutPutId == 0 then
		local cmd = getProtoMsg("Proto11400631");
		cmd.part = self.data.equPart;
		sendMsg(11400631, cmd);
	else
		local arr = Array();
		arr:add(Lua_ToolVo.new(self.itemOutPutId, 1, 1));
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end

function Lua_JueXingPanel:setListData()
	self.Arr = Array();
	for i = 12, 1, -1 do
		local _eq = DataCenter.equData:getEquByPart(i);
		if _eq ~= nil then
			self.Arr:add(_eq);
		end
	end
	self.equip_DragList:setLuaArrayData(self.Arr, false);
end

function Lua_JueXingPanel:onEquipJueXingCellClick(data)
	self.data = data
	self:createEquipItem()
end

function Lua_JueXingPanel:onSuccessEvent()
	if self.effectZiTi == nil then
		self.effectZiTi = UICreate.createUIEffect(self.infoBg.mainContent, "/effects/scsEffects/gui_shenlianchenggong", "gui_shenlianchenggong", 0, 0);
		self.effectZiTi:SetRenderQueue(self.xjylLbl, 10, 2, false);
	else
		self.effectZiTi:setEnable(false);
		self.effectZiTi:setEnable(true);
	end
end

function Lua_JueXingPanel:onUpdateView()
	self:setListData();
	for i = 1, self.Arr:getSize() do
		if self.data.equPart == self.Arr[i].equPart then
			self.data = self.Arr[i];
			break;
		end
	end
	self:createEquipItem();
end

function Lua_JueXingPanel:createEquipItem()
	if self.data == nil then
		return;
	end

	if self.leftEquipItem == nil then
		self.leftEquipItem = Lua_ToolImage.new(self.infoBg.mainContent);
		self.leftEquipItem:setDepth(4);
		self.leftEquipItem:setLocation(0, 0, 0);
	end
	self.leftEquipItem.data = self.data;

	self:onCreateCostItem()
	self:onInfoPanelChange()
	self:onCreateAttr(1, self.attrArr, self.titleObj1)
	self:onCreateAttr(2, self.attrArr_qianghua, self.titleObj2)
	self:onBtnChange()
end

function Lua_JueXingPanel:onCreateCostItem()
	local costItemArr = self.data.jueXingCostItem
	local len = costItemArr:getSize();
	self.itemOutPutId = 0
	for i = 1, len do
		local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemArr[i].id)
		if self.costArr[i] == nil then
			local item = Lua_ToolImage.new(self.parentArr[i])
			item.data = costItemArr[i]
			item:setDepth(6)
			item:showNumLimit(hadCount, costItemArr[i].count, 2)
			item:setEnable(true)
			self.costArr:add(item)
		else
			self.costArr[i]:setEnable(true)
			self.costArr[i].data = costItemArr[i]
			self.costArr[i]:showNumLimit(hadCount, costItemArr[i].count, 2)
		end

		if hadCount < costItemArr[i].count then
			self.itemOutPutId = costItemArr[i].id
		end
	end

	local objLen = self.costArr:getSize();
	if objLen > len or len == 0 then
		for i = len + 1, objLen do
			self.costArr[i].data = nil
			self.costArr[i]:setEnable(false)
		end
	end
end

function Lua_JueXingPanel:getQiangHuaValue(part, attValue, intensifyLevel)
	return getConfig({"equipment_part", "intensify", part, attValue, intensifyLevel});
end

function Lua_JueXingPanel:onCreateAttr(valueIndex, attrArr, go)
	local attr = self.data.baseAttr
	local len = attr:getSize()
	local _attrArr = attrArr
	self.startY = -20
	for i = 1, len do
		if _attrArr[i] == nil then
			local item = Lua_JueXingTxtItem.new(go);
			local value, addValue = self:getAttrValueStr(attr[i], valueIndex)
			if valueIndex == 1 then
				item:setAttrTxt("[85A8BE]" .. attr[i].ChineseName .. "：[-]", "[00E125]" .. value .. addValue);
			else
				local hasQiangHuaAttr = self:getQiangHuaValue(self.data.equPart, attr[i].attr)
				if hasQiangHuaAttr ~= nil and self.data.intensifyLevel ~= nil and self.data.intensifyLevel ~= 0 then
					item:setAttrTxt("[85A8BE]" .. attr[i].ChineseName .. "：[-]", "[00E125]" .. value .. addValue);
				else
					item:setAttrTxt("", "");
				end
			end
			item:setLocation(-118, self.startY, 0);
			self.startY = self.startY - item.getHeight - 5;
			_attrArr:add(item)
		else
			local value = 0
			local addValue = 0
			value, addValue = self:getAttrValueStr(attr[i], valueIndex)
			if valueIndex == 1 then
				_attrArr[i]:setAttrTxt("[85A8BE]" .. attr[i].ChineseName .. "：[-]", "[00E125]" .. value .. addValue);
			else
				local hasQiangHuaAttr = self:getQiangHuaValue(self.data.equPart, attr[i].attr)
				if hasQiangHuaAttr ~= nil and self.data.intensifyLevel ~= nil and self.data.intensifyLevel ~= 0 then
					_attrArr[i]:setAttrTxt("[85A8BE]" .. attr[i].ChineseName .. "：[-]", "[00E125]" .. value .. addValue);
				else
					_attrArr[i]:setAttrTxt("", "");
				end
			end
			_attrArr[i]:setLocation(-118, self.startY, 0);
			self.startY = self.startY - _attrArr[i].getHeight - 5
		end
	end

	local objLen = _attrArr:getSize();
	if objLen > len then
        for i = len + 1, objLen do
            _attrArr[i]:setAttrTxt("", "");
        end
    end
end

function Lua_JueXingPanel:getAttrValueStr(attrList, valueIndex)
	-- 1为基础 2为强化，3为套装
	local configData
	local value = 0
	local addValue = 0
	local param = param
	local offsetValue = 0
	local valueStr = ""
	local addValueStr = ""
	local lvl = self.data.awake_level
	local qianghuaValue = self:getQiangHuaValue(self.data.equPart, attrList.attr, self.data.intensifyLevel)

	if lvl == 0 then
		value = 0
		lvl = 1
		configData = self.data:getConfigDataByPartAndLvl(self.data.equPart, lvl, 1)
		valueStr = "0"
		-- 基础
		if valueIndex == 1 then
			param = "jc_" .. attrList.attr
			addValue = configData[param]
			offsetValue = addValue - value
			if attrList.attr == "attack" then
				addValueStr = " [00E125]+(" .. math.floor(attrList.attack_min * offsetValue / 100) .. "-" .. math.floor(attrList.attack_max * offsetValue / 100) .. ")"
			else
				addValueStr = "  [00E125]+" .. math.floor(attrList.value * offsetValue / 100)
			end
		else
			-- 强化
			param = "qh_" .. attrList.attr
			addValue = configData[param]
			offsetValue = addValue - value
			if qianghuaValue ~= nil then
				valueStr = "0"
				addValueStr = "  [00E125]+" .. math.floor(qianghuaValue * offsetValue / 100)
			else
				valueStr = ""
				addValueStr = ""
			end
		end
	else
		configData = self.data:getConfigDataByPartAndLvl(self.data.equPart, lvl, 1)
		local configData2 = self.data:getConfigDataByPartAndLvl(self.data.equPart, lvl + 1, 1)
		if valueIndex == 1 then
			param = "jc_" .. attrList.attr
			value = configData[param]
			if configData2 ~= nil then
				addValue = configData2[param]
				offsetValue = addValue - value
				if attrList.attr == "attack" then
					addValueStr = " [00E125]+(" .. math.floor(attrList.attack_min * offsetValue / 100) .. "-" .. math.floor(attrList.attack_max * offsetValue / 100) .. ")"
					valueStr = math.floor(attrList.attack_min * value / 100) .. "-" .. math.floor(attrList.attack_max * value / 100)
				else
					addValueStr = "  [00E125]+" .. math.floor(attrList.value * offsetValue / 100)
					valueStr = math.floor(attrList.value * value / 100)
				end
			else
				value = configData[param]
				if attrList.attr == "attack" then
					valueStr = math.floor(attrList.attack_min * value / 100) .. "-" .. math.floor(attrList.attack_max * value / 100)
				else
					valueStr = math.floor(attrList.value * value / 100)
				end
				addValueStr = ""
			end
		else
			-- 强化
			param = "qh_" .. attrList.attr
			value = configData[param]
			if configData2 ~= nil then
				addValue = configData2[param]
				offsetValue = addValue - value
				if qianghuaValue ~= nil then
					valueStr = math.floor(qianghuaValue * value / 100)
					addValueStr = "  [00E125]+" .. math.floor(qianghuaValue * offsetValue / 100)
				else
					valueStr = ""
					addValueStr = ""
				end
			else
				if qianghuaValue ~= nil then
					valueStr = math.floor(qianghuaValue * value / 100)
				else
					valueStr = ""
				end
				addValueStr = ""
			end
		end
	end
	return valueStr, addValueStr
end

function Lua_JueXingPanel:onCreateTaoZhuangInfo()
	if self.data.refine ~= nil and self.data.refine ~= 0 and self.data.isCanJueXing == true then
		self.txt_dragContainer:setEnable(true)
		self.taoZhuangInfoPanel:setTextData(self.data)
	else
		self.txt_dragContainer:setEnable(false)
	end
	self.taoZhuangInfoPanel:updateSubPos()
end

function Lua_JueXingPanel:onInfoPanelChange()
	if self.data.isCanJueXing == false then
		self.infoObj.gameObject:SetActive(false)
		self.tipsTxt:setEnable(true)
		self.tipsTxt.text = "[FF1616]" .. self.data.jueXingTxtShow
		self.xjylLbl.text = self.data.jueXingTxtShow
		self.redDot:setEnable(false);
	else
		self.infoObj.gameObject:SetActive(true)
		self.tipsTxt:setEnable(false)
		if self.data.awake_level ~= self.data.maxJueXingLvl then
			self.xjylLbl.text = LanUtil.getValue(128903) .. self.data.awake_level
		elseif self.data.awake_level == self.data.maxJueXingLvl then
			self.xjylLbl.text = LanUtil.getValue(128903) .. self.data.awake_level
		else
			self.xjylLbl.text = self.data.max_lvl_show
		end

		if self.itemOutPutId == 0 and self.data.awake_level < self.data.maxJueXingLvl then
			self.redDot:setEnable(true);
		else
			self.redDot:setEnable(false);
		end
	end
end

function Lua_JueXingPanel:onBtnChange()
	if self.data.isCanJueXing == false then
		self.juexingBtn.label = LanUtil.getValue(128911)
		self.juexingBtn:setBtnEnable(false)
	else
		if self.data.awake_level == self.data.theMaxJueXingLvl then
			self.juexingBtn.label = LanUtil.getValue(128912)
			self.juexingBtn:setBtnEnable(false)
			self.redDot:setEnable(false);
		else
			self.juexingBtn.label = LanUtil.getValue(128911)
			self.juexingBtn:setBtnEnable(true)
		end
	end
end

function Lua_JueXingPanel:dispose()
	if self.equip_DragList ~= nil then
		self.equip_DragList:dispose();
		self.equip_DragList = nil;
	end
	self:superCall("dispose");
end



































Lua_JueXingTxtItem = class("Lua_JueXingTxtItem", Lua_DisplayObject);

function Lua_JueXingTxtItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_JueXingTxtItem:buildShowItem()
	self:superCall("buildShowItem");

	self.nameTxt = UICreate.createLabel(self.content, "", 0, 0, 100, 30, 22);
	self.nameTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.nameTxt.pivot = UIWidget.Pivot.TopLeft;
	self.nameTxt:setDepth(9);

	self.attrTxt = UICreate.createLabel(self.content, "", 0, 0, 180, 30, 22);
	self.attrTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.attrTxt.pivot = UIWidget.Pivot.TopLeft;
	self.attrTxt:setDepth(10);
end

function Lua_JueXingTxtItem:dispose()
	if self.nameTxt ~= nil then
		self.nameTxt:dispose();
		self.nameTxt = nil;
	end
	if self.attrTxt ~= nil then
		self.attrTxt:dispose();
		self.attrTxt = nil;
	end
	self:superCall("dispose");
end

function Lua_JueXingTxtItem:setAttrTxt(name, attr)
	self.nameTxt.text = name;
	self.attrTxt.text = attr;
	self.attrTxt:setLocation(self.nameTxt.width, 0, 0);
end

function Lua_JueXingTxtItem.Get:getHeight()
	return self.attrTxt.height;
end