Lua_JueXingTaoZhuangInfo = class("Lua_JueXingTaoZhuangInfo", Lua_DragContainerItem);
function Lua_JueXingTaoZhuangInfo:ctor(dragContainer)
    self:superCall("ctor", dragContainer.sub);
    dragContainer:addSubContainer(self, true);
    self.dragContainer = dragContainer;
end

function Lua_JueXingTaoZhuangInfo:buildShowItem()
    self:superCall("buildShowItem");
    self.ObjList = Array()
    self.DesList = Array()

    self.zhuangbei_AttrList = {
        [1] = { "attack", "defence", "attack_multi" },
        [2] = { "blood", "skill_hurt_multi", "reduction_multi" },
        [3] = { "attack", "defence", "attack_multi", "skill_hurt_multi" }
    }
    self.shoushi_AttrList = {
        [1] = { "blood", "attack", "skill_hurt_multi" },
        [2] = { "attack", "defence", "damage_multi", "skill_hurt_multi" }
    }
    self.paramList = { "tz_two_", "tz_four_", "tz_six_" }
end
function Lua_JueXingTaoZhuangInfo:setTextData(data)
    self.data = data
    local lvl = self.data.awake_level
    -- 当前等级数据
    local configData = self.data:getConfigDataByPartAndLvl(self.data.equPart, lvl, 1)
    -- 下级等级数据
    local configData2 = self.data:getConfigDataByPartAndLvl(self.data.equPart, lvl + 1, 1)
    local value = 0
    local addValue = 0
    local offsetValue = 0

    local len = 3
    local attrList = self.zhuangbei_AttrList
    self.dh = 53;
    if self.data.career == 0 then
        len = 2
        attrList = self.shoushi_AttrList
    end
    local strArr = Array()
    for i = 1, len do
        local listData = attrList[i]
        local listDataLen = #listData
        local str = ""
        for c = 1, listDataLen do
            local attrName = Lua_ThingDefine.getParamName(listData[c])
            local isPercnet = Lua_ThingDefine.isPercentParam(listData[c])
            -- 精炼对应的值
            local attrValue = self:getRefineValueByParams(self.data.refine, i, listData[c], self.data.order)
            local params = self.paramList[i] .. listData[c]
            local percentStr = "[-]"
            if isPercnet == true then
                percentStr = "%[-]"
            end
            if configData2 ~= nil then
                addValue = configData2[params]
            else
                addValue = configData[params]
            end
            if configData == nil then
                value = 0
                offsetValue = addValue - value
            else
                value = configData[params]
                offsetValue = addValue - value
                if isPercnet == false then
                    value = math.floor(attrValue * value / 100) .. percentStr
                else
                    value = configData[params] .. percentStr
                end
            end

            if isPercnet == false then
                addValue = "[13a100]  +" .. math.floor(attrValue * offsetValue / 100)
            else
                addValue = "[13a100]  +" .. offsetValue .. percentStr
            end

            local fenhang = "\n"
            if c == listDataLen then
                fenhang = ""
            end
            str = str .. "[3F6180]" .. attrName .. "：[-]" .. "[192e41]" .. value .. "[-]" .. addValue .. fenhang
        end
        strArr:add(str)
    end

    for i = 1, len do
        if self.ObjList[i] == nil then
            local countlabel = UICreate.createLabel(self.content, "", -120, 53, 227, 30, 24);
            countlabel.overflowMethod = UILabel.Overflow.ResizeFreely;
            countlabel.pivot = UIWidget.Pivot.Left;
            countlabel:setDepth(6);
            countlabel.text = LanUtil.formateStr(LanUtil.getValue(128914), tostring(i * 2))
            countlabel:setLocation(-120, self.dh, 0);

            local deslabel = UICreate.createLabel(self.content, "", 0, 0, 227, 30, 24);
            deslabel.overflowMethod = UILabel.Overflow.ResizeFreely;
            deslabel.pivot = UIWidget.Pivot.TopLeft;
            deslabel:setDepth(6);
            deslabel.text = strArr[i]
            local offestY = self.dh - countlabel.height / 2
            deslabel:setLocation(-120, offestY, 0);
            local list = { }
            list.countlabel = countlabel
            list.deslabel = deslabel
            self.ObjList:add(list)
            self.dh = offestY - deslabel.height - countlabel.height / 2
        else
            local offestY = self.dh - self.ObjList[i].countlabel.height / 2
            self.ObjList[i].deslabel.text = strArr[i]
            self.dh = offestY - self.ObjList[i].deslabel.height - self.ObjList[i].countlabel.height / 2
        end
    end

    local objLen = self.ObjList:getSize();
    if objLen > len then
        for i = len + 1, objLen do
            self.ObjList[i].countlabel:dispose()
            self.ObjList[i].deslabel:dispose()
            self.ObjList[i] = nil
        end
    end
    self.dragContainer:updateChildPos();
end 

function Lua_JueXingTaoZhuangInfo.Get:refineConfig()
    if self._refineConfig == nil then
        self._refineConfig = getConfig( { "equipment_refine", "refine" })
    end
    return self._refineConfig
end

function Lua_JueXingTaoZhuangInfo:getRefineValueByParams(refine, count, attrName, order)
    return self.refineConfig[refine]["attr"][count][attrName][order]
end

function Lua_JueXingTaoZhuangInfo:updateSubPos()
    self.dragContainer:updateSubPos(0, 0, 0);
end

function Lua_JueXingTaoZhuangInfo:getHeight()
    local len = self.ObjList:getSize();
    if len == 0 then
        return 0
    else
        return math.abs(self.dh) + 60
    end
end