Lua_MingKeItem = class("Lua_MingKeItem", Lua_ListCell);
function Lua_MingKeItem:ctor(p)
    self:superCall("ctor", p, "XiangQianItem_skin");
end
function Lua_MingKeItem:buildShowItem()
    self:superCall("buildShowItem");
    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    self.itemImg:setLocation(-112, 0, 0);
    self.kongdiArr = Array();
    self.hongbaoshiArr = Array();
    self.lanbaoshiArr = Array();
    self.index = -1;

    self.redDot = UICreate.createUIAtlasImage(self.content, "iconantlas4", "redDot", 152, 40, 0, 0)
    self.redDot:setDepth(6);
    self.redDot.clickScale = false;
    self.redDot.name = "redDot"
    self.redDot:setEnable(false);


    self.kongdiArr:add(self.kongdi1);
    self.kongdiArr:add(self.kongdi2);
    self.kongdiArr:add(self.kongdi3);
    self.kongdiArr:add(self.kongdi4);
    self.kongdiArr:add(self.kongdi5);
    self.kongdiArr:add(self.kongdi6);

    self.hongbaoshiArr:add(self.hongdi1);
    self.hongbaoshiArr:add(self.hongdi2);
    self.hongbaoshiArr:add(self.hongdi3);
    self.hongbaoshiArr:add(self.hongdi4);
    self.hongbaoshiArr:add(self.hongdi5);
    self.hongbaoshiArr:add(self.hongdi6);

    self.lanbaoshiArr:add(self.landi1);
    self.lanbaoshiArr:add(self.landi2);
    self.lanbaoshiArr:add(self.landi3);
    self.lanbaoshiArr:add(self.landi4);
    self.lanbaoshiArr:add(self.landi5);
    self.lanbaoshiArr:add(self.landi6);

end
function Lua_MingKeItem:setData(data)
    self._data = data;
    self.itemImg.data = self._data;
    self.maxLvl = self._data.maxLvl;
    if self._data.jewl_Level == 0 then
        self.itemTxt.text = self.itemImg.data.colorName
    else
        self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.jewl_Level;
    end
    self.count = DataCenter.equData:getJewf_countHoleByPart(self._data.equPart);
    self.count2 = DataCenter.equData:getJewf_countByPart(self._data.equPart);
    self.jewlCount = 0;
    self.isRed = false;
    for i = 1, self.count do
        if i <= self.count2 then
            self.kongdiArr[i].mainContent:SetActive(true);
        else
            self.kongdiArr[i].mainContent:SetActive(false);
        end
        if self._data.jewel[i].id > 0 then
            self.jewlCount = self.jewlCount + 1
        end
        self.hongbaoshiArr[i].mainContent:SetActive(false);
        self.lanbaoshiArr[i].mainContent:SetActive(false);
    end
    for i = 1, self.count do
        if self._data.jewel[i].id > 0 then
            if Lua_ToolVo.new(self._data.jewel[i].id, 0, 0).subType == 101 then
                self.isRed = true;
                break;
            end
        end
    end

    for i = 1, self.jewlCount do
        if self.isRed == true then
            self.hongbaoshiArr[i].mainContent:SetActive(true);
            self.lanbaoshiArr[i].mainContent:SetActive(false);
        else
            self.hongbaoshiArr[i].mainContent:SetActive(false);
            self.lanbaoshiArr[i].mainContent:SetActive(true);
        end
    end
    self:showRedDot()
    self.itemBg:setAltas("iconantlas1", data.selected and "tab3_souchong_select" or "tab3_souchong_normal");
end

function Lua_MingKeItem.Get:mingKeConfig()
    return DataCenter.equData.equipMingKeConfig[self._data.jwelType]
end

function Lua_MingKeItem:showRedDot()
    local redList = Array()
    for i = 1, self.count do
        if self._data.jewel[i].id > 0 then
            local isShowRed = true
            local lvlLimt_mingKeConfig = self.mingKeConfig["level_limit"][self._data.jewel[i].engrave_progress + 1]
            if lvlLimt_mingKeConfig ~= nil then
                local costItemData = self.mingKeConfig["engrave_cost"][self._data.jewel[i].engrave_progress + 1]
                local _len = #costItemData
                for i = 1, _len do
                    local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemData[i][1]);
                    local totalCount = costItemData[i][2]
                    if hadCount < totalCount then
                        isShowRed = false
                        break;
                    end
                end

                if isShowRed == true then
                    local limit_lvl = Lua_ToolVo.new(self._data.jewel[i].id).engrave_limit
                    if limit_lvl ~= 0 and self._data.jewel[i].engrave_progress < limit_lvl then
                        isShowRed = true
                    else
                        isShowRed = false
                    end
                end
            else
                isShowRed = false
            end
            redList:add(isShowRed)
        end
    end
    local isShowRed = false
    local len = redList:getSize()
    for i = 1, len do
        if redList[i] == true then
            isShowRed = true
            break
        end
    end
    self.redDot:setEnable(isShowRed);
end
function Lua_MingKeItem:onPlayerSoundClick(go)
    Lua_MsgUtil.callFunc("onJingLianCellClick", self._data);
end
function Lua_MingKeItem:onSelectionChange(val)
    self:superCall("onSelectionChange", val);
    if self.itemBg ~= nil then
        if val == true then
            self.itemBg:setAltas("iconantlas1", "tab3_souchong_select");
        else
            self.itemBg:setAltas("iconantlas1", "tab3_souchong_normal");
        end
    end
end
function Lua_MingKeItem:dispose()
    self:superCall("dispose");
end