Lua_MingKeTipsWindow = class("Lua_MingKeTipsWindow", Lua_Window);
function Lua_MingKeTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MingKeTipsWindow";
	self.skinName = "MingKeTipsWindow_skin";
	self.blackAlpha = 1 / 255;
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_MingKeTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_MingKeTipsWindow:showWin(param)
	self:superCall("showWin", param);

	self.itemIcon:setAltas("item1", tostring(param.max_item_id));

	local tvo = Lua_ToolVo.new(param.max_item_id)
	self.nameTxt.text = LanUtil.formateStr(LanUtil.getValue(140909), tvo.name)
	self.tipsTxt.text = LanUtil.getValue(140910);

	self:showEffect();
	self:showAttrInfo(tvo.attribute);
end

function Lua_MingKeTipsWindow:showAttrInfo(attrList)
	local len = #self.showData.stone_base_multi;
	local addValue = self.showData.stone_base_multi[len];
	local arr = Array();
	for k, v in ipairs(Lua_ThingDefine.params) do
		for key, value in pairs(attrList) do
			if v == key then
				arr:add({index = Lua_ThingDefine.getParaRankByParams(v),
					value = math.floor(value *(1 + addValue / 100)), attrName = Lua_ThingDefine.getParamName(key)});
			end
		end

		if self.showData[v] ~= nil then
			arr:add({index = Lua_ThingDefine.getParaRankByParams(v),
				value = self.showData[v][len].."%", attrName = Lua_ThingDefine.getParamName(v)});
		end
	end
	arr:sort("index", false);

	local desLab;
	local startY = -25;
	for i = 1, arr:getSize() do
		desLab = UICreate.createLabel(self.tipsTxt.mainContent, "", -155, startY, 265, 30, 22);
		desLab.overflowMethod = UILabel.Overflow.ResizeHeight;
		desLab.spacingY = 10;
		desLab.pivot = UIWidget.Pivot.TopLeft;
		desLab.text = arr[i].attrName .. "：[00E125]+" .. arr[i].value;
		desLab:setDepth(5);

		startY = startY - desLab.height;
	end
end

function Lua_MingKeTipsWindow:showEffect()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.djky.mainContent, "/effects/scsEffects/gui_daojuyuankuang", "gui_daojuyuankuang", 0, 0);
		self.effect:SetRenderQueue(self.nameTxt, 5, 2, false);
	end
	self.effect:setEnable(false);
	self.effect:setEnable(true);
end

function Lua_MingKeTipsWindow:dispose()
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil
	end
	self:superCall("dispose");
end