Lua_QiangHuaPanel = class("Lua_QiangHuaPanel", Lua_DisplayObject);
function Lua_QiangHuaPanel:ctor(p)
	self:superCall("ctor", p, "QiangHuaPanel_skin");
end

function Lua_QiangHuaPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.hongdian = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 347, -236, 0, 0)
	self.hongdian:setDepth(15);
	self.hongdian.clickScale = false;
	self.hongdian.name = "hongdian"
	self.hongdian:setEnable(false);

	self:addLuaEvent("onQiangHuaCellClick", self, self.onQiangHuaCellClick);
	self:addLuaEvent("MONEY_UPDATE", self, self.onUpdateMoney);
	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView);
	self:addLuaEvent("FORGING_BAO_JI", self, self.onBaoJiEvent);
	self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent);

	self.spArr = Array();
	self.isClick = false;
	self.isMax = false;

	self.autoBtn:setGray(true);
	self.qiangHuaBtn:setGray(true);
	self.shuLianDuBar:setText("");

	self.tipsLbl.text = LanUtil.getValue(110555);

	self.qianghua_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 542));
	self.qianghua_DragList:setListCell(Lua_QiangHuaItem, 116, 286, 1);
	self.qianghua_DragList:setLocation(-460, -70, 0);

	self.Arr = Array();
	self.equipArr = DataCenter.equData.parts;
	if #self.equipArr ~= 0 then
		local _eq;
		for i = 12, 1, -1 do
			_eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil and _eq.intensifyLevel ~= _eq.maxLvl then
				self.Arr:add(_eq);
			end
		end

		for i = 12, 1, -1 do
			_eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil and _eq.intensifyLevel == _eq.maxLvl then
				self.Arr:add(_eq);
			end
		end
	end

	self.qianghua_DragList:setLuaArrayData(self.Arr, false);
	self.length = self.qianghua_DragList.showList:getSize();
	if self.length ~= 0 then
		self.qianghua_DragList.showList[1]:onPlayerSoundClick();
		self.qianghua_DragList:setSelected(1);
	end

	self:onChangeInfo();

	self.iconBg:addClickFuntion(self, self.onIcon4Click);
end

function Lua_QiangHuaPanel:onChangeInfo()
	if DataCenter.equData.indensify ~= nil and DataCenter.equData.indensify ~= 0 and DataCenter.funcOpenData:isOpened(10006) == true then
		self.upLab.text = "+" .. DataCenter.equData.indensify;
	else
		self.upLab.text = "";
	end
end

function Lua_QiangHuaPanel:onIcon4Click()
	Lua_WindowUtil.openWin("Lua_AdditionWindow", WinParam.ACTION_AUTO, {str = "indensify_attr", value = DataCenter.equData.indensify});
end

function Lua_QiangHuaPanel:onSuccessEvent()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_qianghua", "gui_qianghua", 104, 22);
	else
		self.effect:setEnable(false);
		self.effect:setEnable(true);
	end
	self.effect:SetRenderQueue(self.xjylLbl, 5, 2, false);

	if self.effectZiTi == nil then
		self.effectZiTi = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_qianghuaziti", "gui_qianghuaziti", 104, -70);
	else
		self.effectZiTi:setEnable(false);
		self.effectZiTi:setEnable(true);
	end
	self.effectZiTi:SetRenderQueue(self.xjylLbl, 10, 2, false);
end

function Lua_QiangHuaPanel:onBaoJiEvent()
	self.scaleValue = 1;
	self.colorValue = 1;
	if self.emptyObj == nil then
		self.emptyObj = UICreate.createGameObject(self.shuLianDuBar.mainContent, -30, 0, 0);
	end
	-- self.emptyObj.transform.localScale = Vector3(1, 1, 1);
	LuaUtil.setObjScale(self.emptyObj, 1, 1, 1);

	local list = {[1] = "ui_common_pz_bj", [2] = "bj_x", [3] = "bj_2"};
	local posList = {[1] = - 50, [2] = 10, [3] = 45};
	for i = 1, 3 do
		self.sp = UICreate.createUIAtlasImage(self.emptyObj, "number_atlas", list[i], posList[i], 40, 0, 0);
		self.sp:setDepth(15)
		self.spArr:add(self.sp)
	end

	self.bol = false;
	Lua_CommonUtil.addTimer("onFadeKey", 0.1, self, self.onFadeKey);
end

function Lua_QiangHuaPanel:onFadeKey()
	if self.bol == true then
		self.scaleValue = self.scaleValue - 0.2;
		self.colorValue = self.colorValue - 0.2;
		for i = 1, 3 do
			self.spArr[i].uiwidget.color = Color.New(1, 1, 1, self.colorValue);
		end
	else
		self.scaleValue = self.scaleValue + 0.3;
	end

	-- self.emptyObj.transform.localScale = Vector3(self.scaleValue, self.scaleValue, self.scaleValue);
	LuaUtil.setObjScale(self.emptyObj, self.scaleValue, self.scaleValue, self.scaleValue);
	if self.scaleValue > 1.5 then
		self.bol = true;
	end

	if self.scaleValue < 1 then
		Lua_CommonUtil.removeTimer(self, self.onFadeKey);
		for i = 1, self.spArr:getSize() do
			self.spArr[i]:dispose();
		end
		self.spArr:clear();
	end
end

function Lua_QiangHuaPanel:onAutoClick()
	if self.data == nil then
		return;
	end

	if self.isMax == true then
		OperateAlert.show(LanUtil.getValue(110590));
		return;
	end

	self.curPart = self.data.equPart;
	if self.data.intensifyLevel == 0 then
		self.nedMoney = Lua_QiangHuaUtil.getCost(self.data.equPart)[1];
	else
		self.nedMoney = Lua_QiangHuaUtil.getCost(self.data.equPart)[self.data.intensifyLevel + 1];
	end

	-- print("打印", DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER_AND_BINDCOPPER));
	if DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER) >= self.nedMoney then
		self.isClick = not self.isClick;
		if self.isClick == true then
			self.autoBtn.label = LanUtil.getValue(110563);
			Lua_CommonUtil.addTimer("onSendMsgKey", 0.1, self, self.onSendMsg);
		else
			self.autoBtn.label = LanUtil.getValue(110562);
			Lua_CommonUtil.removeTimer(self, self.onSendMsg);
		end
	else
		local arr = Array();
		arr:add(Lua_ToolVo.new(Lua_MoneyData.COPPER, 1, 1));
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end

function Lua_QiangHuaPanel:onSendMsg()
	if self.data.intensifyLevel == 0 then
		self.nedMoney = Lua_QiangHuaUtil.getCost(self.data.equPart)[1];
	else
		self.nedMoney = Lua_QiangHuaUtil.getCost(self.data.equPart)[self.data.intensifyLevel + 1];
	end

	if self.isMax == false and DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER) >= self.nedMoney then
		Lua_ProxyManager.getProxy("Lua_ForgingProxy"):sQiangHuaMsg(self.data.equPart, false);
	else
		self.autoBtn.label = LanUtil.getValue(110562);
		Lua_CommonUtil.removeTimer(self, self.onSendMsg);
	end
end

function Lua_QiangHuaPanel:onQiangHuaClick()
	if self.data == nil then
		return;
	end

	if self.isMax == true then
		OperateAlert.show(LanUtil.getValue(110590));
		return;
	end

	self.curPart = self.data.equPart;
	if self.data.intensifyLevel == 0 then
		self.nedMoney = Lua_QiangHuaUtil.getCost(self.data.equPart)[1];
	else
		self.nedMoney = Lua_QiangHuaUtil.getCost(self.data.equPart)[self.data.intensifyLevel + 1];
	end

	-- print("打印", DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER_AND_BINDCOPPER));
	if DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER) >= self.nedMoney then
		Lua_ProxyManager.getProxy("Lua_ForgingProxy"):sQiangHuaMsg(self.data.equPart, false);
	else
		local arr = Array();
		arr:add(Lua_ToolVo.new(Lua_MoneyData.COPPER, 1, 1));
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end

function Lua_QiangHuaPanel:onCellDispose()
	if self.data == nil then
		return;
	end

	if self.curPart ~= self.data.equPart then
		if self.isClick ~= false then
			self.isClick = false
			self.autoBtn.label = LanUtil.getValue(110562);
			Lua_CommonUtil.removeTimer(self, self.onSendMsg);
		end
	end
end

function Lua_QiangHuaPanel:onQiangHuaCellClick(data)
	-- print("测试", data.name)
	self.data = data;
	if self.data == nil then
		return;
	end

	self:onShowInfo()
end

function Lua_QiangHuaPanel:onYuLanEquipClick()
	if self.data == nil then
		return;
	end
	Lua_PackUtil.showItemInfo(self.data, nil, true);
end

function Lua_QiangHuaPanel:onShowInfo()
	if self.data == nil then
		return;
	end

	self:onCellDispose();
	self.isMax = false;

	-- print("部位", self.data.equPart, self.data.intensifyLevel);
	-- print("输出", self.data.intensifyLevel, Lua_QiangHuaUtil.getIndensify_level(self.data.order));
	if self.curEquipImg == nil then
		self.curEquipImg = Lua_ToolImage.new(self.content);
		self.curEquipImg:setDepth(6);
		self.curEquipImg:setLocation(-65, 26, 0);
	end
	self.curEquipImg.data = self.data;

	if self.nextEquipImg == nil then
		self.nextEquipImg = Lua_ToolImage.new(self.content);
		self.nextEquipImg:setDepth(6);
		self.nextEquipImg:setLocation(104, 26, 0);
	end
	self.nextEquipImg:removeFun(false);
	self.nextEquipImg.item_bg:addClickFuntion(self, self.onYuLanEquipClick);
	self.nextEquipImg.data = self.data;

	if self.money_Img == nil then
		self.money_Img = Lua_ToolImage.new(self.content);
		self.money_Img:setDepth(6);
		self.money_Img:setLocation(273, 26, 0);
	end
	self.money_Img.data = Lua_ToolVo.new(Lua_MoneyData.COPPER, 0, 0);

	self.attackLbl.text = Lua_QiangHuaUtil.getProperty(self.data.equPart)[1][1];
	self.value_1:setLocation(self.attackLbl.mainContent.transform.localPosition.x + self.attackLbl.width, self.value_1.mainContent.transform.localPosition.y);
	if self.data.intensifyLevel == 0 then
		self.value_1.text = "0";
	else
		self.value_1.text = Lua_QiangHuaUtil.getValue(self.data.equPart, Lua_QiangHuaUtil.getProperty(self.data.equPart)[1][2])[self.data.intensifyLevel];
	end

	if self.data.intensifyLevel == Lua_QiangHuaUtil.getMax_level() then
		self.lvlLbl.text = "Lv." .. self.data.intensifyLevel;
		self.lvlLbl2.text = "Lv." .. self.data.intensifyLevel;
		self.value_1_1.text = LanUtil.getValue(120537);
	else
		self.lvlLbl.text = "Lv." .. self.data.intensifyLevel;
		self.lvlLbl2.text = "Lv." .. self.data.intensifyLevel + 1
		self.value_1_1.text = Lua_QiangHuaUtil.getValue(self.data.equPart, Lua_QiangHuaUtil.getProperty(self.data.equPart)[1][2])[self.data.intensifyLevel + 1];
	end

	if Lua_QiangHuaUtil.getProperty(self.data.equPart)[2] == nil then
		-- self.desObj1.transform.localPosition = Vector3(0, -145, 0);
		LuaUtil.setObjPos(self.desObj1, 0, -145, 0);
	else
		-- self.desObj1.transform.localPosition = Vector3(0, -130, 0);
		LuaUtil.setObjPos(self.desObj1, 0, -130, 0);

		self.critLbl.text = Lua_QiangHuaUtil.getProperty(self.data.equPart)[2][1];
		self.value_2:setLocation(self.attackLbl.mainContent.transform.localPosition.x + self.attackLbl.width, self.value_2.mainContent.transform.localPosition.y);
		if self.data.intensifyLevel == 0 then
			self.value_2.text = "0";
		else
			self.value_2.text = Lua_QiangHuaUtil.getValue(self.data.equPart, Lua_QiangHuaUtil.getProperty(self.data.equPart)[2][2])[self.data.intensifyLevel];
		end
		self.value_1_2.text = Lua_QiangHuaUtil.getValue(self.data.equPart, Lua_QiangHuaUtil.getProperty(self.data.equPart)[2][2])[self.data.intensifyLevel + 1];
	end
	self.desObj2:SetActive(Lua_QiangHuaUtil.getProperty(self.data.equPart)[2] ~= nil);

	local len = Lua_QiangHuaUtil.getItsLvl();
	local itsLvl;
	local _maxLvl = Lua_QiangHuaUtil.getIndensify_level(len, 1);
	if self.data.order >= len then
		itsLvl = _maxLvl;
	else
		itsLvl = self.data.maxLvl;
	end
	if self.data.intensifyLevel == _maxLvl then
		self.shuLianDuBar:setMaxValue(Lua_QiangHuaUtil.getProgress_range(self.data.equPart)[self.data.intensifyLevel][3]);
	else
		self.shuLianDuBar:setMaxValue(Lua_QiangHuaUtil.getProgress_range(self.data.equPart)[self.data.intensifyLevel + 1][3]);
	end

	if self.data.intensifyLevel ~= itsLvl then
		self.autoBtn:setGray(false);
		self.qiangHuaBtn:setGray(false);
		self.autoBtn:addClickFuntion(self, self.onAutoClick);
		self.qiangHuaBtn:addClickFuntion(self, self.onQiangHuaClick);
		if self.data.intensifyLevel >= itsLvl then
			self.isMax = true;
		else
			self.isMax = false;
		end
		self.shuLianDuBar:setText(tostring(self.data.intensifyProgress) .. "/" .. tostring(Lua_QiangHuaUtil.getProgress_range(self.data.equPart)[self.data.intensifyLevel + 1][3]))
	else
		self.isMax = true;
		self.autoBtn:setGray(true);
		self.qiangHuaBtn:setGray(true);
		self.autoBtn:removeClickFuntion(self, self.onAutoClick);
		self.qiangHuaBtn:removeClickFuntion(self, self.onQiangHuaClick);
		local str = LanUtil.formateStr(LanUtil.getValue(110589), tostring(self.data.intensifyProgress));
		self.shuLianDuBar:setText(str);
	end

	self.shuLianDuBar:setValue(self.data.intensifyProgress);

	self:onUpdateMoney();
	self.hongdian:setEnable(self:checkRedDot() and self.isRedDot);
end

function Lua_QiangHuaPanel:checkRedDot()
	local maxLvl = self.data.maxLvl;
	if self.data.intensifyLevel == 0 then
		return true;
	elseif self.data.intensifyLevel == maxLvl then
		return false;
	else
		return true;
	end
end

function Lua_QiangHuaPanel:onUpdateView()
	self.Arr:clear();
	self:onChangeInfo()

	self.equipArr = DataCenter.equData.parts;
	self.Arr2 = Array();
	if #self.equipArr ~= 0 then
		local _eq;
		for i = 12, 1, -1 do
			_eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil and _eq.intensifyLevel ~= _eq.maxLvl then
				self.Arr:add(_eq);
			end
		end

		for i = 12, 1, -1 do
			_eq = DataCenter.equData:getEquByPart(i);
			if _eq ~= nil and _eq.intensifyLevel == _eq.maxLvl then
				self.Arr:add(_eq);
			end
		end

		for i = 1, self.Arr:getSize() do
			if self.data.equPart == self.Arr[i].equPart then
				-- print("更新", self.data.equPart, self.Arr[i].equPart);
				self.data = self.Arr[i];
				-- self.Arr[i].selected = true;
			else
				-- self.Arr[i].selected = false;
			end
		end
		self.qianghua_DragList:setLuaArrayData(self.Arr, false);
	end

	self:onShowInfo();
	if self.isMax == true then
		self.qianghua_DragList:setSelected(1);
		self.qianghua_DragList.showList[1]:onPlayerSoundClick();
	end
end

function Lua_QiangHuaPanel:onUpdateMoney()
	if self.data == nil then
		return;
	end

	local _totalMoney = DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER);
	if self.data.intensifyLevel == 0 then
		self.nedMoney = Lua_QiangHuaUtil.getCost(self.data.equPart)[1];
	elseif self.data.intensifyLevel == Lua_QiangHuaUtil.getMax_level() then
		self.nedMoney = Lua_QiangHuaUtil.getCost(self.data.equPart)[self.data.intensifyLevel];
	else
		self.nedMoney = Lua_QiangHuaUtil.getCost(self.data.equPart)[self.data.intensifyLevel + 1];
	end

	self.isRedDot = false;
	if _totalMoney < self.nedMoney then
		self.isRedDot = false;
		self.costLbl.text = LanUtil.formateStr(LanUtil.getValue(110560), tostring(self.nedMoney));
	else
		self.isRedDot = true;
		self.costLbl.text = LanUtil.formateStr(LanUtil.getValue(110561), tostring(self.nedMoney));
	end
end

function Lua_QiangHuaPanel:dispose()
	if self.qianghua_DragList ~= nil then
		self.qianghua_DragList:dispose();
		self.qianghua_DragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onSendMsg);
	Lua_CommonUtil.removeTimer(self, self.onFadeKey);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_QiangHuaItem = class("Lua_QiangHuaItem", Lua_ListCell);
function Lua_QiangHuaItem:ctor(p)
	self:superCall("ctor", p, "QiangHuaItem_skin");
end

function Lua_QiangHuaItem:buildShowItem()
    self:superCall("buildShowItem");

    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    self.itemImg:setLocation(-93.5, 2.5, 0);
end

function Lua_QiangHuaItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data;

	local isRedDot = false;
	self.maxLvl = self._data.maxLvl;
	self.maxTxt.text = "";
	if data.intensifyLevel == 0 then
		isRedDot = true
		self.itemTxt.text = self.itemImg.data.colorName
	elseif data.intensifyLevel == self.maxLvl then
		isRedDot = false;
		self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.intensifyLevel;
		self.maxTxt.text = "[" .. self.itemImg.data.colorStr .. "]強化已滿";
	else
		isRedDot = true
		self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.intensifyLevel;
	end
	self.redDot:setEnable(self:checkRedDot() and isRedDot);
end

function Lua_QiangHuaItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onQiangHuaCellClick", self._data);
end

function Lua_QiangHuaItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_QiangHuaItem:checkRedDot()
	local needMoney;
	if self._data.intensifyLevel == 0 then
		needMoney = Lua_QiangHuaUtil.getCost(self._data.equPart)[1];
	elseif self._data.intensifyLevel == Lua_QiangHuaUtil.getMax_level() then
		needMoney = Lua_QiangHuaUtil.getCost(self._data.equPart)[self._data.intensifyLevel];
	else
		needMoney = Lua_QiangHuaUtil.getCost(self._data.equPart)[self._data.intensifyLevel + 1];
	end

	local totalMoney = DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER);
	if totalMoney >= needMoney then
		return true;
	else
		return false;
	end
end

function Lua_QiangHuaItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end