checkRequire("Lua_RongLianPanel");-- 常规装备
checkRequire("Lua_AmuletNecklacePanel");-- 护符项链
checkRequire("Lua_HeChengPanel");-- 手镯戒指
Lua_RongHePanel = class("Lua_RongHePanel", Lua_DisplayObject);
function Lua_RongHePanel:ctor(p)
	self:superCall("ctor", p, "ForgingPanel_skin");
end

function Lua_RongHePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.initIndex = 1;
	self.isFirstClick = true;

	self.btnNames = Array();
	self.btnNames:add({name = LanUtil.getValue(120591), panel = Lua_RongLianPanel, eventIds = {16002}, openId = 10082});
	self.btnNames:add({name = LanUtil.getValue(120592), panel = Lua_AmuletNecklacePanel, eventIds = {17003}, openId = 10196});
	self.btnNames:add({name = LanUtil.getValue(120593), panel = Lua_HeChengPanel, eventIds = {17002}, openId = 10170});

	self.forgingList = Lua_ButtonList.new(self.content, self.btnNames, 154, self, self.onButtonListClick,
		"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 148, 66), Vector4(0, 0, 148, 66),
		Lua_ColorDefine.transColor("D2D8DC"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(28, 28, 120, 30), 2, "common_atlas_1");
	self.forgingList:setDepth(5);
	self.forgingList:setRedDotPos(63, 23);
	self.forgingList:setLocation(-540, 250, 0);

	local len = self.btnNames:getSize();
	local initIndex = 1;
	local winData = DataCenter.equData.ForgingWindowData;
	if winData ~= nil and type(winData) == "number" then
		initIndex = winData;
	elseif winData ~= nil and winData.nameIndex ~= nil then
		for i = 1, len do
			if self.btnNames[i].name == LanUtil.getValue(winData.nameIndex) then
				initIndex = i;
				break;
			end
		end
	end
	self.forgingList:setSelected(initIndex, true);

	local isShowIcon;
	for i = 1, len do
		isShowIcon = true;
		if self.btnNames[i].openId == nil or DataCenter.funcOpenData:isOpened(self.btnNames[i].openId) == true then
			self.forgingList:setBtnGray(false, i, isShowIcon);
		else
			local cfg = getConfig({"func_open", self.btnNames[i].openId});
			if cfg ~= nil and cfg.advance_function ~= nil then
				isShowIcon = cfg.advance_function == 1;
			end
			self.forgingList:setBtnGray(true, i, isShowIcon);
		end
	end
end

function Lua_RongHePanel:onButtonListClick(val)
	if self.initIndex == val and self.isFirstClick == false then
		return;
	end

	if self.btnNames[val].openId ~= nil and DataCenter.funcOpenData:isOpened(self.btnNames[val].openId) == false then
		local cfg = getConfig({"func_open", self.btnNames[val].openId});
		if cfg ~= nil and cfg.advance_message ~= nil then
			OperateAlert.show(cfg.advance_message);
		end
		return;
	end

	if self.isFirstClick == true then
		self.isFirstClick = false;
	end

	self.initIndex = val
	if self.panel ~= nil then
		self.panel:dispose();
		self.panel = nil;
	end

	if self.btnNames[self.initIndex].panel == nil then
		return;
	end
	self.panel = self.btnNames[self.initIndex].panel.new(self.content);
end

function Lua_RongHePanel:dispose()
	if self.forgingList ~= nil then
		self.forgingList:dispose();
		self.forgingList = nil;
	end
	if self.panel ~= nil then
		self.panel:dispose();
		self.panel = nil;
	end
	DataCenter.equData.ForgingWindowData = nil;

	self:superCall("dispose");
end
