﻿checkRequire("Lua_RongLianUtil");
checkRequire("Lua_YuLanEquipSelectedItem")
Lua_RongLianPanel = class("Lua_RongLianPanel", Lua_DisplayObject);
function Lua_RongLianPanel:ctor(p)
	self:superCall("ctor", p, "RongLianPanel_skin");
end

function Lua_RongLianPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.titleLab_1.text = Lua_RongLianUtil.getCareer_equip()[DataCenter.roleData.career];
	self.titleLab_2.text = LanUtil.getValue(120596);
	self.tipsLab.text = LanUtil.getValue(110559);
	self.desLab.text = ""
	self.rateLab.text = "";
	self.tipsLab:setEnable(false);
	self.rongLianObj:SetActive(false);
	self.desLbl1:setEnable(false);

	self.pkg_indexArr = Array();
	self.duanzaoBgArr = Array();
	self.duanzaoBgArr:add(self.duanzao2);
	self.duanzaoBgArr:add(self.duanzao3);
	self.duanzaoBgArr:add(self.duanzao4);
	self.duanzaoBgArr:add(self.duanzao5);
	self.duanzaoBgArr:add(self.duanzao6);

	self._list = {txt = self.titleLab_1.text, index = DataCenter.roleData.career};
	self:ObjectState(false, true);

	self.equip_DragList = Lua_DragList.new(self.dragListObj, 1, Vector4(0, 0, 768, 410));
	self.equip_DragList:setListCell(Lua_YuLanEquipSelectedItem, 118, 256, 3);
	self.equip_DragList:setLocation(0, -238, 0);

	self._count = getConfig({"equipment_compose", "order_count"});
	self.level_limitArr = getConfig({"equipment_compose", "lvl_limit"});
	local order_equip = getConfig({"equipment_compose", "order_equip"});
	local color_equip = getConfig({"equipment_compose", "color_equip"});
	local color_equip_limit = getConfig({"equipment_compose", "color_equip_limit"});
	local key;
	local sub;
	local arr = Array();
	for i = 1, #color_equip do
		if DataCenter.roleData.level >= color_equip_limit[i] then
			key = "a"..DataCenter.roleData.career;
			sub = Array();
			for j = 1, self._count[i] do
				if DataCenter.roleData.level >= self.level_limitArr[i][j] then
					local obj = order_equip[key][key .. i - 1 .. string.format("%02d", j)];
					sub:add({ name = obj[1][1], data = obj[2] });
				end
			end
			arr:add({name = color_equip[i], sub = sub});
		end
	end
	if arr:getSize() <= 0 then return; end

	self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, 0, 268, 485), Vector3(268, 65, 0), Vector3(244, 46, 0), Vector2(0, 0), Vector3(0, 16));
	self.btnList:setLocation(-460, -90, 0);
	self.btnList:setDepth(5);
	self.btnList:setMainBtnStyle("common_atlas_1", "ui_common_btn_p2", "ui_common_btn_p1", "D5DADE", "FFFFFF", 28);
	self.btnList:setSubBtnStyle("common_atlas_1", "ui_common_btn_p4", "ui_common_btn_p3", "92A0DA", "FFFCB7", 26);
	self.btnList:setData(arr, self, self.onSubClick, 0, 210); -- (485 - 65) / 2
	self:checkRedDot(DataCenter.roleData.career);

	local configList = getConfig({"equipment_compose", "prof_equip_choose"});
	local roleProfession = DataCenter.roleData.profession + 1;
	if roleProfession > #configList then
		roleProfession = #configList;
	end
	if self.level_limitArr[1][configList[roleProfession]] > DataCenter.roleData.level then
		roleProfession = roleProfession - 1;
	end
	self.btnList:setMainSlected(1, configList[roleProfession]);

	self.returnBtn.clickScale = false;
	self.returnBtn:addClickFuntion(self, self.onReturnClick);
	self.titleBg_1:addClickFuntion(self, self.onOpenTipsClick);
	self.tipsIcon:addClickFuntion(self, self.onHelpClick);
	self.desLbl2:addClickFuntion(self, self.onAddEquipClick);
	self.desLbl3:addClickFuntion(self, self.onAddEquipClick);
	self.desLbl4:addClickFuntion(self, self.onAddEquipClick);
	self.desLbl5:addClickFuntion(self, self.onAddEquipClick);
	self.desLbl6:addClickFuntion(self, self.onAddEquipClick);
	self.yijianBtn:addClickFuntion(self, self.onOncePutClick);
	self.ronglianBtn:addClickFuntion(self, self.onRongLianClick);

	self:addLuaEvent("UPDATE_COST", self, self.onUpdateView);
	self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent);
	self:addLuaEvent("UPDATE_RONGLIANPANEL_REDDOT", self, self.checkRedDot);
	self:addLuaEvent("REMOVE_EQUIP", self, self.onRemoveEquip);
	-- self:addLuaEvent("REMOVE_YULAN_EQUIP", self, self.onRemoveYuLanEquip);
	self:addLuaEvent("TIPS_CHANGE", self, self.onSanJiaoChange);
	self:addLuaEvent("ON_EQUIPSELECT_ITEMCLICK", self, self.onEquipSelecteCellClick);
	self:addLuaEvent("PUT_INTO_EQUIP", self, self.onPutIntoEquip);
end

function Lua_RongLianPanel:ObjectState(state1, state2)
	local offsetLen = 0
	if self.rateArr ~= nil and #self.rateArr ~= 0 then
		offsetLen = #self.rateArr - 1;
	end
	self.desLbl2:setEnable(state1);
	self.desLbl3:setEnable(state1);
	self.desLbl4:setEnable(state1);
	self.desLbl5:setEnable(offsetLen == 1 or offsetLen == 2);
	self.desLbl6:setEnable(offsetLen == 2);
	self.suo2:setEnable(state2);
	self.suo3:setEnable(state2);
	self.suo4:setEnable(state2);
	self.suo5:setEnable(offsetLen == 0);
	self.suo6:setEnable(offsetLen == 0 or offsetLen == 1);
end

function Lua_RongLianPanel:checkRedDot(index)
	index = index or self._list.index;

	local arr = DataCenter.equData:getRonglianRedData();
	self.hongdian_title:setEnable(arr:getSize() > 0);

	local mainIndexState = false;
	local mainIndexState2 = false;
	local mainIndexState3 = false;
	local subArr1 = Array();
	local subArr2 = Array();
	local subArr3 = Array();
	for i = 1, arr:getSize() do
		if arr[i].carrer == index and arr[i].mainIndex == 1 then
			mainIndexState = true;
			subArr1:add(arr[i].subIndex);
		elseif arr[i].carrer == index and arr[i].mainIndex == 2 then
			mainIndexState2 = true;
			subArr2:add(arr[i].subIndex);
		elseif arr[i].carrer == index and arr[i].mainIndex == 3 then
			mainIndexState3 = true;
			subArr3:add(arr[i].subIndex);
		end
	end
	self.btnList:setRedDot(1, { mainIndexState, mainIndexState2, mainIndexState3 });

	self.list1 = {};
	self.list2 = {};
	self.list3 = {};
	for i = 1, 11 do
		if mainIndexState == true then
			for j = 1, subArr1:getSize() do
				self.list1[i] = i == subArr1[j];
			end
		end
		if mainIndexState2 == true then
			for j = 1, subArr2:getSize() do
				self.list2[i] = i == subArr2[j];
			end
		end
		if mainIndexState3 == true then
			for j = 1, subArr3:getSize() do
				self.list3[i] = i == subArr3[j];
			end
		end
	end
	self:onBtnListRedDotChange();
end

function Lua_RongLianPanel:onBtnListRedDotChange()
	if self.mainIndex == 1 then
		self.btnList:setRedDot(2, self.list1);
		self.hongdian_plus:setEnable(self.list1[self.btnIndex]);
		self.hongdian_btn:setEnable(self.list1[self.btnIndex]);
		self._list.partRedDot = self.list1[self.btnIndex];
	elseif self.mainIndex == 2 then
		self.btnList:setRedDot(2, self.list2);
		self.hongdian_plus:setEnable(self.list2[self.btnIndex]);
		self.hongdian_btn:setEnable(self.list2[self.btnIndex]);
		self._list.partRedDot = self.list2[self.btnIndex];
	elseif self.mainIndex == 3 then
		self.btnList:setRedDot(2, self.list3);
		self.hongdian_plus:setEnable(self.list3[self.btnIndex]);
		self.hongdian_btn:setEnable(self.list3[self.btnIndex]);
		self._list.partRedDot = self.list3[self.btnIndex];
	end
end

function Lua_RongLianPanel:onSubClick(data)
	self.curInfo = data;
	self.mainIndex = data.mainIndex;
	self.btnIndex = data.btnIndex;

	local order_equip = getConfig({"equipment_compose", "order_equip"});
	local key = "a" .. self._list.index;
	self._list.idxArr = order_equip[key][key .. data.mainIndex - 1 .. string.format("%02d", data.btnIndex)][2];
	self._list.btnIndex = data.btnIndex;
	self._list.mainIndex = data.mainIndex;

	self:onBtnListRedDotChange();
	self:checkRedDot(self._list.index);

	local list = {};
	for i = 1, self._count[data.mainIndex] do
		list[i] = DataCenter.roleData.level >= self.level_limitArr[data.mainIndex][i];
	end
	self.btnList:setBtnGray(2, list);

	if list[data.btnIndex] == false then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(120550), tostring(self.level_limitArr[data.mainIndex][data.btnIndex])));
		return;
	end
	self:infoShowState(true);
	self:onRemoveYuLanEquip();
	self:onShowEquipList();
	self.tipsLab:setEnable(self.mainIndex == 3);
end

function Lua_RongLianPanel:infoShowState(state)
	self.tipsLab:setEnable(state);
	self.dragListObj:SetActive(state);
	self.rongLianObj:SetActive(not state);
end

function Lua_RongLianPanel:onRemoveYuLanEquip()
	self:onUpdateView();
	if self.equipImg ~= nil then
		self.equipImg:dispose();
	end
	DataCenter.equData.outPutData = nil;
	self.materialsArr = nil;
	self.rateArr = nil;
	self:ObjectState(false, true);
end

function Lua_RongLianPanel:onUpdateView()
	if self.costItem ~= nil then
		local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.costItemId);
		self.costItem:showNumLimit(hadCount, self.costItem.data.count, 2);
	end

	self.pkg_indexArr:clear();
	if self.goArr == nil then
		self.goArr = Array();
	else
		self.goArr:dispose();
		self.goArr:clear();
	end
	self:updateRate();
end

function Lua_RongLianPanel:updateRate()
	if self.materialsArr == nil then
		self.rateLab.text = "";
		return
	end

	local idxLen = self.pkg_indexArr:getSize();
	if idxLen == 0 then
		self.rateLab.text = LanUtil.getValue(120549);
		return;
	end

	local needCount = #self.materialsArr - #self.rateArr + 1;
	self.maxRate = self.rateArr[#self.rateArr];
	if idxLen < needCount then
		self.curRate = -1;
		self.rateLab.text = LanUtil.getValue(120549);
	else
		self.curRate = self.rateArr[idxLen - needCount + 1];
		self.rateLab.text = LanUtil.formateStr(LanUtil.getValue(110582), tostring(self.curRate));
	end
end

function Lua_RongLianPanel:onShowEquipList()
	local equipList;
	if self._list.index == 4 then
		equipList = Lua_RongLianUtil.getCommon_equip();
	else
		equipList = Lua_RongLianUtil.getSelected_equipArr();
	end

	local id;
	local arr = Array();
	for i = 1, #equipList do
		id = self._list.idxArr[i];
		materialsArr = getConfig({ "equipment_compose", id, "materials"});
		arr:add({
			index = i,
			idx = id,
			partRedDot = self._list.partRedDot,
			rateArr = getConfig({"equipment_compose", id, "rate_arr"}),
			output = getConfig({"equipment_compose", id, "output"}),
			star = getConfig({"equipment_compose", id, "star" }),
			costItem = getConfig({"equipment_compose", id, "cost_item"}),
			materialsArr = materialsArr,
			listKey = materialsArr[1][1]..materialsArr[1][2]..materialsArr[1][3]..
				materialsArr[1][4]..materialsArr[1][5]..materialsArr[1][6]
		});
	end
	self.equip_DragList:setLuaArrayData(arr, false);
end

function Lua_RongLianPanel:onSuccessEvent()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_qianghua", "gui_qianghua", 89, -7);
		self.effect:SetRenderQueue(self.preReadLab, 5, 2, false);
	end
	self.effect:setEnable(false);
	self.effect:setEnable(true);

	if self.effectZiTi == nil then
		self.effectZiTi = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_ronglianziti", "gui_ronglianziti", 89, -114);
		self.effectZiTi:SetRenderQueue(self.preReadLab, 10, 2, false);
	end
	self.effectZiTi:setEnable(false);
	self.effectZiTi:setEnable(true);
end

function Lua_RongLianPanel:onRemoveEquip(go)
	local tempIdxArr = Array();
	for i = 1, self.goArr:getSize() do
		if self.goArr[i].data ~= nil and go ~= nil and go.index == self.goArr[i].data.index then
			DataCenter.equData.selected_EquArr:add(go);
			self.goArr[i]:dispose();
			
			tempIdxArr:add({idx = i, index = go.index});
		end
	end

	for i = 1, tempIdxArr:getSize() do
		self.goArr:remove(tempIdxArr[i].idx);
		for c = 1, self.pkg_indexArr:getSize() do
			if self.pkg_indexArr[c].index == tempIdxArr[i].index then
				self.pkg_indexArr:remove(c);
				break;
			end
		end
	end
	self:updateRate();
end

function Lua_RongLianPanel:onSanJiaoChange(value)
	self.sanjiao:setRot(0, 0, value.isbol and 1 or 0, 1);

	if self.idx ~= nil then
		self.idx = nil;
	end

	if self.pkg_indexArr ~= nil then
		self.pkg_indexArr:clear();
		self.rateLab.text = ""
	end

	if value.isbol == true then
		self.titleLab_1.text = self.titleLab_1.text;
	else
		self.titleLab_1.text = value.txt;
		self._list.index = value.index;
		if self.mainIndex == nil then
			self._list.idxArr = nil;
		else
			local order_equip = getConfig({"equipment_compose", "order_equip"});
			local key = "a" .. self._list.index;
			self._list.idxArr = order_equip[key][key .. self.mainIndex - 1 .. string.format("%02d", self.btnIndex)][2];
		end
	end
	self:checkRedDot(value.index);
end

function Lua_RongLianPanel:onEquipSelecteCellClick(data)
	self:infoShowState(false);
	self:onEquipChange(data);
end

function Lua_RongLianPanel:onEquipChange(value)
	self.idx = value.idx;
	self.materialsArr = value.materialsArr;
	self.rateArr = value.rateArr
	if self.goArr == nil then
		self.goArr = Array();
	else
		for i = 1, self.goArr:getSize() do
			self.goArr[i]:dispose();
		end
	end

	if self.costItem ~= nil then
		self.costItem:dispose();
		self.costItem = nil;
		self.costItemId = 0;
	end

	if value == nil then
		self:ObjectState(false, true);

		if self.equipImg ~= nil then
			self.equipImg:dispose();
		end
		DataCenter.equData.outPutData = nil;
	else
		self:ObjectState(true, false);

		local equipVo = Lua_ToolVo.new(value.output, 0, 0);
		equipVo.star = value.star;
		DataCenter.equData.outPutData = equipVo;

		self.equipImg = Lua_ToolImage.new(self.showBg.mainContent);
		self.equipImg:setDepth(15);
		self.equipImg.data = equipVo;
		-- self.equipImg:showCloseSp(true, true, "REMOVE_YULAN_EQUIP", "Lua_ForgingWindow", Vector3(30, 30));
		self.equipImg:showStars(value.star);

		self.pkg_indexArr:clear();
		if value.costItem ~= nil then
			self.costItemId = value.costItem[1][1];
			local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.costItemId);

			self.costItem = Lua_ToolImage.new(self.duanzao1.mainContent);
			self.costItem.data = Lua_ToolVo.new(value.costItem[1][1], value.costItem[1][2]);
			self.costItem:setDepth(15);
			self.costItem:showNumLimit(hadCount, value.costItem[1][2], 2);
		end
		self:updateRate()
	end
	DataCenter.equData.equipArr = self.materialsArr;
end

function Lua_RongLianPanel:onPutIntoEquip(data)
	self.mtImg = Lua_ToolImage.new(self.duanzaoBgArr[self.goParIdx - 1].mainContent);
	self.mtImg.data = data;
	self.mtImg:setDepth(15);
	self.mtImg:showNum(0, true);
	self.mtImg:showCloseSp(true, true, "REMOVE_EQUIP", "Lua_ForgingWindow", Vector3(30, 30));

	self.goArr:add(self.mtImg);
	self.pkg_indexArr:add({index = self.mtImg.data.index, bind = self.mtImg.data.bind});

	local arr = DataCenter.equData.selected_EquArr;
	for i = 1, self.goArr:getSize() do
		for j = 1, arr:getSize() do
			if self.goArr[i].data ~= nil and arr[j] ~= nil and self.goArr[i].data.index == arr[j].index then
				arr:remove(j);
				break;
			end
		end
	end
	self:updateRate();
end

function Lua_RongLianPanel:onReturnClick(go)
	self:onSubClick(self.curInfo);
end

function Lua_RongLianPanel:onOpenTipsClick()
	self._list.isbol = true;
	self._list.txt = self.titleLab_1.text;
	self:onSanJiaoChange(self._list);
	Lua_WindowUtil.openWin("Lua_RongLianTipsWindow", WinParam.ACTION_AUTO, self._list);
end

function Lua_RongLianPanel:onHelpClick()
	if self.mainIndex ~= 3 then
		Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(120511));
	else
		Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(120590));
	end
end

function Lua_RongLianPanel:onAddEquipClick(go)
	self.goParIdx = tonumber(string.sub(go.name, -1, -1));
	Lua_WindowUtil.openWin("Lua_TiHuanEquipWindow", WinParam.ACTION_AUTO);
end

function Lua_RongLianPanel:onOncePutClick()
	if self.materialsArr == nil then
		OperateAlert.show(LanUtil.getValue(110580));
		return;
	end

	DataCenter.equData.equipArr = self.materialsArr;
	DataCenter.equData.outPutData = self.equipImg.data;
	
	self.pkg_indexArr:clear();
	if self.goArr == nil then
		self.goArr = Array();
	else
		for i = 1, self.goArr:getSize() do
			self.goArr[i]:dispose();
		end
	end
	self.goArr:clear();

	local _mater = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsBySubType({ Lua_PackTypeDefine.EQUIP });
	local index = 0;
	for i = 1, #self.materialsArr do
		local _materArr = Array();
		if _mater ~= nil and _mater:getSize() ~= 0 then
			for j = 1, _mater:getSize() do
				if _mater[j].star == self.materialsArr[i][3] and _mater[j].career == self.equipImg.data.career and _mater[j].order == self.materialsArr[i][4] and _mater[j].color == self.materialsArr[i][5] then
					_materArr:add(_mater[j]);
				end
			end

			if _materArr:getSize() ~= 0 then
				if _materArr[i] ~= nil then
					self.mtImg = Lua_ToolImage.new(self.duanzaoBgArr[i].mainContent);
					self.mtImg.data = _materArr[i];
					self.mtImg:setDepth(15);
					self.mtImg:showNum(0, true);
					self.mtImg:showCloseSp(true, true, "REMOVE_EQUIP", "Lua_ForgingWindow", Vector3(30, 30));
					self.mtImg:showNewTip(false);
					self.goArr:add(self.mtImg);

					index = index + 1;
					if _materArr[index] ~= nil then
						self.pkg_indexArr:add({index = _materArr[index].index, bind = _materArr[index].bind});
					end
				end
				self:updateRate();
			else
				OperateAlert.show(LanUtil.getValue(110581));
				return;
			end
		else
			OperateAlert.show(LanUtil.getValue(110581));
			break;
		end
	end

	local arr = DataCenter.equData.selected_EquArr;
	local idxArr = Array();
	for i = 1, self.goArr:getSize() do
		for j = 1, arr:getSize() do
			if self.goArr[i].data.index == arr[j].index and idxArr:indexOf(j) == -1 then
				idxArr:add(j);
			end
		end
	end

	for i = 1, idxArr:getSize() do
		arr:remove(1);
	end
end

function Lua_RongLianPanel:onRongLianClick()
	if self.materialsArr == nil then
		OperateAlert.show(LanUtil.getValue(110580));
		return;
	else
		if self.costItem ~= nil then
			local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.costItemId);
			if hadCount < self.costItem.data.count then
				OperateAlert.show(LanUtil.getValue(120549));
				return;
			end
		end

		local isHas_bindItem = false;
		self.cmd = ProtoPublic_pb.Proto11400625();
		for i = 1, self.pkg_indexArr:getSize() do
			self.cmd.pkg_index:append(self.pkg_indexArr[i].index);
			if self.pkg_indexArr[i].bind == 1 then
				isHas_bindItem = true;
			end
		end

		if self.idx ~= nil then
			self.cmd.rule_id = self.idx;
		else
			OperateAlert.show(LanUtil.getValue(120539));
			return;
		end

		if isHas_bindItem == false then
			self:checkRate();
		else
			local tipData = {
				owner = self,
				titleName = LanUtil.getValue(120544),
				des = LanUtil.getValue(120547),
				type = 1,
				subFun = self.checkRate,
				subName = LanUtil.getValue(120546),
				cancelName = LanUtil.getValue(120545)
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		end
	end
end

function Lua_RongLianPanel:checkRate()
	if self.curRate ~= self.maxRate then
		if self.curRate ~= -1 then
			Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_CLOSE);
			local tipData = {
				owner = self,
				des = LanUtil.formateStr(LanUtil.getValue(120548), tostring(self.curRate), tostring(self.maxRate)),
				txtPivot = UIWidget.Pivot.Left,
				txtFontSize = 26,
				txtSpacingY = 10,
				type = 1,
				subFun = self.onSureCallBack,
				subName = LanUtil.getValue(120546)
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		else
			sendMsg(11400625, self.cmd);
		end
	else
		sendMsg(11400625, self.cmd);
	end
end

function Lua_RongLianPanel:onSureCallBack()
	sendMsg(11400625, self.cmd);
end

function Lua_RongLianPanel:dispose()
	if self.equip_DragList ~= nil then
		self.equip_DragList:dispose();
		self.equip_DragList = nil;
	end
	self:superCall("dispose");
end