checkRequire("Lua_RongLianUtil");
Lua_RongLianTipsWindow = class("Lua_RongLianTipsWindow", Lua_Window);
function Lua_RongLianTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RongLianTipsWindow";
	self.isClickClose = true;
	self.blackAlpha = 1 / 255;
	self.showClose = false;
end

function Lua_RongLianTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.maskBg:setDepth(3500);

	local listArr = Lua_RongLianUtil.getCareer_equip();
	self._showData = Lua_WindowUtil.getWinData("Lua_RongLianTipsWindow", true);
	self.Arr = Array();
	for i = 1, #listArr do
		self.Arr:add({index = i, selected = i == self._showData.index, txt = listArr[i]});
	end
	self.tips_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 268, 198));
	self.tips_DragList:setLocation(-460, 50, 0);
	self.tips_DragList:setListCell(Lua_RongLianTipsItem, 66, 268, 1);
	self.tips_DragList:setLuaArrayData(self.Arr, true);

	self.ronglian_downMenu = UICreate.createUIAtlasImage(self.content, "feature_atlas", "ui_duanzao_title_04", -460, 54, 298, 220);

	self:addLuaEvent("onTipsCellClick", self, self.onTipsCellClick);
end

function Lua_RongLianTipsWindow:onTipsCellClick(data)
	local _data = data;
	for i = 1, self.Arr:getSize() do
		if self.Arr[i].index == data.index then
			self.Arr[i].selected = true;
		else
			self.Arr[i].selected = false;
		end
	end
	self.tips_DragList:setLuaArrayData(self.Arr, false);

	Lua_CommonUtil.delayCall(0.01, self, self.hide, data);
end

function Lua_RongLianTipsWindow:hide(data)
	local txt;
	local index;
	if data == nil then
		txt = self._showData.txt;
		index = self._showData.index;
	else
		txt = data.txt;
		index = data.index;
	end
	Lua_MsgUtil.callFunc("TIPS_CHANGE", {isbol = false, txt = txt, index = index});
	Lua_CommonUtil.removeTimer(self, self.hide);

	self:superCall("hide");
end

function Lua_RongLianTipsWindow:dispose()
	if self.tips_DragList ~= nil then
		self.tips_DragList:dispose();
		self.tips_DragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.hide);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RongLianTipsItem = class("Lua_RongLianTipsItem", Lua_ListCell);
function Lua_RongLianTipsItem:ctor(p)
	self:superCall("ctor", p, "RongLianTipsItem_skin");
end

function Lua_RongLianTipsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 125, 25, 0, 0)
	self.redDot:setDepth(6);
	self.redDot.clickScale = false;
	self.redDot.name = "redDot"
	self.redDot:setEnable(false);
end

function Lua_RongLianTipsItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.tipsLbl.text = data.txt;

	self.tipsBg:setAltas("common_atlas_1", data.selected and "ui_common_btn_p1" or "ui_common_btn_p2");
	self.tipsLbl.colorStr = data.selected and Lua_ColorDefine.transColor("FFFFFF") or Lua_ColorDefine.transColor("D5DADE");

	self:checkRedDot();
end

function Lua_RongLianTipsItem:checkRedDot(go)
	local arr = DataCenter.equData:getRonglianRedData();
	local len = arr:getSize();
	for i = 1, len do
		if self._data.index == arr[i].carrer then
			self.redDot:setEnable(true);
		else
			self.redDot:setEnable(false);
		end
	end
end

function Lua_RongLianTipsItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onTipsCellClick", self._data);
end

function Lua_RongLianTipsItem:dispose(go)
	self._data = nil;
	self:superCall("dispose");
end