checkRequire("Lua_JueXingPanel"); -- 神煉
checkRequire("Lua_FuLingPanel"); -- 附靈
Lua_ShenLianPanel = class("Lua_ShenLianPanel", Lua_DisplayObject);
function Lua_ShenLianPanel:ctor(p)
	self:superCall("ctor", p, "ForgingPanel_skin");
end

function Lua_ShenLianPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.initIndex = 1
	self.isFirstClick = true

	self.btnNames = Array();
	self.btnNames:add({name = LanUtil.getValue(128900), panel = Lua_JueXingPanel, openId = 10182, eventIds = {10811}});
	self.btnNames:add({name = LanUtil.getValue(128906), panel = Lua_FuLingPanel, openId = 10182, eventIds = {10812}});

	self.forgingList = Lua_ButtonList.new(self.content, self.btnNames, 154, self, self.onButtonListClick,
		"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 148, 66), Vector4(0, 0, 148, 66),
		Lua_ColorDefine.transColor("D2D8DC"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(28, 28, 120, 30), 2, "common_atlas_1");
	self.forgingList:setDepth(5);
	self.forgingList:setRedDotPos(63, 23);
	self.forgingList:setLocation(-540, 250, 0);

	local len = self.btnNames:getSize()
	local initIndex = 1
	local winData = DataCenter.equData.ForgingWindowData
	if winData ~= nil and type(winData) == "number" then
		initIndex = winData
	elseif winData ~= nil and winData.nameIndex ~= nil then
		for i = 1, len do
			if self.btnNames[i].name == LanUtil.getValue(winData.nameIndex) then
				initIndex = i;
				break;
			end
		end
	end
	self.forgingList:setSelected(initIndex, true);

	for i = 1, len do
	local isShowIcon = true
		if self.btnNames[i].openId == nil or DataCenter.funcOpenData:isOpened(self.btnNames[i].openId) == true then
			self.forgingList:setBtnGray(false, i, isShowIcon);
		else
			local cfg = getConfig( { "func_open", self.btnNames[i].openId });
			if cfg ~= nil and cfg.advance_function ~= nil then
				isShowIcon = cfg.advance_function == 1
			end
			self.forgingList:setBtnGray(true, i, isShowIcon);
		end
	end
end

function Lua_ShenLianPanel:onButtonListClick(val)
	if self.initIndex == val and self.isFirstClick == false then
		return;
	end

	if self.btnNames[val].openId ~= nil and DataCenter.funcOpenData:isOpened(self.btnNames[val].openId) == false then
		local cfg = getConfig({"func_open", self.btnNames[val].openId});
		if cfg ~= nil and cfg.advance_message ~= nil then
			OperateAlert.show(cfg.advance_message);
		end
		return;
	end

	if self.isFirstClick == true then
		self.isFirstClick = false;
	end
	self.initIndex = val;

	if self.panel ~= nil then
		self.panel:dispose();
		self.panel = nil;
	end

	if self.btnNames[self.initIndex].panel == nil then
		return;
	end
	self.panel = self.btnNames[self.initIndex].panel.new(self.content)
end

function Lua_ShenLianPanel:dispose()
	if self.forgingList ~= nil then
		self.forgingList:dispose()
		self.forgingList = nil
	end
	if self.panel ~= nil then
		self.panel:dispose();
		self.panel = nil;
	end
	DataCenter.equData.ForgingWindowData = nil

	self:superCall("dispose");
end
