Lua_TiHuanEquipWindow = class("Lua_TiHuanEquipWindow", Lua_Window);
function Lua_TiHuanEquipWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TiHuanEquipWindow";
	self.skinName = "TiHuan_skin";
end

function Lua_TiHuanEquipWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.titleNameLab.text = LanUtil.getValue(120535);

	self.tihuanBtn:setEnable(false);
	self.xiexiaBtn:setEnable(false);

	local arr = DataCenter.equData.selected_EquArr;
	arr:sort("index", false);
	self.tihuan_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 380, 432));
	self.tihuan_DragList:setLocation(0, -35, 0);
	self.tihuan_DragList:setListCell(Lua_TiHuanEquItem, 126, 380, 1);
	self.tihuan_DragList:setLuaArrayData(arr, false);

	self:addLuaEvent("onTiHuanCellClick", self, self.onTiHuanCellClick);
end

function Lua_TiHuanEquipWindow:onTiHuanCellClick(data)
    self.data = data
    if self.data == nil then
        return;
    end

    Lua_MsgUtil.callFunc("PUT_INTO_EQUIP", self.data);
    self:hide()
end

function Lua_TiHuanEquipWindow:dispose()
	if self.tihuan_DragList ~= nil then
		self.tihuan_DragList:dispose();
		self.tihuan_DragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_TiHuanEquItem = class("Lua_TiHuanEquItem", Lua_ListCell);
function Lua_TiHuanEquItem:ctor(p)
	self:superCall("ctor", p, "TiHuanEquipItem_skin");
end

function Lua_TiHuanEquItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setCanClick(true);
	self.itemImg:setLocation(-132, 2, 0);
end

function Lua_TiHuanEquItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data;
	self.itemNameTxt.text = self.itemImg.data.colorName;
end

function Lua_TiHuanEquItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onTiHuanCellClick", self._data);
end

function Lua_TiHuanEquItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end