Lua_XiLianPanel = class("Lua_XiLianPanel", Lua_DisplayObject);
function Lua_XiLianPanel:ctor(p)
	self:superCall("ctor", p, "XiLianPanel_skin");
end

function Lua_XiLianPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.costMoney = 100; -- 购买时开启花费
	self.openCount = 0; -- 开启数量
	self.lockingNum = 0; -- 当前锁定数量
	self.redDot:setEnable(false);

	self.islockArr = Array();
	self.islockArr:add(false);
	self.islockArr:add(false);
	self.islockArr:add(false);
	self.islockArr:add(false);
	self.islockArr:add(false);

	self.desLabArr = Array();
	self.desLabArr:add(self.desLbl1);
	self.desLabArr:add(self.desLbl2);
	self.desLabArr:add(self.desLbl3);
	self.desLabArr:add(self.desLbl4);
	self.desLabArr:add(self.desLbl5);

	self.suoArr = Array();
	self.suoArr:add(self.suo1);
	self.suoArr:add(self.suo2);
	self.suoArr:add(self.suo3);
	self.suoArr:add(self.suo4);
	self.suoArr:add(self.suo5);

	self.objArr = Array();
	self.objArr:add({[1] = self.suo1, [2] = self.xlcs1});
	self.objArr:add({[1] = self.suo2, [2] = self.xlcs2});
	self.objArr:add({[1] = self.suo3, [2] = self.xlcs3});
	self.objArr:add({[1] = self.suo4, [2] = self.xlcs4});
	self.objArr:add({[1] = self.suo5, [2] = self.xlcs5});

	self.equipImg = Lua_ToolImage.new(self.duanzao2.mainContent);
	self.equipImg:setDepth(6);
	self.equipImg2 = Lua_ToolImage.new(self.duanzao1.mainContent);
	self.equipImg2:setDepth(6);

	self.suo1:addClickFuntion(self, self.onSuoClick);
	self.suo2:addClickFuntion(self, self.onSuoClick);
	self.suo3:addClickFuntion(self, self.onSuoClick);
	self.suo4:addClickFuntion(self, self.onSuoClick);
	self.suo5:addClickFuntion(self, self.onSuoClick);
	self.xilianBtn:addClickFuntion(self, self.onXiLianClick);
	self.tipsIcon:addClickFuntion(self, self.onRuleClick);

	self:addLuaEvent("ON_XILIAN_ITEM_CLICK", self, self.onUpdateXiLianShowInfo);
	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView);

	self.configPartsDic = Lua_CuiLianUtil.getShow_order();
	self.equipPartsDic = DataCenter.equData.parts; -- 装备部位
	local equvo;
	local obj;
	local arr = Array();
	for i = 1, #self.configPartsDic do
		equvo = DataCenter.equData:getEquByPart(self.configPartsDic[i]);
		if equvo == nil then
			obj = self.equipPartsDic[self.configPartsDic[i]];
			equvo = {
				id = obj.id,
				star = DataCenter.equData.star,
				equPart = obj.equPart,
				polish_open = obj.polish_open,
				polish_open_siz = obj.polish_open_siz
			};
		end
		arr:add(equvo);
	end

	self.xiLianList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 542));
	self.xiLianList:setListCell(Lua_XiLianItem, 116, 286, 1);
	self.xiLianList:setLocation(-460, -70, 0);
	self.xiLianList:setLuaArrayData(arr, false);
	if arr:getSize() > 0 then
		self.xiLianList.showList[1]:onPlayerSoundClick();
		self.xiLianList:setSelected(1);
	end
end

function Lua_XiLianPanel:onUpdateXiLianShowInfo(data)
	self.data = data;
	if self.data == nil then
		return;
	end
	self:onShowInfo();
end

function Lua_XiLianPanel:onUpdateView()
	local equvo;
	local obj;
	local arr = Array();
	for i = 1, #self.configPartsDic do
		equvo = DataCenter.equData:getEquByPart(self.configPartsDic[i]);
		if equvo == nil then
			obj = self.equipPartsDic[self.configPartsDic[i]];
			equvo = {
				id = obj.id,
				star = DataCenter.equData.star,
				equPart = obj.equPart,
				polish_open = obj.polish_open,
				polish_open_siz = obj.polish_open_siz
			};
		end
		arr:add(equvo);
	end
	self.xiLianList:setLuaArrayData(arr, false);

	for i = 1, arr:getSize() do
		if self.data.equPart == arr[i].equPart then
			self.data = arr[i];
		end
	end
	self:onShowInfo();
end

function Lua_XiLianPanel:onShowInfo()	
	self:onInitShowInfo();

	self.gradesLbl.text = self.data.xiLianGrades;
	self.tipsLbl.text = LanUtil.formateStr(LanUtil.getValue(110587), tostring(DataCenter.equData.free_polish_times));

	if self.data.id <= 0 then
		self.equipImg:setEnable(false);
		self.equipImg2:setEnable(false);
		self.redDot:setEnable(false);
		self:onChangeGold();

		for i = 1, self.desLabArr:getSize() do
			self.desLabArr[i].text = LanUtil.getValue(110573); -- 点击开启该洗练槽
		end
	else
		self.equipImg.data = self.data;
		self.equipImg:setEnable(true);
		self.equipImg2:setEnable(true);
		self:onCostCount();

		local info = self.data.wash_attrs;
		local attr;
		local isShow = false;
		for i = 1, #info do
			self.objArr[i][1]:setEnable(info[i].open);
			self.objArr[i][2]:setEnable(info[i].open);
			if info[i].open then
				if i == #info then
					isShow = self.data.star ~= 4;
				end
				if not isShow then
					self.openCount = self.openCount + 1;
				end

				attr = info[i].attr;
				if attr.attr_id ~= 0 then
					local str = Lua_CuiLianUtil.getAttr_name(attr.attr_id);
					str = string.format(str, Lua_ColorDefine.getItemColorStr(attr.color), attr.value, attr.lower, attr.upper);
					if not isShow then
						self.desLabArr[i].text = str;
					else
						self.desLabArr[i].text = str.." " ..LanUtil.getValue(120598);
					end
				else
					self.desLabArr[i].text = ""
				end
			else
				self.desLabArr[i].text = LanUtil.getValue(110573);
			end
		end
	end

	if self.desLabArr[3].text == LanUtil.getValue(110573) and self.data.id ~= 0 then
		self.xlc3:addClickFuntion(self, self.onxlcClick);
	else
		self.xlc3:removeClickFuntion(self, self.onxlcClick);
	end
	if self.desLabArr[4].text == LanUtil.getValue(110573) and self.data.id ~= 0 then
		self.xlc4:addClickFuntion(self, self.onxlcClick);
	else
		self.xlc4:removeClickFuntion(self, self.onxlcClick);
	end
	if self.desLabArr[5].text == LanUtil.getValue(110573) and self.data.id ~= 0 then
		self.xlc5:addClickFuntion(self, self.onxlcClick);
	else
		self.xlc5:removeClickFuntion(self, self.onxlcClick);
	end

	self.xlcObj5:SetActive(self.data.star == 4); -- 4星粉装
	if self.data.id ~= 0 then
		local info = self.data.wash_attrs;
		if self.data.star ~= 4 and info[#info].open then
			self.xlcObj5:SetActive(true); -- 4星粉装开启直接显示，但直接锁定
			self.suoArr[#info]:setAltas("common_atlas_2", "ui_common_icon_jiesuo_1");
		end
	end
end

function Lua_XiLianPanel:onInitShowInfo()
	self.openCount = 0;
	self.lockingNum = 0;
	if self.data.id <= 0 then
		for i = 1, self.islockArr:getSize() do
			self.islockArr[i] = false;
			self.objArr[i][1]:setEnable(false);
			self.objArr[i][2]:setEnable(false);
			self.suoArr[i]:setAltas("common_atlas_2", "ui_common_icon_jiesuo_2");
		end
	else
		local info = self.data.wash_attrs;
		local state = true;
		for i = 1, self.islockArr:getSize() do
			if i == #info then -- 最后一条属性既要开启又要是4星粉装
				state = self.data.star == 4;
			end
			if info[i].open and info[i].lock and state then
				self.lockingNum = self.lockingNum + 1;
				self.islockArr[i] = true; -- 1 锁定
				self.objArr[i][1]:setEnable(true);
				self.objArr[i][2]:setEnable(true);
				self.suoArr[i]:setAltas("common_atlas_2", "ui_common_icon_jiesuo_1");
			else
				self.islockArr[i] = false;
				self.objArr[i][1]:setEnable(false);
				self.objArr[i][2]:setEnable(false);
				self.suoArr[i]:setAltas("common_atlas_2", "ui_common_icon_jiesuo_2");
			end
		end
	end
end

function Lua_XiLianPanel:onCostCount()
	local itemInfo = Lua_CuiLianUtil.getLock_cost(self.lockingNum + 1);
	local hadNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(itemInfo[1]);
	self.equipImg2.data = Lua_ToolVo.new(itemInfo[1], itemInfo[2], 0);
	self.equipImg2:showNumLimit(hadNum, itemInfo[2], 2);
	
	self.redDot:setEnable(DataCenter.equData.free_polish_times > 0 or hadNum >= itemInfo[2]);
	self:onChangeGold();
end

function Lua_XiLianPanel:onChangeGold()
	local costMoneyNum = Lua_CuiLianUtil.getLock_needMoney(self.lockingNum + 1) + Lua_CuiLianUtil.getGold();
	self.xiaohaoBox.txt.text = LanUtil.formateStr(LanUtil.getValue(110588), tostring(costMoneyNum));
end

function Lua_XiLianPanel:onxlcClick(go)
	if self.data.id == 0 then
		return;
	end

	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
		owner = self,
		des = LanUtil.formateStr(LanUtil.getValue(110598), tostring(self.costMoney)),
		type = 1,
		subFun = self.onOpenXiLianFun
	});
	self.cmd = ProtoPublic_pb.Proto11400620();
	self.cmd.part = self.data.part;
	self.cmd.polish_index = tonumber(string.sub(go.name, -1, -1)) - 1;
end

function Lua_XiLianPanel:onOpenXiLianFun(go)
	sendMsg(11400620, self.cmd);
end

function Lua_XiLianPanel:onSuoClick(go)
	if self.data == nil then
		return;
	end

	local info = self.data.wash_attrs;
	if go.name == self.suoArr[#info].name and self.data.star ~= 4 then
		OperateAlert.show(LanUtil.getValue(120599));
		return;
	end

	local lockedCount = 0;
	local idx = 1;
	for i = 1, self.suoArr:getSize() do
		if self.islockArr[i] then
			lockedCount = lockedCount + 1;
		end
		if go.name == self.suoArr[i].name then
			idx = i;
		end
	end
	if not self.islockArr[idx] then
		if lockedCount == self.openCount - 1 then
			OperateAlert.show(LanUtil.getValue(120512));
			return;
		end
	end
	self.islockArr[idx] = not self.islockArr[idx];
	
	self.lockingNum = self.islockArr[idx] and lockedCount + 1 or lockedCount - 1;
	self.suoArr[idx]:setAltas("common_atlas_2", self.islockArr[idx] and "ui_common_icon_jiesuo_1" or "ui_common_icon_jiesuo_2");
	self:onCostCount();
end

function Lua_XiLianPanel:onXiLianClick(go)
	if self.data == nil or self.data.id <= 0 then
		return;
	end

	if self.data.star ~= 4 and self.lockingNum == 4 then
		OperateAlert.show(LanUtil.getValue(160300));
		return;
	end

	self.cmd2 = ProtoPublic_pb.Proto11400619();
	self.cmd2.part = self.data.equPart;
	self.cmd2.add_money = self.xiaohaoBox.seleted;
	for i = 1, self.islockArr:getSize() do
		if self.islockArr[i] then
			self.cmd2.lock_list:append(i - 1);
		end
	end

	local info = self.data.wash_attrs
	local isColor = false; -- 品质大于3且没有锁定的要tips
	for i = 1, #info do
		if info[i].open then
			if info[i].attr.color > 3 and not self.islockArr[i] then
				isColor = true;
				break;
			end
		end
	end
	if isColor then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
			owner = self,
			des = LanUtil.getValue(120508),
			type = 1,
			subFun = self.onSureXiLianFun
		});
	else
		sendMsg(11400619, self.cmd2);
	end
end

function Lua_XiLianPanel:onSureXiLianFun(go)
	sendMsg(11400619, self.cmd2);
end

function Lua_XiLianPanel:onRuleClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(110597));
end

function Lua_XiLianPanel:dispose()
	if self.equipImg ~= nil then
		self.equipImg:dispose();
		self.equipImg = nil;
	end
	if self.equipImg2 ~= nil then
		self.equipImg2:dispose();
		self.equipImg2 = nil;
	end
	if self.xiLianList ~= nil then
		self.xiLianList:dispose();
		self.xiLianList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_XiLianItem = class("Lua_XiLianItem", Lua_ListCell);
function Lua_XiLianItem:ctor(p)
	self:superCall("ctor", p, "XiLianItem_skin");
end

function Lua_XiLianItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-93.5, 2.5, 0);
end

function Lua_XiLianItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.id ~= 0 then
		self.lockIcon:setEnable(false);
		self.itemImg.data = data;
		self.itemTxt.text = self.itemImg.data.colorName;
	else
		self.lockIcon:setEnable(not data.polish_open); -- 未开启
		self.itemImg.data = nil;
		self.itemTxt.text = LanUtil.formateStr(LanUtil.getValue(110577), Lua_CuiLianUtil.getEquip_part(data.equPart));
	end

	if data.polish_open then
		if data.id ~= 0 then
			self.itemTipsTxt.text = LanUtil.formateStr(LanUtil.getValue(110574), tostring(data.polish_open_siz));
		else
			self.itemTipsTxt.text = LanUtil.getValue(120510);
		end
	else
		local openLv = Lua_CuiLianUtil.getOpen_level(data.equPart); -- 部位洗练开启等级
		if DataCenter.roleData.level < openLv then
			self.itemTipsTxt.text = LanUtil.formateStr(LanUtil.getValue(110575), tostring(openLv));
		else
			self.itemTipsTxt.text = LanUtil.getValue(110576); -- 点击开启
		end
	end
	self:updateXiLianRedDot();
end

function Lua_XiLianItem:updateXiLianRedDot()
	local openLv = Lua_CuiLianUtil.getOpen_level(self._data.equPart); -- 部位洗练开启等级
	self.redDot:setEnable(not self._data.polish_open and DataCenter.roleData.level >= openLv); -- 未开启满足开启等级
	-- 已开启且有装备
	if self._data.polish_open and self._data.id ~= 0 then
		if DataCenter.equData.free_polish_times > 0 then
			self.redDot:setEnable(true);
		else
			local id = Lua_CuiLianUtil.getLock_cost(1)[1];
			local costnum = Lua_CuiLianUtil.getLock_cost(1)[2];
			local hadNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(id);
			self.redDot:setEnable(hadNum >= costnum);
		end
	end
end

function Lua_XiLianItem:onPlayerSoundClick(go)
	local openLv = Lua_CuiLianUtil.getOpen_level(self._data.equPart); -- 部位洗练开启等级
	if DataCenter.roleData.level < openLv and not self._data.polish_open then
		OperateAlert.show(LanUtil.getValue(120509));
		return;
	end
	if not self._data.polish_open and DataCenter.roleData.level >= openLv then
		self:openXiLianFun(); -- 开启洗练
	end
	Lua_MsgUtil.callFunc("ON_XILIAN_ITEM_CLICK", self._data);
end

function Lua_XiLianItem:openXiLianFun(go)
	local cmd = ProtoPublic_pb.Proto11400620();
	cmd.part = self._data.equPart; -- 装备位置
	cmd.polish_index = 0; -- 洗练位置
	sendMsg(11400620, cmd);
end

function Lua_XiLianItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_XiLianItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end