Lua_ZhuLingItem = class("Lua_ZhuLingItem", Lua_ListCell);
function Lua_ZhuLingItem:ctor(p)
	self:superCall("ctor", p, "ZhuLingItem_skin");
end

function Lua_ZhuLingItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-93.5, 2.5, 0);
end

function Lua_ZhuLingItem:setData(data)
	self._data = data
	if data == nil then
		return;
	end

	self.itemImg.data = self._data
	self.itemTxt.text = self._data.colorName
	self.itemTipsTxt.text = self._data.zhuLingName
	self:checkRedot();
end

function Lua_ZhuLingItem:checkRedot()
	self._data.zhuLingRedDot = self._data.zhuLingMax == false and self:getZhuLingRedDot(self._data.equPart, self._data.mana_rank, self._data.mana_level, self._data.zhuLingState)
	self.redDot:setEnable(self._data.zhuLingRedDot);
end

function Lua_ZhuLingItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onZhuLingCellClick", self._data);
end

function Lua_ZhuLingItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_ZhuLingItem:getZhuLingRedDot(equPart, mana_rank, mana_level, zhuLingState)
	local rankIndex = mana_rank
	if mana_rank == 0 then
		rankIndex = 1
	end

	local rankItemId = Lua_ZhuLingUtil.getCostRank_item(equPart)
	local rankItemNum = Lua_ZhuLingUtil.getCostRank_cost(equPart, rankIndex + 1)
	local rankItem_hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(rankItemId);
	local levelItemId = Lua_ZhuLingUtil.getCostLevel_item(equPart)
	local _mana_rank = mana_rank
	local _mana_level = mana_level + 1
	if mana_rank == 0 then
		_mana_rank = 1
	else
		_mana_rank = mana_rank
	end

	if mana_level == 2 then
		_mana_rank = mana_rank + 1
		_mana_level = 0
	end

	if mana_level == 0 and mana_rank == 0 then
		_mana_rank = 1
		_mana_level = 0
	end

	local levelItemNum = Lua_ZhuLingUtil.getCostLevel_cost(equPart, _mana_rank, _mana_level + 1)
	local levelItem_hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(levelItemId);
	local isRed = false
	if zhuLingState == 1 then
		isRed = levelItem_hadCount >= levelItemNum
	else
		isRed = levelItem_hadCount >= levelItemNum and rankItem_hadCount >= rankItemNum
	end
	return isRed
end

function Lua_ZhuLingItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end