﻿checkRequire("Lua_ZhuLingItem");
checkRequire("Lua_ZhuLingTxtItem");
checkRequire("Lua_SkillAnimalItem");
Lua_ZhuLingPanel = class("Lua_ZhuLingPanel", Lua_DisplayObject);
function Lua_ZhuLingPanel:ctor(p)
	self:superCall("ctor", p, "ZhuLingPanel_skin");
end

function Lua_ZhuLingPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.itemOutPutId = 0;
	self.isFirstZhuLing = false;
	self.skillListLeft = {};
	self.skillListRight = {};
	self.redDot:setEnable(false);

	self:addLuaEvent("onZhuLingCellClick", self, self.onZhuLingCellClick);
	self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent);
	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView);

	self.zhuling_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 500));
	self.zhuling_DragList:setListCell(Lua_ZhuLingItem, 116, 286, 1);
	self.zhuling_DragList:setLocation(-460, -85, 0);

	self.left_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 238, 106));
	self.left_DragList:setLocation(-88, -45, 0);
	self.left_DragList:setListCell(Lua_ZhuLingTxtItem, 35, 238, 1);

	self.right_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 238, 106));
	self.right_DragList:setLocation(313, -45, 0);
	self.right_DragList:setListCell(Lua_ZhuLingTxtItem, 35, 238, 1);

	self:setListData();

	if self.Arr:getSize() > 0 then
		self.zhuling_DragList.showList[1]:onPlayerSoundClick();
		self.zhuling_DragList:setSelected(1);
	end

	self.helpIcon:addClickFuntion(self, self.onHelpClick);
	self.clickBtn:addClickFuntion(self, self.onBtnClick);
end

function Lua_ZhuLingPanel:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(120571));
end

function Lua_ZhuLingPanel:onBtnClick()
	if self.data == nil then
		return
	end
	
	if self.itemOutPutId == 0 then
		local cmd = getProtoMsg("Proto11400628");
		cmd.part = self.data.equPart;
		sendMsg(11400628, cmd)
	else
		local arr = Array();
		arr:add(Lua_ToolVo.new(self.itemOutPutId, 1, 1));
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end

function Lua_ZhuLingPanel:onSuccessEvent(msg)
	if msg == nil then
		return;
	end

	if msg.level_up == false then
		self:onZhuLingEffect()
	else
		if self.isFirstZhuLing == false then
			self:onTuPoEffect()
		else
			self:onZhuLingEffect()
		end
	end
end

function Lua_ZhuLingPanel:onTuPoEffect()
	if self.tupo_effect == nil then
		self.tupo_effect = UICreate.createUIEffect(self.arrow.mainContent, "/effects/scsEffects/gui_tupochenggong", "gui_tupochenggong", 0, 110);
	else
		self.tupo_effect.mainContent:SetActive(false);
		self.tupo_effect.mainContent:SetActive(true);
	end
	self.tupo_effect:SetRenderQueue(self.arrow, 5, 2, false);
	self.isFirstZhuLing = false
end

function Lua_ZhuLingPanel:onZhuLingEffect()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.arrow.mainContent, "/effects/scsEffects/gui_zhulingchenggong", "gui_zhulingchenggong", 0, 110);
	else
		self.effect.mainContent:SetActive(false);
		self.effect.mainContent:SetActive(true);
	end
	self.effect:SetRenderQueue(self.arrow, 5, 2, false);
	self.isFirstZhuLing = false;
end

function Lua_ZhuLingPanel:onZhuLingCellClick(data)
	self.data = data;
	self:createEquipItem();
end

function Lua_ZhuLingPanel:onUpdateView()
	self:setListData()
	local len = self.Arr:getSize()
	for i = 1, len do
		if self.data.equPart == self.Arr[i].equPart then
			self.data = self.Arr[i];
			break;
		end
	end
	self:createEquipItem();
end

function Lua_ZhuLingPanel:setListData()
	local _eq;
	self.Arr = Array();
	for i = 12, 1, -1 do
		_eq = DataCenter.equData:getEquByPart(i);
		if _eq ~= nil then
			local limitArr = Lua_ZhuLingUtil.getLimit(_eq.equPart)
			if _eq.order >= limitArr[1] and _eq.star >= limitArr[2] and _eq.color >= limitArr[3] then
				self.Arr:add(_eq);
			end
		end
	end
	self.zhuling_DragList:setLuaArrayData(self.Arr, false);
end 

function Lua_ZhuLingPanel:createEquipItem()
	if self.data == nil then
		return;
	end

	if self.leftEquipItem == nil then
		self.leftEquipItem = Lua_ToolImage.new(self.leftEquipBg.mainContent);
		self.leftEquipItem:setDepth(7);
		self.leftEquipItem:setLocation(0, 0, 0);
	end

	self.leftEquipItem.data = self.data
	if self.rightEquipItem == nil then
		self.rightEquipItem = Lua_ToolImage.new(self.rightEquipBg.mainContent);
		self.rightEquipItem:setDepth(7);
		self.rightEquipItem:setLocation(0, 0, 0);
	end

	local copyVo = self.data:clone()
	if self.data.zhuLingMax == false then
		copyVo.zhuLingIndex = self.data.zhuLingIndex + 1
		if copyVo.zhuLingIndex <= 0 then
			copyVo.zhuLingIndex = 1
		end
	end
	self.rightEquipItem.data = copyVo
	self.rightEquipItem:setEnable(true)

	if self.rankItem == nil then
		self.rankItem = Lua_ToolImage.new(self.mtBg.mainContent);
		self.rankItem:setDepth(7);
	end

	local rankIndex = self.data.mana_rank
	if self.data.mana_rank == 0 then
		rankIndex = 1
	end
	local rankItemId = Lua_ZhuLingUtil.getCostRank_item(self.data.equPart)
	local rankItemNum = Lua_ZhuLingUtil.getCostRank_cost(self.data.equPart, rankIndex + 1)
	local rankItem_hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(rankItemId);
	self.rankItem.data = Lua_ToolVo.new(rankItemId)
	self.rankItem:setEnable(true)
	self.rankItem:showNumLimit(rankItem_hadCount, rankItemNum, 2)

	if self.levelItem == nil then
		self.levelItem = Lua_ToolImage.new(self.mtBg.mainContent);
		self.levelItem:setDepth(7);
	end
	self.levelItem:setEnable(true);

	local levelItemId = Lua_ZhuLingUtil.getCostLevel_item(self.data.equPart);
	local mana_rank = self.data.mana_rank;
	local mana_level = self.data.mana_level + 1;
	if self.data.mana_rank == 0 then
		mana_rank = 1;
	else
		mana_rank = self.data.mana_rank
	end

	if self.data.mana_level == 2 then
		mana_rank = self.data.mana_rank + 1;
		mana_level = 0;
	end

	if self.data.mana_level == 0 and self.data.mana_rank == 0 then
		mana_rank = 1;
		mana_level = 0;
	end

	local levelItemNum = Lua_ZhuLingUtil.getCostLevel_cost(self.data.equPart, mana_rank, mana_level + 1);
	local levelItem_hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(levelItemId);
	self.levelItem.data = Lua_ToolVo.new(levelItemId);
	self.levelItem:showNumLimit(levelItem_hadCount, levelItemNum, 2);
	-- 初始注灵界面
	self.isFirstZhuLing = false;

	if levelItem_hadCount < levelItemNum then
		self.itemOutPutId = levelItemId;
	else
		self.itemOutPutId = 0;
	end

	if self.data.mana_level == 0 and self.data.mana_rank == 0 then
		self.rankItem:setLocation(0, 0, 0);
		self.isFirstZhuLing = true
		self.rankItem:setEnable(false)

		-- 突破界面
		self.levelItem:setLocation(0, 0, 0);
		self.mtBg:setAltas("feature_atlas", "ui_duanzao_icon_dzk");
		self.mtBg:SetDimensions(112, 112);

		self.leftEquipBg:setLocation(-108, 146, 0);
		self.plus:setLocation(1, 148, 0);
		self.mtBg:setLocation(106, 147, 0);
		self.denghao:setLocation(211, 147, 0);
		self.rightEquipBg:setLocation(322, 148, 0);
		self.suo:setLocation(322, 148, 0);
	elseif self.data.mana_level == 2 and self.data.mana_rank ~= 0 then
		self.rankItem:setEnable(true)
		self.rankItem:setLocation(-47, 0, 0);
		self.levelItem:setLocation(47, 0, 0);

		-- 注灵界面
		self.mtBg:setAltas("common_atlas_2", "ui_common_tips_bg");
		self.mtBg:SetDimensions(255, 135);

		self.leftEquipBg:setLocation(-148, 146, 0);
		self.plus:setLocation(-49, 148, 0);
		self.mtBg:setLocation(102, 147, 0);
		self.denghao:setLocation(251, 147, 0);
		self.rightEquipBg:setLocation(352, 148, 0);
		self.suo:setLocation(352, 148, 0);

		if rankItem_hadCount < rankItemNum then
			self.itemOutPutId = rankItemId
		end
	else
		self.rankItem:setLocation(0, 0, 0);
		self.rankItem:setEnable(false)
		self.levelItem:setLocation(0, 0, 0);
		self.mtBg:setAltas("feature_atlas", "ui_duanzao_icon_dzk");
		self.mtBg:SetDimensions(112, 112);

		self.leftEquipBg:setLocation(-108, 146, 0);
		self.plus:setLocation(1, 148, 0);
		self.mtBg:setLocation(106, 147, 0);
		self.denghao:setLocation(211, 147, 0);
		self.rightEquipBg:setLocation(322, 148, 0);
		self.suo:setLocation(322, 148, 0);
	end

	self:showAttr()
	self:showSkill(1, self.skillListLeft)
	self:showSkill(2, self.skillListRight)
	self:onChangeBtn()
	self:checkMax()
end

function Lua_ZhuLingPanel:checkMax()
	if self.data.zhuLingMax == true then
		self.clickBtn:setBtnEnable(false)
		self.rankItem:setEnable(false)
		self.levelItem:setEnable(false)
		self.rightEquipItem:setEnable(false)
	else
		self.clickBtn:setBtnEnable(true)
	end
	self.redDot:setEnable(self.data.zhuLingRedDot)
end

function Lua_ZhuLingPanel:onChangeBtn()
	if self.data.mana_level == 2 and self.data.mana_rank ~= 0 then
		self.clickBtn.label = LanUtil.getValue(120574)
	else
		self.clickBtn.label = LanUtil.getValue(120570)
	end
end

function Lua_ZhuLingPanel:showAttr()
	local arr = Array()
	if self.data.zhuLingName == "" then
		arr:add(LanUtil.getValue(120572));
	else
		local attrArr = self.data.zhuLingAttr;
		local len = attrArr:getSize();
		local str = LanUtil.formateStr(LanUtil.getValue(120573), tostring(self.data.zhuLingName));
		arr:add(str);
		for i = 1, len do
			if attrArr[i].isPercent == true then
				arr:add("[85A8BE]" .. attrArr[i].attrName .. "：[85A8BE]" .. attrArr[i].value .. "%")
			else
				arr:add("[85A8BE]" .. attrArr[i].attrName .. "：[85A8BE]" .. attrArr[i].value)
			end
		end
	end
	self.left_DragList:setLuaArrayData(arr, false)

	local index = self.data.zhuLingIndex + 1;
	if index <= 0 then
		index = 1;
	end

	local arr2 = Array();
	local zhuLingName = "[00E125]" .. Lua_ZhuLingUtil.getZhuLingName(self.data.equPart, index);
	if zhuLingName == "" then
		arr2:add(LanUtil.getValue(120572));
	else
		local attrArr2 = Lua_ZhuLingUtil.getZhuLingPorpertyAttr(self.data.equPart, index);
		local len2 = attrArr2:getSize();
		local str = LanUtil.formateStr(LanUtil.getValue(120573), tostring(zhuLingName));
		arr2:add(str);
		for i = 1, len2 do
			if attrArr2[i].isPercent == true then
				arr2:add("[85A8BE]" .. attrArr2[i].attrName .. "：[00E125]" .. attrArr2[i].value .. "%");
			else
				arr2:add("[85A8BE]" .. attrArr2[i].attrName .. "：[00E125]" .. attrArr2[i].value);
			end
		end
	end
	self.right_DragList:setLuaArrayData(arr2, false);
end

function Lua_ZhuLingPanel:showSkill(value, skillList)
	local offsetPos = 242;
	local index = 0;
	if value == 1 then
		offsetPos = -158;
		index = self.data.zhuLingIndex;
	elseif value == 2 then
		offsetPos = 242;
		index = self.data.zhuLingIndex + 1;
	end

	local tempSkillList = skillList;
	for i = 1, #skillList do
		if tempSkillList[i] ~= nil then
			tempSkillList[i]:dispose();
			tempSkillList[i] = nil;
		end
	end

	local skillItem;
	local skillArr = Lua_ZhuLingUtil.getZhuLingSkillArr(value, self.data.equPart, index);
	local skillLen = skillArr:getSize();
	for i = 1, skillLen do
		skillItem = Lua_SkillAnimalItem.new(self.content);
		skillItem:setDepth(5);
		skillItem:showLvlTxt(false);
		skillItem:setScale(0.7, 0.7);
		skillItem:setInfo(skillArr[i]);
		skillItem:setLocation(offsetPos +(i - 1) * 70, -163, 0);
		tempSkillList[i] = skillItem;
	end

	if value == 1 then
		self.qilingTips:setEnable(skillLen <= 0);
		self.skillListLeft = tempSkillList;
	else
		self.skillListRight = tempSkillList;
	end
end

function Lua_ZhuLingPanel:dispose()
	if self.zhuling_DragList ~= nil then
		self.zhuling_DragList:dispose();
		self.zhuling_DragList = nil;
	end
	if self.left_DragList ~= nil then
		self.left_DragList:dispose();
		self.left_DragList = nil;
	end
	if self.right_DragList ~= nil then
		self.right_DragList:dispose();
		self.right_DragList = nil;
	end
	if self.skillListLeft ~= nil then
		for i = 1, #self.skillListLeft do
			self.skillListLeft[i]:dispose();
		end
		self.skillListLeft = nil;
	end
	if self.skillListRight ~= nil then
		for i = 1, #self.skillListRight do
			self.skillListRight[i]:dispose();
		end
		self.skillListRight = nil;
	end

	self:superCall("dispose");
end